package jp.co.sra.jun.collections.linkedlist;

/**
 * JunSingleLink class
 * 
 *  @author    nisinaka
 *  @created   1998/11/09 (by nisinaka)
 *  @updated   2008/04/24 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSingleLink.java,v 9.9 2010/03/09 09:16:43 nisinaka Exp $
 */
public class JunSingleLink<E> extends JunAbstractLink<E, JunSingleLink<E>> {

	/**
	 * Create a new instance of JunSingleLink and initialize it with the Object.
	 * 
	 * @param anObject java.lang.Object
	 * @return jp.co.sra.jun.collections.linkedlist.JunSingleLink
	 * @category Instance creation
	 * @deprecated since Jun701, use the constructor.
	 */
	public static <E> JunSingleLink<E> Entity_(E anObject) {
		return new JunSingleLink<E>(anObject);
	}

	/**
	 * Create a new instance of JunSingleLink and initialize it with the Object and the Link.
	 * 
	 * @param anObject java.lang.Object
	 * @param aLink jp.co.sra.jun.collections.linkedlist.JunSingleLink
	 * @return jp.co.sra.jun.collections.linkedlist.JunSingleLink
	 * @category Instance creation
	 * @deprecated since Jun701, use the constructor.
	 */
	public static <E> JunSingleLink<E> Entity_next_(E anObject, JunSingleLink<E> aLink) {
		return new JunSingleLink<E>(anObject, aLink);
	}

	/**
	 * Create a new instance of JunSingleLink and initialize it.
	 *
	 * @param anObject java.lang.Object
	 * @param aLink jp.co.sra.jun.collections.linkedlist.JunSingleLink
	 * @category Instance creation
	 */
	public JunSingleLink(E anObject) {
		super(anObject);
	}

	/**
	 * Create a new instance of JunSingleLink and initialize it.
	 *
	 * @param anObject java.lang.Object
	 * @param aLink jp.co.sra.jun.collections.linkedlist.JunSingleLink
	 * @category Instance creation
	 */
	public JunSingleLink(E anObject, JunSingleLink<E> aLink) {
		super(anObject, aLink);
	}

}
