package jp.co.sra.jun.collections.sequences;

/**
 * JunLinearEquationsTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/10/30 (by nisinaka)
 *  @updated   2008/04/24 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLinearEquationsTestExamples.java,v 9.9 2010/03/09 09:16:43 nisinaka Exp $
 */
public class JunLinearEquationsTestExamples extends jp.co.sra.jun.system.support.JunTestExamples {

	/**
	 * Example0:
	 * 
	 * @return boolean
	 */
	public static boolean Example0() {
		double[] elements = { 1, -1, 0, 1, 1, 2, 4, -17, 2, -1, 1, -3 };
		JunLinearEquations aMatrix = new JunLinearEquations(3, 4, elements);
		aMatrix.solve();
		System.out.println(aMatrix.printString());

		return (aMatrix._at(0, 0) == 0) && (aMatrix._at(0, 1) == 1) && (aMatrix._at(0, 2) == 0) && (aMatrix._at(0, 3) == -2) && (aMatrix._at(1, 0) == 0) && (aMatrix._at(1, 1) == 0) && (aMatrix._at(1, 2) == 1) && (aMatrix._at(1, 3) == -3)
				&& (aMatrix._at(2, 0) == 1) && (aMatrix._at(2, 1) == 0) && (aMatrix._at(2, 2) == 0) && (aMatrix._at(2, 3) == -1);
	}

	/**
	 * Example1:
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		double[] elements = { 1, 3, 5, 7, 11, 13, 17, 19, 29, 31, 37, 41 };
		JunLinearEquations aMatrix = new JunLinearEquations(3, 4, elements);
		aMatrix.solve();
		System.out.println(aMatrix.printString());

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		double[] elements = { 1, 2, 3, 4, 5, 6, 1, 1, 1 };
		JunLinearEquations aMatrix = new JunLinearEquations(3, 3, elements);
		aMatrix.solve();
		System.out.println(aMatrix.printString());

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunLinearEquationsTestExamples();
	}

}
