package jp.co.sra.jun.csg.atoms;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;

/**
 * JunBlockCSG class
 * 
 *  @author    nisinaka
 *  @created   1998/10/18 (by nisinaka)
 *  @updated   2008/04/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBlockCSG.java,v 9.9 2010/03/09 09:16:46 nisinaka Exp $
 */
public class JunBlockCSG extends jp.co.sra.jun.csg.abstracts.JunCSG {

	protected StBlockClosure1<Double, Jun3dPoint> block;

	/**
	 * Create a new instance of JunBlockCSG.
	 * 
	 * @param aBlock jp.co.sra.smalltalk.StBlockClosure
	 */
	public JunBlockCSG(StBlockClosure1<Double, Jun3dPoint> aBlock) {
		this.setBlock_(aBlock);
	}

	/**
	 * Create a new instance of JunBlockCSG.
	 * 
	 * @param aBlock jp.co.sra.smalltalk.StBlockClosure
	 * 
	 * @return jp.co.sra.jun.csg.atoms.JunBlockCSG
	 */
	public static JunBlockCSG On_(StBlockClosure1<Double, Jun3dPoint> aBlock) {
		return new JunBlockCSG(aBlock);
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return block.value(aJun3dPoint);
	}

	/**
	 * Set the block closure.
	 * 
	 * @param aBlock jp.co.sra.smalltalk.StBlockClosure
	 */
	protected void setBlock_(StBlockClosure1<Double, Jun3dPoint> aBlock) {
		block = aBlock;
	}

}
