package jp.co.sra.jun.csg.compound;

import jp.co.sra.jun.csg.abstracts.JunBinaryCSG;
import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.solid.abstracts.JunSolidModel;

/**
 * JunCSGUnion class
 * 
 *  @author    nisinaka
 *  @created   1998/10/18 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCSGUnion.java,v 9.8 2010/03/09 09:16:46 nisinaka Exp $
 */
public class JunCSGUnion extends JunBinaryCSG {

	/**
	 * Create a new instance of JunCSGUnion.
	 * 
	 * @param aSolid1 jp.co.sra.jun.solid.abstracts.JunSolid
	 * @param aSolid2 jp.co.sra.jun.solid.abstracts.JunSolid
	 */
	public JunCSGUnion(JunSolidModel aSolid1, JunSolidModel aSolid2) {
		super(aSolid1, aSolid2);
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * 
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return Math.max(solid1.valueAt_(aJun3dPoint), solid2.valueAt_(aJun3dPoint));
	}
}
