package jp.co.sra.jun.delaunay.twoD;

/**
 * Jun2dDelaunayBoundaryVertex class
 * 
 *  @author    Ryouichi Matsuda
 *  @created   2002/01/14 (by Ryouichi Matsuda)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: Jun2dDelaunayBoundaryVertex.java,v 9.9 2010/03/09 09:16:47 nisinaka Exp $
 */
public class Jun2dDelaunayBoundaryVertex extends Jun2dDelaunayVertex {

	/**
	 * Create a new instance of <code>Jun2dDelaunayBoundaryVertex</code> and initialize it.
	 * 
	 * @param x double
	 * @param y double
	 * @category Instance creation
	 */
	public Jun2dDelaunayBoundaryVertex(double x, double y) {
		super(x, y);
	}

	/**
	 * Create a new instance of <code>Jun2dDelaunayBoundaryVertex</code> and initialize it.
	 * 
	 * @param x double
	 * @param y double
	 * @param z double
	 * @category Instance creation
	 */
	public Jun2dDelaunayBoundaryVertex(double x, double y, double z) {
		super(x, y, z);
	}

	/**
	 * Answer true if the receiver is a boundary vertex, otherwise false.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.delaunay.twoD.Jun2dDelaunayVertex#isBoundaryVertex()
	 * @category testing
	 */
	public boolean isBoundaryVertex() {
		return true;
	}

}
