package jp.co.sra.jun.geometry.abstracts;

import jp.co.sra.jun.geometry.curves.JunNurbsCurve;
import jp.co.sra.jun.goodies.lisp.JunLispList;

import jp.co.sra.smalltalk.SmalltalkException;

/**
 * JunCurve class
 * 
 *  @author    nisinaka
 *  @created   1998/09/29 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun508 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCurve.java,v 9.9 2010/03/09 09:16:49 nisinaka Exp $
 */
public abstract class JunCurve extends JunGeometry {
	/**
	 * Create a new instance of <code>JunCurve</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunCurve() {
		super();
	}

	/**
	 * Create a new instance of <code>JunCurve</code> and initialize it.
	 * 
	 * @param aList jp.co.sra.jun.goodies.lisp.JunLispList
	 * @category Instance creation
	 */
	public JunCurve(JunLispList aList) {
		super(aList);
	}

	/**
	 * Convert the receiver as a nurbs curve.
	 * 
	 * @return JunNurbsCurve
	 * @category converting
	 */
	public JunNurbsCurve asNurbsCurve() {
		throw SmalltalkException.SubclassResponsibility();
	}

	/**
	 * Answer true if this is a kind of Curve geometry object, otherwise false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isCurve() {
		return true;
	}
}
