package jp.co.sra.jun.geometry.abstracts;

/**
 * JunSolid class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2004/10/18 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun582 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSolid.java,v 9.8 2010/03/09 09:16:49 nisinaka Exp $
 */
public abstract class JunSolid extends JunGeometry {
	/**
	 * Answer true if the receiver is a 3d geometry element, otherwise
	 * false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean is3d() {
		return true;
	}

	/**
	 * Answer true if this is a kind of Solid geometry object, otherwise
	 * false.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isSolid() {
		return true;
	}
}
