package jp.co.sra.jun.geometry.abstracts;

import jp.co.sra.jun.goodies.lisp.JunLispConverter;
import jp.co.sra.jun.goodies.lisp.JunLispList;

/**
 * JunSurface class
 * 
 *  @author    nisinaka
 *  @created   1998/09/29 (by nisinaka)
 *  @updated   2009/03/18 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun721 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSurface.java,v 9.10 2010/03/09 09:16:49 nisinaka Exp $
 */
public abstract class JunSurface extends JunGeometry {

	/**
	 * Create a new instance of <code>JunSurface</code> from the specified lisp list.
	 * 
	 * @return jp.co.sra.jun.geometry.abstracts.JunSurface
	 * @param aList jp.co.sra.jun.goodies.lisp.JunLispList
	 * @category Lisp support
	 */
	public static JunSurface FromLispList(JunLispList aList) {
		return (JunSurface) JunLispConverter.Convert(aList);
	}

	/**
	 * Create a new instance of <code>JunSurface</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunSurface() {
		super();
	}

	/**
	 * Create a new instance of <code>JunSurface</code> and initialize it.
	 * 
	 * @param aList jp.co.sra.jun.goodies.lisp.JunLispList
	 * @category Instance creation
	 */
	public JunSurface(JunLispList aList) {
		super(aList);
	}

	/**
	 * Answer <code>true</code> if this is a kind of Surface geometry object, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @category testing
	 */
	@Override
	public boolean isSurface() {
		return true;
	}

}
