package jp.co.sra.jun.geometry.pluralities;

import java.awt.Color;

import jp.co.sra.jun.geometry.basic.Jun2dPoint;
import jp.co.sra.jun.geometry.boundaries.Jun2dBoundingBall;
import jp.co.sra.jun.opengl.objects.JunOpenGL3dCompoundObject;
import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * Jun2dBoundingBallsTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/05/30 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun667 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: Jun2dBoundingBallsTestExamples.java,v 9.8 2010/03/09 09:16:54 nisinaka Exp $
 */
public class Jun2dBoundingBallsTestExamples extends JunTestExamples {
	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		Jun2dBoundingBall boundingBall = new Jun2dPoint(0, 0).ball_(2);
		Jun2dBoundingBoxes detailedBoundingBoxes = boundingBall.detailedBoundingBoxes();
		Jun2dBoundingBalls detailedBoundingBalls = boundingBall.detailedBoundingBalls();

		JunOpenGL3dCompoundObject compoundObject = new JunOpenGL3dCompoundObject();
		compoundObject.add_(boundingBall.asJunOpenGL3dObjectColor_alpha_(Color.cyan, 0.5f));
		compoundObject.add_(detailedBoundingBoxes.asJunOpenGL3dObjectColor_alpha_(Color.magenta, 0.25f));
		compoundObject.add_(detailedBoundingBalls.asJunOpenGL3dObjectColor_alpha_(Color.yellow, 0.25f));
		compoundObject.add_(JunOpenGL3dObject.Axes().scaledBy_(4));
		compoundObject.show().selectAll();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new Jun2dBoundingBallsTestExamples();
	}
}
