package jp.co.sra.jun.geometry.pluralities;

import java.util.Collection;

import jp.co.sra.jun.geometry.boundaries.JunBoundingBall;
import jp.co.sra.jun.goodies.lisp.JunLispList;

/**
 * JunBoundingBalls class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/05/30 (by m-asada)
 *  @updated   2008/04/16 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun667 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBoundingBalls.java,v 9.10 2010/03/09 09:16:54 nisinaka Exp $
 */
public abstract class JunBoundingBalls<G extends JunBoundingBall> extends JunBoundingObjects<G> {
	/**
	 * Create a new instance of <code>JunBoundingBalls</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunBoundingBalls() {
		super();
	}

	/**
	 * Create a new instance of <code>JunBoundingBalls</code> and initialize it.
	 * 
	 * @param aList jp.co.sra.jun.goodies.lisp.JunLispList
	 * @category Instance creation
	 */
	public JunBoundingBalls(JunLispList aList) {
		super(aList);
	}

	/**
	 * Answer my current bounding balls.
	 * 
	 * @return jp.co.sra.jun.geometry.boundaries.JunBoundingBall[]
	 * @category accessing
	 */
	public G[] boundingBalls() {
		return this.geometries();
	}

	/**
	 * Set my new bounding balls.
	 * 
	 * @param boundingBallCollection java.util.Collection
	 * @category accessing
	 */
	public void boundingBalls_(Collection<G> boundingBallCollection) {
		this.boundingObjects_(boundingBallCollection);
	}

	/**
	 * Answer true if the receiver is a bounding balls, otherwise false.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.geometry.abstracts.JunGeometry#isBoundingBalls()
	 * @category testing
	 */
	public boolean isBoundingBalls() {
		return true;
	}

}
