package jp.co.sra.jun.geometry.solid;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunCircularConeTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/06/29 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun610 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCircularConeTestExamples.java,v 9.8 2010/03/09 09:16:54 nisinaka Exp $
 */
public class JunCircularConeTestExamples extends JunTestExamples {
	/**
	 * Example1: Show a cone as <code>JunOpenGL3dObject</code>.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunCircularCone aCircularCone = new JunCircularCone(new Jun3dPoint(1, 1, 1), 1, 2);
		System.out.println(aCircularCone.printString());
		System.out.println(aCircularCone.storeString());
		System.out.println("area: " + aCircularCone.area());
		System.out.println("volume:" + aCircularCone.volume());
		aCircularCone.asJunOpenGL3dObject().showWithUnitAxes();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunCircularConeTestExamples();
	}
}
