package jp.co.sra.jun.geometry.surfaces;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.goodies.lisp.JunLispList;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunSphereSurfaceTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2009/03/19 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun721 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSphereSurfaceTestExamples.java,v 9.6 2010/03/09 09:16:57 nisinaka Exp $
 */
public class JunSphereSurfaceTestExamples extends JunTestExamples {
	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunSphereSurface aSphereSurface = ExampleSphereSurface();
		JunLispList aList = aSphereSurface.toLispList();

		System.out.println(aSphereSurface.toString());
		System.out.println(aList.toString());
		System.out.println(new JunSphereSurface(aList).toString());

		return true;
	}

	/**
	 * Example: SphereSurface.
	 * 
	 * @return jp.co.sra.jun.geometry.surfaces.JunSphereSurface
	 * @category Examples
	 */
	public static JunSphereSurface ExampleSphereSurface() {
		return new JunSphereSurface(new Jun3dPoint(0, 0, 0), 1);
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunSphereSurfaceTestExamples();
	}
}
