package jp.co.sra.jun.goodies.animation;

import java.awt.Color;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunCartoonMovieView interface
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/02/05 (By Nobuto Matsubara)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2007/11/05 (by nisinaka)
 *  @updated   2008/05/27 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun519 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCartoonMovieView.java,v 9.9 2010/03/09 09:16:57 nisinaka Exp $
 */
public interface JunCartoonMovieView extends JunAbstractView {

	/**
	 * Answer my model as JunCartoonMovie.
	 * 
	 * @return jp.co.sra.jun.goodies.animation.JunCartoonMovie
	 * @category model accessing
	 */
	public JunCartoonMovie getCartoonMovie();

	/**
	 * Answer background color.
	 * 
	 * @return java.awt.Color
	 * @category visual properties
	 */
	public Color backgroundColor();

}
