package jp.co.sra.jun.goodies.calendar;

import java.util.Calendar;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.goodies.milliseconds.JunMillisecondModel;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunCalendarClockDateAndTimeTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   2008/06/09 (by Nobuto Matsubara)
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarClockDateAndTimeTestExamples.java,v 9.11 2010/03/09 09:16:58 nisinaka Exp $
 */
public class JunCalendarClockDateAndTimeTestExamples extends JunTestExamples {
	/**
	 * Example2: time stamp output for 10 seconds.
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		JunCalendarClockDateAndTime calendarClock = new JunCalendarClockDateAndTime();
		calendarClock.compute_(new StBlockClosure1<Void, Calendar>() {
			public Void value(Calendar cal) {
				int year = cal.get(Calendar.YEAR);
				int month = cal.get(Calendar.MONTH);
				int day = cal.get(Calendar.DATE);
				int hour = cal.get(Calendar.HOUR);
				int minute = cal.get(Calendar.MINUTE);
				int second = cal.get(Calendar.SECOND);
				int[] ampm = { 0, 12 };
				hour += ampm[cal.get(Calendar.AM_PM)];
				System.out.println((month + 1) + " " + day + "," + year + " " + hour + ":" + minute + ":" + second);
				return null;
			}
		});
		long endTime = calendarClock.nextMillisecondClockValue() + 10000;
		JunMillisecondModel time = new JunMillisecondModel();
		time.nowValue();
		while (time.milliseconds() < endTime) {
			time.nowValue();
		}
		calendarClock.release();
		return true;
	}

	/**
	 * Example1: Open a JunCalendarDateAndTime.
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarClockDateAndTime calendarClock = new JunCalendarClockDateAndTime();
		calendarClock.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(String args[]) {
		new JunCalendarClockDateAndTimeTestExamples();
	}
}
