package jp.co.sra.jun.goodies.calendar;

import java.util.Calendar;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.system.support.JunSystem;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunCalendarDateAndTimeDialogTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   2008/06/09 (by Nobuto Matsubara)
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateAndTimeDialogTestExamples.java,v 9.11 2010/03/09 09:16:59 nisinaka Exp $
 */
public class JunCalendarDateAndTimeDialogTestExamples extends JunTestExamples {
	/**
	 * Example1: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		JunCalendarDateAndTimeModel dateAndTime = JunCalendarDateAndTimeDialog.Request();
		System.out.println(dateAndTime);
		return true;
	}

	/**
	 * Example2: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		JunCalendarDateAndTimeModel answer = JunCalendarDateAndTimeDialog.Request_(JunSystem.$String("Select date and time."));
		if (answer != null) {
			System.out.println(answer);
		}
		return true;
	}

	/**
	 * Example3: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example3() {
		Calendar[] dateAndTime = { Calendar.getInstance(), Calendar.getInstance() };
		dateAndTime[0].add(Calendar.DATE, 7);
		dateAndTime[1].add(Calendar.SECOND, 60 * 60);
		JunCalendarDateAndTimeModel answer = JunCalendarDateAndTimeDialog.Request_initialDateAndTime_(JunSystem.$String("Select date and time."), dateAndTime);
		if (answer != null) {
			System.out.println(answer);
		}
		return true;
	}

	/**
	 * Example4: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example4() {
		Calendar[] dateAndTime = { Calendar.getInstance(), Calendar.getInstance() };
		dateAndTime[0].add(Calendar.DATE, 7);
		dateAndTime[1].add(Calendar.SECOND, 60 * 60);
		StBlockClosure1<Boolean, JunCalendarDateAndTimeModel> acceptBlock = new StBlockClosure1<Boolean, JunCalendarDateAndTimeModel>() {
			public Boolean value(JunCalendarDateAndTimeModel dateAndTimeModel) {
				System.out.println(JunSystem.$String("Accept button was pressed."));
				System.out.println("	" + dateAndTimeModel);
				return true;
			}
		};
		StBlockClosure1<Boolean, JunCalendarDateAndTimeModel> cancelBlock = new StBlockClosure1<Boolean, JunCalendarDateAndTimeModel>() {
			public Boolean value(JunCalendarDateAndTimeModel dateAndTimeModel) {
				System.out.println(JunSystem.$String("Cancel button was pressed."));
				System.out.println("	" + dateAndTimeModel);
				return true;
			}
		};
		JunCalendarDateAndTimeModel answer = JunCalendarDateAndTimeDialog.Request_initialDateAndTime_onAccept_onCancel_(JunSystem.$String("Select date and time."), dateAndTime, acceptBlock, cancelBlock);
		if (answer != null) {
			System.out.println(answer);
		}
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunCalendarDateAndTimeDialogTestExamples();
	}
}
