package jp.co.sra.jun.goodies.calendar;

import java.util.Calendar;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.system.support.JunSystem;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunCalendarDateDialogTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   2008/06/09 (by Nobuto Matsubara)
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateDialogTestExamples.java,v 9.11 2010/03/09 09:16:59 nisinaka Exp $
 */
public class JunCalendarDateDialogTestExamples extends JunTestExamples {
	/**
	 * Example1: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example1() {
		Calendar answer = JunCalendarDateDialog.Request();
		if (answer != null) {
			System.out.print(answer.get(Calendar.YEAR));
			System.out.print("." + answer.get(Calendar.MONTH));
			System.out.println("." + answer.get(Calendar.DATE));
		}
		return true;
	}

	/**
	 * Example2: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example2() {
		Calendar answer = JunCalendarDateDialog.Request_(JunSystem.$String("Select date."));
		if (answer != null) {
			System.out.print(answer.get(Calendar.YEAR));
			System.out.print("." + answer.get(Calendar.MONTH));
			System.out.println("." + answer.get(Calendar.DATE));
		}
		return true;
	}

	/**
	 * Example3: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example3() {
		Calendar date = Calendar.getInstance();
		date.add(Calendar.DATE, 100);
		Calendar answer = JunCalendarDateDialog.Request_initialDate_(JunSystem.$String("Select date."), date);
		if (answer != null) {
			System.out.print(answer.get(Calendar.YEAR));
			System.out.print("." + answer.get(Calendar.MONTH));
			System.out.println("." + answer.get(Calendar.DATE));
		}
		return true;
	}

	/**
	 * Example4: Call Request().
	 *
	 * @return boolean
	 */
	public static boolean Example4() {
		Calendar date = Calendar.getInstance();
		date.add(Calendar.DATE, 100);
		StBlockClosure1<Boolean, JunCalendarDateModel> acceptBlock = new StBlockClosure1<Boolean, JunCalendarDateModel>() {
			public Boolean value(JunCalendarDateModel dateModel) {
				System.out.println(JunSystem.$String("Accept button was pressed."));
				System.out.println("	" + dateModel);
				return true;
			}
		};
		StBlockClosure1<Boolean, JunCalendarDateModel> cancelBlock = new StBlockClosure1<Boolean, JunCalendarDateModel>() {
			public Boolean value(JunCalendarDateModel dateModel) {
				System.out.println(JunSystem.$String("Cancel button was pressed."));
				System.out.println("	" + dateModel);
				return true;
			}
		};
		Calendar answer = JunCalendarDateDialog.Request_initialDate_onAccept_onCancel_(JunSystem.$String("Select date."), date, acceptBlock, cancelBlock);
		if (answer != null) {
			System.out.print(answer.get(Calendar.YEAR));
			System.out.print("." + answer.get(Calendar.MONTH));
			System.out.println("." + answer.get(Calendar.DATE));
		}
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunCalendarDateDialogTestExamples();
	}
}
