package jp.co.sra.jun.goodies.calendar;

import java.awt.Color;
import java.awt.Graphics;
import java.util.Vector;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunCalendarDateView interface
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2008/06/09 (by Nobuto Matsubara)
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarDateView.java,v 9.10 2010/03/09 09:16:59 nisinaka Exp $
 */
public interface JunCalendarDateView extends JunAbstractView {

	public static final Color veryLightGray = new Color((float) 0.8, (float) 0.8, (float) 0.8);
	public static final Color veryDarkGray = new Color((float) 0.2, (float) 0.2, (float) 0.2);

	/**
	 * Return frames.
	 * @return java.util.Vector
	 * @category accessing
	 */
	public Vector<Object[]> frames();

	/**
	 * Paint.
	 * @param aGraphics Graphics
	 * @category displaying
	 */
	public void displayOn_(Graphics aGraphics);

}
