package jp.co.sra.jun.goodies.calendar;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewSwing;

/**
 * JunCalendarTimeDialogViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarTimeDialogViewSwing.java,v 9.9 2010/03/09 09:16:59 nisinaka Exp $
 */
public class JunCalendarTimeDialogViewSwing extends JunAbstractDialogViewSwing implements JunCalendarTimeDialogView {

	protected JunCalendarTimeViewSwing calendarTimeView;

	/**
	 * Create a new instance of <code>JunCalendarTimeDialogViewSwing</code> and initialize it.
	 * 
	 * @param newCalendarTimeDialog JunCalendarTimeDialog
	 * @category Instance creation
	 */
	public JunCalendarTimeDialogViewSwing(JunCalendarTimeDialog newCalendarTimeDialog) {
		super(newCalendarTimeDialog);
	}

	/**
	 * Answer the default dialog.
	 *
	 * @return java.awt.Dialog
	 * @category accessing
	 */
	public Dialog defaultDialog() {
		Dialog aDialog = new Dialog(new Frame(), this.getCalendarTimeDialog().windowTitle(), true);
		aDialog.add(this);
		aDialog.pack();
		return aDialog;
	}

	/**
	 * Answer my model as a JunCalendarTimeDialog.
	 * 
	 * @return JunCalendarTimeDialog
	 * @category accessing
	 */
	public JunCalendarTimeDialog getCalendarTimeDialog() {
		return (JunCalendarTimeDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.calendarTimeView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -102, 1f, -1));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		defaultButton = this.acceptButton();
		this.setPreferredSize(new Dimension(250, 200));
	}

	/**
	 * Answer my calendar date view.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	protected JunCalendarTimeViewSwing calendarTimeView() {
		if (calendarTimeView == null) {
			calendarTimeView = new JunCalendarTimeViewSwing(this.getCalendarTimeDialog().calendarTimeModel());
		}
		return calendarTimeView;
	}

}
