package jp.co.sra.jun.goodies.calendar;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Frame;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewSwing;

/**
 * JunCalendarTimeIntervalDialogViewSwing class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2003/10/06 (by Nobuto Matsubara)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun472 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunCalendarTimeIntervalDialogViewSwing.java,v 9.9 2010/03/09 09:16:59 nisinaka Exp $
 */
public class JunCalendarTimeIntervalDialogViewSwing extends JunAbstractDialogViewSwing implements JunCalendarTimeIntervalDialogView {

	protected JunCalendarTimeViewSwing fromView;
	protected JunCalendarTimeViewSwing toView;

	/**
	 * Create a new instance of <code>JunCalendarTimeIntervalDialogViewSwing</code> and initialize it.
	 * 
	 * @param newCalendarTimeIntervalDialog JunCalendarTimeIntervalDialog
	 * @category Instance creation
	 */
	public JunCalendarTimeIntervalDialogViewSwing(JunCalendarTimeIntervalDialog newCalendarTimeIntervalDialog) {
		super(newCalendarTimeIntervalDialog);
	}

	/**
	 * Answer the default dialog.
	 *
	 * @return java.awt.Dialog
	 * @category accessing
	 */
	public Dialog defaultDialog() {
		Dialog aDialog = new Dialog(new Frame(), this.getCalendarTimeIntervalDialog().windowTitle(), true);
		aDialog.add(this);
		aDialog.pack();
		return aDialog;
	}

	/**
	 * Answer my model as a JunCalendarTimeIntervalDialog.
	 * 
	 * @return JunCalendarTimeIntervalDialog
	 * @category accessing
	 */
	public JunCalendarTimeIntervalDialog getCalendarTimeIntervalDialog() {
		return (JunCalendarTimeIntervalDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fromView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -102, 0.5f, -1));
		this.add(this.toView(), WindowSpecLayout.Position(0f, 1, 0.5f, 1, 1f, -102, 1f, -1));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		defaultButton = this.acceptButton();
		this.setPreferredSize(new Dimension(250, 400));
	}

	/**
	 * Answer from time view.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	protected JunCalendarTimeViewSwing fromView() {
		if (fromView == null) {
			fromView = new JunCalendarTimeViewSwing(this.getCalendarTimeIntervalDialog().calendarTimeIntervalModel().fromCalendarTimeModel());
		}
		return fromView;
	}

	/**
	 * Answer to time view.
	 *
	 * @return JunCalendarTimeViewSwing
	 * @category accessing
	 */
	protected JunCalendarTimeViewSwing toView() {
		if (toView == null) {
			toView = new JunCalendarTimeViewSwing(this.getCalendarTimeIntervalDialog().calendarTimeIntervalModel().toCalendarTimeModel());
		}
		return toView;
	}

}
