package jp.co.sra.jun.goodies.colors;

import java.awt.Dimension;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewSwing;

/**
 * JunColorBarDialogViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2004/06/14 (by nisinaka)
 *  @updated   2008/05/14 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun492 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunColorBarDialogViewSwing.java,v 9.9 2010/03/09 09:17:00 nisinaka Exp $
 */
public class JunColorBarDialogViewSwing extends JunAbstractDialogViewSwing implements JunColorBarDialogView {

	protected JunColorBarViewSwing colorBarView;

	/**
	 * Create a new instance of JunColorBarDialogViewSwing and initialize it.
	 * 
	 * @param aColorBarDialog jp.co.sra.jun.goodies.colors.JunColorBarDialog
	 * @category Instance creation
	 */
	public JunColorBarDialogViewSwing(JunColorBarDialog aColorBarDialog) {
		super(aColorBarDialog);
	}

	/**
	 * Answer my model as JunColorBarDialog.
	 * 
	 * @return jp.co.sra.jun.goodies.colors.JunColorBarDialog
	 * @see jp.co.sra.jun.goodies.colors.JunColorBarDialogView#getColorBarDialog()
	 * @category model accessing
	 */
	public JunColorBarDialog getColorBarDialog() {
		return (JunColorBarDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewPanel#buildComponent()
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.colorBarView(), WindowSpecLayout.Position(0f, 0, 0f, 0, 1f, 0, 1f, -50));
		this.add(this.acceptButton(), WindowSpecLayout.Position(0.25f, -44, 1f, -40, 0.25f, 44, 1f, -8));
		this.add(this.cancelButton(), WindowSpecLayout.Position(0.75f, -44, 1f, -40, 0.75f, 44, 1f, -8));
		this.setPreferredSize(new Dimension(238, 100));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my color bar view.
	 * 
	 * @return jp.co.sra.jun.goodies.colors.JunColorBarViewSwing
	 * @category user interface
	 */
	protected JunColorBarViewSwing colorBarView() {
		if (colorBarView == null) {
			colorBarView = new JunColorBarViewSwing(this.getColorBarDialog().colorBarModel());
		}
		return colorBarView;
	}

}
