package jp.co.sra.jun.goodies.display;

import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;

import jp.co.sra.smalltalk.StView;

import jp.co.sra.jun.system.framework.JunAbstractController;

/**
 * JunDisplayController class
 * 
 *  @author    nisinaka
 *  @created   2002/01/09 (by nisinaka)
 *  @updated   2003/03/19 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun473 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDisplayController.java,v 9.8 2010/03/09 09:17:01 nisinaka Exp $
 */
public class JunDisplayController extends JunAbstractController implements MouseListener, MouseMotionListener {

	/**
	 * Remove references to objects that may refer to the receiver. 
	 * Remove the listeners of the view here as well.
	 * 
	 * @see jp.co.sra.smalltalk.StObject#release()
	 * @see jp.co.sra.smalltalk.StController#buildListener(jp.co.sra.smalltalk.StView)
	 * @category initialize-release
	 */
	public void release() {
		super.release();
		this.getDisplayView().canvasComponent().removeMouseListener(this);
	}

	/**
	 * Add myself as a listener of the view.
	 * 
	 * @param aView jp.co.sra.smalltalk.StView
	 * @see jp.co.sra.smalltalk.StController#buildListener(jp.co.sra.smalltalk.StView)
	 * @see jp.co.sra.smalltalk.StController#release()
	 * @category initialize-release
	 */
	protected void buildListener(StView aView) {
		this.getDisplayView().canvasComponent().addMouseListener(this);
	}

	/**
	 * Answer my view as JunDisplayView.
	 * 
	 * @return jp.co.sra.jun.goodies.display.JunDisplayView
	 * @category view accessing
	 */
	public JunDisplayView getDisplayView() {
		return (JunDisplayView) this.view();
	}

}
