package jp.co.sra.jun.goodies.drawing;

import jp.co.sra.jun.goodies.drawing.map.JunDrawingMapView;
import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunDrawingView interface
 * 
 *  @author    m-asada
 *  @created   2005/06/07 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDrawingView.java,v 9.8 2010/03/09 09:17:03 nisinaka Exp $
 */
public interface JunDrawingView extends JunAbstractView {
	/**
	 * Answer the receiver's model as JunDrawing.
	 * 
	 * @return jp.co.sra.jun.goodies.drawing.JunDrawing
	 * @category model accessing
	 */
	public JunDrawing getDrawingModel();

	/**
	 * Answer the drawing map view.
	 * 
	 * @return jp.co.sra.jun.goodies.drawing.map.JunDrawingMapView
	 * @category interface opening
	 */
	public JunDrawingMapView drawingMapView();
}
