package jp.co.sra.jun.goodies.drawing.properties;

import jp.co.sra.jun.goodies.drawing.element.JunDrawingElement;
import jp.co.sra.jun.goodies.drawing.element.JunPathElement;
import jp.co.sra.jun.goodies.drawing.map.JunDrawingMap;
import jp.co.sra.jun.goodies.drawing.map.JunDrawingMapModelTestExamples;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunPathPropertiesModelTestExamples class
 * 
 *  @author    m-asada
 *  @created   2005/05/23 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPathPropertiesModelTestExamples.java,v 9.8 2010/03/09 09:17:05 nisinaka Exp $
 */
public class JunPathPropertiesModelTestExamples extends JunTestExamples {
	/**
	 * Example1: Open a JunRectangularShapePropertiesModel.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunDrawingMap aMap = JunDrawingMapModelTestExamples.MapExample1();
		JunDrawingElement[] elements = aMap._componentElements();
		for (int i = elements.length - 1; i >= 0; i--) {
			if (elements[i] instanceof JunPathElement) {
				JunPathPropertiesModel aModel = new JunPathPropertiesModel((JunPathElement) elements[i]);
				aModel.open();
				break;
			}
		}

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunPathPropertiesModelTestExamples();
	}
}
