package jp.co.sra.jun.goodies.drawing.properties;

import jp.co.sra.jun.goodies.texteditor.JunTextEditorView;
import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunTextPropertiesView interface
 * 
 *  @author    m-asada
 *  @created   2005/05/11 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTextPropertiesView.java,v 9.8 2010/03/09 09:17:05 nisinaka Exp $
 */
public interface JunTextPropertiesView extends JunAbstractView {
	/**
	 * Answer the model as JunTextPropertiesModel.
	 * 
	 * @return jp.co.sra.jun.goodies.drawing.properties.JunTextPropertiesModel
	 * @category model accessing
	 */
	public JunTextPropertiesModel getModel();

	/**
	 * Answer the text editor view.
	 * 
	 * @return jp.co.sra.jun.goodies.texteditor.JunTextEditorViewAwt
	 * @category interface opening
	 */
	public JunTextEditorView textEditorView();

	/**
	 * Answer the text in text area.
	 * 
	 * @return java.lang.String
	 * @category text accessing
	 */
	public String getText();
}
