package jp.co.sra.jun.goodies.dump;

import java.io.File;

import jp.co.sra.jun.graphics.navigator.JunFileRequesterDialog;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunDumpModelTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2003/03/18 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun629 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDumpModelTestExamples.java,v 9.9 2010/03/09 09:17:06 nisinaka Exp $
 */
public class JunDumpModelTestExamples extends JunTestExamples {
	/**
	 * Example1: Open a dump model.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunDumpModel dumpModel = new JunDumpModel(new byte[] {
				(byte) 71,
				(byte) 73,
				(byte) 70,
				(byte) 56,
				(byte) 55,
				(byte) 97,
				(byte) 16,
				(byte) 0,
				(byte) 16,
				(byte) 0,
				(byte) 247,
				(byte) 0,
				(byte) 0,
				(byte) 255,
				(byte) 255,
				(byte) 255,
				(byte) 255,
				(byte) 255,
				(byte) 204,
				(byte) 255,
				(byte) 255,
				(byte) 153,
				(byte) 255,
				(byte) 255,
				(byte) 102,
				(byte) 255,
				(byte) 255,
				(byte) 51,
				(byte) 255,
				(byte) 255,
				(byte) 0,
				(byte) 255,
				(byte) 204,
				(byte) 255,
				(byte) 255,
				(byte) 204,
				(byte) 204,
				(byte) 255,
				(byte) 204,
				(byte) 153,
				(byte) 255,
				(byte) 204,
				(byte) 102,
				(byte) 255,
				(byte) 204,
				(byte) 51,
				(byte) 255,
				(byte) 204,
				(byte) 0,
				(byte) 255,
				(byte) 153,
				(byte) 255,
				(byte) 255,
				(byte) 153,
				(byte) 204,
				(byte) 255,
				(byte) 153,
				(byte) 153,
				(byte) 255,
				(byte) 153,
				(byte) 102,
				(byte) 255,
				(byte) 153,
				(byte) 51,
				(byte) 255,
				(byte) 153,
				(byte) 0,
				(byte) 255,
				(byte) 102,
				(byte) 255,
				(byte) 255,
				(byte) 102,
				(byte) 204,
				(byte) 255,
				(byte) 102,
				(byte) 153,
				(byte) 255,
				(byte) 102,
				(byte) 102,
				(byte) 255,
				(byte) 102,
				(byte) 51,
				(byte) 255,
				(byte) 102,
				(byte) 0,
				(byte) 255,
				(byte) 51,
				(byte) 255,
				(byte) 255,
				(byte) 51,
				(byte) 204,
				(byte) 255,
				(byte) 51,
				(byte) 153,
				(byte) 255,
				(byte) 51,
				(byte) 102,
				(byte) 255,
				(byte) 51,
				(byte) 51,
				(byte) 255,
				(byte) 51,
				(byte) 0,
				(byte) 255,
				(byte) 0,
				(byte) 255,
				(byte) 255,
				(byte) 0,
				(byte) 204,
				(byte) 255,
				(byte) 0,
				(byte) 153,
				(byte) 255,
				(byte) 0,
				(byte) 102,
				(byte) 255,
				(byte) 0,
				(byte) 51,
				(byte) 255,
				(byte) 0,
				(byte) 0,
				(byte) 204,
				(byte) 255,
				(byte) 255,
				(byte) 204,
				(byte) 255,
				(byte) 204,
				(byte) 204,
				(byte) 255,
				(byte) 153,
				(byte) 204,
				(byte) 255,
				(byte) 102,
				(byte) 204,
				(byte) 255,
				(byte) 51,
				(byte) 204,
				(byte) 255,
				(byte) 0,
				(byte) 204,
				(byte) 204,
				(byte) 255,
				(byte) 204,
				(byte) 204,
				(byte) 204,
				(byte) 204,
				(byte) 204,
				(byte) 153,
				(byte) 204,
				(byte) 204,
				(byte) 102,
				(byte) 204,
				(byte) 204,
				(byte) 51,
				(byte) 204,
				(byte) 204,
				(byte) 0,
				(byte) 204,
				(byte) 153,
				(byte) 255,
				(byte) 204,
				(byte) 153,
				(byte) 204,
				(byte) 204,
				(byte) 153,
				(byte) 153,
				(byte) 204,
				(byte) 153,
				(byte) 102,
				(byte) 204,
				(byte) 153,
				(byte) 51,
				(byte) 204,
				(byte) 153,
				(byte) 0,
				(byte) 204,
				(byte) 102,
				(byte) 255,
				(byte) 204,
				(byte) 102,
				(byte) 204,
				(byte) 204,
				(byte) 102,
				(byte) 153,
				(byte) 204,
				(byte) 102,
				(byte) 102,
				(byte) 204,
				(byte) 102,
				(byte) 51,
				(byte) 204,
				(byte) 102,
				(byte) 0,
				(byte) 204,
				(byte) 51,
				(byte) 255,
				(byte) 204,
				(byte) 51,
				(byte) 204,
				(byte) 204,
				(byte) 51,
				(byte) 153,
				(byte) 204,
				(byte) 51,
				(byte) 102,
				(byte) 204,
				(byte) 51,
				(byte) 51,
				(byte) 204,
				(byte) 51,
				(byte) 0,
				(byte) 204,
				(byte) 0,
				(byte) 255,
				(byte) 204,
				(byte) 0,
				(byte) 204,
				(byte) 204,
				(byte) 0,
				(byte) 153,
				(byte) 204,
				(byte) 0,
				(byte) 102,
				(byte) 204,
				(byte) 0,
				(byte) 51,
				(byte) 204,
				(byte) 0,
				(byte) 0,
				(byte) 153,
				(byte) 255,
				(byte) 255,
				(byte) 153,
				(byte) 255,
				(byte) 204,
				(byte) 153,
				(byte) 255,
				(byte) 153,
				(byte) 153,
				(byte) 255,
				(byte) 102,
				(byte) 153,
				(byte) 255,
				(byte) 51,
				(byte) 153,
				(byte) 255,
				(byte) 0,
				(byte) 153,
				(byte) 204,
				(byte) 255,
				(byte) 153,
				(byte) 204,
				(byte) 204,
				(byte) 153,
				(byte) 204,
				(byte) 153,
				(byte) 153,
				(byte) 204,
				(byte) 102,
				(byte) 153,
				(byte) 204,
				(byte) 51,
				(byte) 153,
				(byte) 204,
				(byte) 0,
				(byte) 153,
				(byte) 153,
				(byte) 255,
				(byte) 153,
				(byte) 153,
				(byte) 204,
				(byte) 153,
				(byte) 153,
				(byte) 153,
				(byte) 153,
				(byte) 153,
				(byte) 102,
				(byte) 153,
				(byte) 153,
				(byte) 51,
				(byte) 153,
				(byte) 153,
				(byte) 0,
				(byte) 153,
				(byte) 102,
				(byte) 255,
				(byte) 153,
				(byte) 102,
				(byte) 204,
				(byte) 153,
				(byte) 102,
				(byte) 153,
				(byte) 153,
				(byte) 102,
				(byte) 102,
				(byte) 153,
				(byte) 102,
				(byte) 51,
				(byte) 153,
				(byte) 102,
				(byte) 0,
				(byte) 153,
				(byte) 51,
				(byte) 255,
				(byte) 153,
				(byte) 51,
				(byte) 204,
				(byte) 153,
				(byte) 51,
				(byte) 153,
				(byte) 153,
				(byte) 51,
				(byte) 102,
				(byte) 153,
				(byte) 51,
				(byte) 51,
				(byte) 153,
				(byte) 51,
				(byte) 0,
				(byte) 153,
				(byte) 0,
				(byte) 255,
				(byte) 153,
				(byte) 0,
				(byte) 204,
				(byte) 153,
				(byte) 0,
				(byte) 153,
				(byte) 153,
				(byte) 0,
				(byte) 102,
				(byte) 153,
				(byte) 0,
				(byte) 51,
				(byte) 153,
				(byte) 0,
				(byte) 0,
				(byte) 102,
				(byte) 255,
				(byte) 255,
				(byte) 102,
				(byte) 255,
				(byte) 204,
				(byte) 102,
				(byte) 255,
				(byte) 153,
				(byte) 102,
				(byte) 255,
				(byte) 102,
				(byte) 102,
				(byte) 255,
				(byte) 51,
				(byte) 102,
				(byte) 255,
				(byte) 0,
				(byte) 102,
				(byte) 204,
				(byte) 255,
				(byte) 102,
				(byte) 204,
				(byte) 204,
				(byte) 102,
				(byte) 204,
				(byte) 153,
				(byte) 102,
				(byte) 204,
				(byte) 102,
				(byte) 102,
				(byte) 204,
				(byte) 51,
				(byte) 102,
				(byte) 204,
				(byte) 0,
				(byte) 102,
				(byte) 153,
				(byte) 255,
				(byte) 102,
				(byte) 153,
				(byte) 204,
				(byte) 102,
				(byte) 153,
				(byte) 153,
				(byte) 102,
				(byte) 153,
				(byte) 102,
				(byte) 102,
				(byte) 153,
				(byte) 51,
				(byte) 102,
				(byte) 153,
				(byte) 0,
				(byte) 102,
				(byte) 102,
				(byte) 255,
				(byte) 102,
				(byte) 102,
				(byte) 204,
				(byte) 102,
				(byte) 102,
				(byte) 153,
				(byte) 102,
				(byte) 102,
				(byte) 102,
				(byte) 102,
				(byte) 102,
				(byte) 51,
				(byte) 102,
				(byte) 102,
				(byte) 0,
				(byte) 102,
				(byte) 51,
				(byte) 255,
				(byte) 102,
				(byte) 51,
				(byte) 204,
				(byte) 102,
				(byte) 51,
				(byte) 153,
				(byte) 102,
				(byte) 51,
				(byte) 102,
				(byte) 102,
				(byte) 51,
				(byte) 51,
				(byte) 102,
				(byte) 51,
				(byte) 0,
				(byte) 102,
				(byte) 0,
				(byte) 255,
				(byte) 102,
				(byte) 0,
				(byte) 204,
				(byte) 102,
				(byte) 0,
				(byte) 153,
				(byte) 102,
				(byte) 0,
				(byte) 102,
				(byte) 102,
				(byte) 0,
				(byte) 51,
				(byte) 102,
				(byte) 0,
				(byte) 0,
				(byte) 51,
				(byte) 255,
				(byte) 255,
				(byte) 51,
				(byte) 255,
				(byte) 204,
				(byte) 51,
				(byte) 255,
				(byte) 153,
				(byte) 51,
				(byte) 255,
				(byte) 102,
				(byte) 51,
				(byte) 255,
				(byte) 51,
				(byte) 51,
				(byte) 255,
				(byte) 0,
				(byte) 51,
				(byte) 204,
				(byte) 255,
				(byte) 51,
				(byte) 204,
				(byte) 204,
				(byte) 51,
				(byte) 204,
				(byte) 153,
				(byte) 51,
				(byte) 204,
				(byte) 102,
				(byte) 51,
				(byte) 204,
				(byte) 51,
				(byte) 51,
				(byte) 204,
				(byte) 0,
				(byte) 51,
				(byte) 153,
				(byte) 255,
				(byte) 51,
				(byte) 153,
				(byte) 204,
				(byte) 51,
				(byte) 153,
				(byte) 153,
				(byte) 51,
				(byte) 153,
				(byte) 102,
				(byte) 51,
				(byte) 153,
				(byte) 51,
				(byte) 51,
				(byte) 153,
				(byte) 0,
				(byte) 51,
				(byte) 102,
				(byte) 255,
				(byte) 51,
				(byte) 102,
				(byte) 204,
				(byte) 51,
				(byte) 102,
				(byte) 153,
				(byte) 51,
				(byte) 102,
				(byte) 102,
				(byte) 51,
				(byte) 102,
				(byte) 51,
				(byte) 51,
				(byte) 102,
				(byte) 0,
				(byte) 51,
				(byte) 51,
				(byte) 255,
				(byte) 51,
				(byte) 51,
				(byte) 204,
				(byte) 51,
				(byte) 51,
				(byte) 153,
				(byte) 51,
				(byte) 51,
				(byte) 102,
				(byte) 51,
				(byte) 51,
				(byte) 51,
				(byte) 51,
				(byte) 51,
				(byte) 0,
				(byte) 51,
				(byte) 0,
				(byte) 255,
				(byte) 51,
				(byte) 0,
				(byte) 204,
				(byte) 51,
				(byte) 0,
				(byte) 153,
				(byte) 51,
				(byte) 0,
				(byte) 102,
				(byte) 51,
				(byte) 0,
				(byte) 51,
				(byte) 51,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 255,
				(byte) 255,
				(byte) 0,
				(byte) 255,
				(byte) 204,
				(byte) 0,
				(byte) 255,
				(byte) 153,
				(byte) 0,
				(byte) 255,
				(byte) 102,
				(byte) 0,
				(byte) 255,
				(byte) 51,
				(byte) 0,
				(byte) 255,
				(byte) 0,
				(byte) 0,
				(byte) 204,
				(byte) 255,
				(byte) 0,
				(byte) 204,
				(byte) 204,
				(byte) 0,
				(byte) 204,
				(byte) 153,
				(byte) 0,
				(byte) 204,
				(byte) 102,
				(byte) 0,
				(byte) 204,
				(byte) 51,
				(byte) 0,
				(byte) 204,
				(byte) 0,
				(byte) 0,
				(byte) 153,
				(byte) 255,
				(byte) 0,
				(byte) 153,
				(byte) 204,
				(byte) 0,
				(byte) 153,
				(byte) 153,
				(byte) 0,
				(byte) 153,
				(byte) 102,
				(byte) 0,
				(byte) 153,
				(byte) 51,
				(byte) 0,
				(byte) 153,
				(byte) 0,
				(byte) 0,
				(byte) 102,
				(byte) 255,
				(byte) 0,
				(byte) 102,
				(byte) 204,
				(byte) 0,
				(byte) 102,
				(byte) 153,
				(byte) 0,
				(byte) 102,
				(byte) 102,
				(byte) 0,
				(byte) 102,
				(byte) 51,
				(byte) 0,
				(byte) 102,
				(byte) 0,
				(byte) 0,
				(byte) 51,
				(byte) 255,
				(byte) 0,
				(byte) 51,
				(byte) 204,
				(byte) 0,
				(byte) 51,
				(byte) 153,
				(byte) 0,
				(byte) 51,
				(byte) 102,
				(byte) 0,
				(byte) 51,
				(byte) 51,
				(byte) 0,
				(byte) 51,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 255,
				(byte) 0,
				(byte) 0,
				(byte) 204,
				(byte) 0,
				(byte) 0,
				(byte) 153,
				(byte) 0,
				(byte) 0,
				(byte) 102,
				(byte) 0,
				(byte) 0,
				(byte) 51,
				(byte) 238,
				(byte) 0,
				(byte) 0,
				(byte) 221,
				(byte) 0,
				(byte) 0,
				(byte) 187,
				(byte) 0,
				(byte) 0,
				(byte) 170,
				(byte) 0,
				(byte) 0,
				(byte) 136,
				(byte) 0,
				(byte) 0,
				(byte) 119,
				(byte) 0,
				(byte) 0,
				(byte) 85,
				(byte) 0,
				(byte) 0,
				(byte) 68,
				(byte) 0,
				(byte) 0,
				(byte) 34,
				(byte) 0,
				(byte) 0,
				(byte) 17,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 238,
				(byte) 0,
				(byte) 0,
				(byte) 221,
				(byte) 0,
				(byte) 0,
				(byte) 187,
				(byte) 0,
				(byte) 0,
				(byte) 170,
				(byte) 0,
				(byte) 0,
				(byte) 136,
				(byte) 0,
				(byte) 0,
				(byte) 119,
				(byte) 0,
				(byte) 0,
				(byte) 85,
				(byte) 0,
				(byte) 0,
				(byte) 68,
				(byte) 0,
				(byte) 0,
				(byte) 34,
				(byte) 0,
				(byte) 0,
				(byte) 17,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 238,
				(byte) 0,
				(byte) 0,
				(byte) 221,
				(byte) 0,
				(byte) 0,
				(byte) 187,
				(byte) 0,
				(byte) 0,
				(byte) 170,
				(byte) 0,
				(byte) 0,
				(byte) 136,
				(byte) 0,
				(byte) 0,
				(byte) 119,
				(byte) 0,
				(byte) 0,
				(byte) 85,
				(byte) 0,
				(byte) 0,
				(byte) 68,
				(byte) 0,
				(byte) 0,
				(byte) 34,
				(byte) 0,
				(byte) 0,
				(byte) 17,
				(byte) 238,
				(byte) 238,
				(byte) 238,
				(byte) 221,
				(byte) 221,
				(byte) 221,
				(byte) 187,
				(byte) 187,
				(byte) 187,
				(byte) 170,
				(byte) 170,
				(byte) 170,
				(byte) 136,
				(byte) 136,
				(byte) 136,
				(byte) 119,
				(byte) 119,
				(byte) 119,
				(byte) 85,
				(byte) 85,
				(byte) 85,
				(byte) 68,
				(byte) 68,
				(byte) 68,
				(byte) 34,
				(byte) 34,
				(byte) 34,
				(byte) 17,
				(byte) 17,
				(byte) 17,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 44,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 0,
				(byte) 16,
				(byte) 0,
				(byte) 16,
				(byte) 0,
				(byte) 0,
				(byte) 8,
				(byte) 76,
				(byte) 0,
				(byte) 1,
				(byte) 8,
				(byte) 28,
				(byte) 72,
				(byte) 176,
				(byte) 160,
				(byte) 65,
				(byte) 130,
				(byte) 227,
				(byte) 198,
				(byte) 29,
				(byte) 52,
				(byte) 152,
				(byte) 112,
				(byte) 33,
				(byte) 67,
				(byte) 135,
				(byte) 2,
				(byte) 19,
				(byte) 42,
				(byte) 4,
				(byte) 32,
				(byte) 241,
				(byte) 160,
				(byte) 196,
				(byte) 139,
				(byte) 21,
				(byte) 9,
				(byte) 22,
				(byte) 216,
				(byte) 200,
				(byte) 145,
				(byte) 227,
				(byte) 193,
				(byte) 142,
				(byte) 32,
				(byte) 15,
				(byte) 94,
				(byte) 24,
				(byte) 73,
				(byte) 146,
				(byte) 164,
				(byte) 200,
				(byte) 146,
				(byte) 40,
				(byte) 13,
				(byte) 98,
				(byte) 91,
				(byte) 201,
				(byte) 178,
				(byte) 37,
				(byte) 54,
				(byte) 131,
				(byte) 32,
				(byte) 98,
				(byte) 202,
				(byte) 156,
				(byte) 9,
				(byte) 115,
				(byte) 166,
				(byte) 205,
				(byte) 131,
				(byte) 236,
				(byte) 114,
				(byte) 234,
				(byte) 204,
				(byte) 233,
				(byte) 144,
				(byte) 39,
				(byte) 0,
				(byte) 159,
				(byte) 16,
				(byte) 29,
				(byte) 6,
				(byte) 4,
				(byte) 0,
				(byte) 59 });
		dumpModel.open();

		return true;
	}

	/**
	 * Example2: Open a dump model.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		File aFile = JunFileRequesterDialog.RequestFile();
		if (aFile == null) {
			return false;
		}

		JunDumpModel dumpModel = new JunDumpModel(aFile);
		dumpModel.open();

		return true;
	}

	/**
	 * Example3: Open a dump model.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		File aFile = JunFileRequesterDialog.RequestFile();
		if (aFile == null) {
			return false;
		}

		JunDumpModel dumpModel = new JunDumpModel(aFile, 100, 200);
		dumpModel.open();

		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunDumpModelTestExamples();
	}
}
