package jp.co.sra.jun.goodies.files;

import java.awt.Dimension;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewAwt;

/**
 * JunFileDialogViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2003/03/09 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun433 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFileDialogViewAwt.java,v 9.10 2010/03/09 09:17:07 nisinaka Exp $
 */
public class JunFileDialogViewAwt extends JunAbstractDialogViewAwt implements JunFileDialogView {

	protected JunFileViewAwt fileView;

	/**
	 * Create a new instance of JunFileDialogViewAwt and initialize it.
	 *
	 * @param aFileDialog jp.co.sra.jun.goodies.files.JunFileDialog
	 * @category Instance creation
	 */
	public JunFileDialogViewAwt(JunFileDialog aFileDialog) {
		super(aFileDialog);
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewPanel#buildComponent()
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.fileView(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -97, 1f, -1));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.setPreferredSize(new Dimension(540, 300));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my model as JunFileDialog.
	 *
	 * @return jp.co.sra.jun.goodies.files.JunFileDialog
	 * @see jp.co.sra.jun.goodies.files.JunFileDialogView#getFileDialog()
	 * @category model accessing
	 */
	public JunFileDialog getFileDialog() {
		return (JunFileDialog) this.model();
	}

	/**
	 * Answer my file view.
	 *
	 * @return jp.co.sra.jun.goodies.files.JunFileViewAwt
	 * @category user interface
	 */
	protected JunFileViewAwt fileView() {
		if (fileView == null) {
			fileView = new JunFileViewAwt(this.getFileDialog().fileModel());
		}
		return fileView;
	}

}
