package jp.co.sra.jun.goodies.font;

import java.awt.Font;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunFontDialogTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2003/03/03 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun373 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFontDialogTestExamples.java,v 9.9 2010/03/09 09:17:07 nisinaka Exp $
 */
public class JunFontDialogTestExamples extends JunTestExamples {

	/**
	 * Example1: Create a new instance of JunFontModel and open it.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		Font font = JunFontDialog.Request();
		System.out.println(font);
		return true;
	}

	/**
	 * Example2: Create a new instance of JunFontModel and open it.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunFontDialog fontDialog = new JunFontDialog();
		fontDialog.fontName_("Times New Roman");
		fontDialog.fontSize_(12);
		fontDialog.openDialog();
		Font font = fontDialog.font();
		System.out.println(font);
		return true;
	}

	/**
	 * Open a test example launcher.
	 * 
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunFontDialogTestExamples();
	}

}
