package jp.co.sra.jun.goodies.gauge;

import java.awt.Dimension;
import java.awt.Window;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewAwt;

/**
 * JunGaugeDialogViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2004/04/14 (by nisinaka)
 *  @updated   2008/05/14 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun492 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunGaugeDialogViewAwt.java,v 9.10 2010/03/09 09:17:10 nisinaka Exp $
 */
public class JunGaugeDialogViewAwt extends JunAbstractDialogViewAwt implements JunGaugeDialogView {

	protected JunGaugeViewAwt gaugeView;

	/**
	 * Create a new instance of JunGaugeDialogViewAwt and initialize it.
	 * 
	 * @param aGaugeDialog jp.co.sra.jun.goodies.gauge.JunGaugeDialogViewAwt
	 * @category Instance creation
	 */
	public JunGaugeDialogViewAwt(JunGaugeDialog aGaugeDialog) {
		super(aGaugeDialog);
	}

	/**
	 * Answer my model as JunGaugeDialog.
	 * 
	 * @return jp.co.sra.jun.goodies.gauge.JunGaugeDialog
	 * @see jp.co.sra.jun.goodies.gauge.JunGaugeDialogView#getGaugeDialog()
	 * @category model accessing
	 */
	public JunGaugeDialog getGaugeDialog() {
		return (JunGaugeDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewPanel#buildComponent()
	 * @category interface specs
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.gaugeView()._onBorderedPanel(), WindowSpecLayout.Position(0f, 0, 0f, 0, 1f, -104, 1f, 0));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.setPreferredSize(new Dimension(200, 200));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my gauge view.
	 * 
	 * @return jp.co.sra.jun.goodies.gauge.JunGaugeViewAwt
	 * @category user interface
	 */
	protected JunGaugeViewAwt gaugeView() {
		if (gaugeView == null) {
			gaugeView = new JunGaugeViewAwt(this.getGaugeDialog().gaugeModel());
		}
		return gaugeView;
	}

	/**
	 * Set up the keyboard for the view on the window.
	 * 
	 * @param aWindow java.awt.Window
	 * @see jp.co.sra.smalltalk.StView#_setupKeyboard(java.awt.Window)
	 * @category keyboard
	 */
	public void _setupKeyboard(Window aWindow) {
		this.gaugeView()._setupKeyboard(aWindow);
	}

}
