package jp.co.sra.jun.goodies.gauge;

import java.awt.Color;

import jp.co.sra.smalltalk.StRectangle;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunGaugeView interface
 * 
 *  @author    nisinaka
 *  @created   2004/04/13 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun519 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunGaugeView.java,v 9.9 2010/03/09 09:17:10 nisinaka Exp $
 */
public interface JunGaugeView extends JunAbstractView {

	public static Color DefaultSelectionBackgroundColor = new Color(0.0391894f, 0.141131f, 0.415578f);
	public static Color DefaultSelectionForegroundColor = Color.white;

	/**
	 * Answer my model as JunGaugeModel.
	 * 
	 * @return jp.co.sra.jun.goodies.gauge.JunGaugeModel
	 * @category model accessing
	 */
	public JunGaugeModel getGaugeModel();

	/**
	 * Answer the border rectangle of the gauge.
	 * 
	 * @return java.awt.Rectangle
	 * @category accessing
	 */
	public StRectangle gaugeBorder();

	/**
	 * Answer my selection background color.
	 * 
	 * @return java.lang.Color
	 * @category visual properties
	 */
	public Color selectionBackgroundColor();

	/**
	 * Answer my selection foreground color.
	 * 
	 * @return java.lang.Color
	 * @category visual properties
	 */
	public Color selectionForegroundColor();

}
