package jp.co.sra.jun.goodies.huffman;

import java.awt.Rectangle;

import jp.co.sra.smalltalk.StImage;

import jp.co.sra.jun.goodies.image.framework.JunImageDisplayModel;
import jp.co.sra.jun.goodies.utilities.JunImageUtility;
import jp.co.sra.jun.opengl.display.JunOpenGLDisplayModel;
import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunHuffmanValueHolderTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2008/11/05 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun707 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunHuffmanValueHolderTestExamples.java,v 9.7 2010/03/09 09:17:10 nisinaka Exp $
 */
public class JunHuffmanValueHolderTestExamples extends JunTestExamples {
	/**
	 * Example1: Compress and expand with <code>StImage</code>.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		StImage anImage = new StImage(JunImageUtility.FromDisplay_(new Rectangle(0, 0, 512, 512)));
		JunHuffmanValueHolder<StImage> huffmanValueHolder = new JunHuffmanValueHolder<StImage>(anImage);
		anImage = huffmanValueHolder.value();
		JunImageDisplayModel.Show_(anImage);

		return true;
	}

	/**
	 * Example2: Compress and expand with <code>JunOpenGL3dObject.Smalltalk()</code>.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunOpenGL3dObject aBody = JunOpenGL3dObject.Smalltalk();
		JunHuffmanValueHolder<JunOpenGL3dObject> huffmanValueHolder = new JunHuffmanValueHolder<JunOpenGL3dObject>(aBody);
		aBody = huffmanValueHolder.value();
		JunOpenGLDisplayModel.Show_(aBody);

		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunHuffmanValueHolderTestExamples();
	}
}
