package jp.co.sra.jun.goodies.image.support;

import java.awt.Dimension;
import java.awt.TextArea;

import jp.co.sra.smalltalk.StBlockClosure1;
import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.framework.JunAbstractViewPanel;

/**
 * JunImageToAsciiViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2000/12/13 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2006/12/07 (by nisinaka)
 *  @updated   2008/04/16 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun668 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunImageToAsciiViewAwt.java,v 9.10 2010/03/09 09:17:13 nisinaka Exp $
 */
public class JunImageToAsciiViewAwt extends JunAbstractViewPanel implements JunImageToAsciiView {

	protected TextArea textArea;

	/**
	 * Create a new instance of JunImageToAsciiViewAwt and initialize it.
	 *
	 * @param anImageToAscii jp.co.sra.jun.goodies.image.support.JunImageToAscii
	 * @category Instance creation
	 */
	public JunImageToAsciiViewAwt(JunImageToAscii anImageToAscii) {
		super(anImageToAscii);
	}

	/**
	 * Build the component.
	 * 
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.textArea(), WindowSpecLayout.Position(0f, 0, 0f, 0, 1f, 0, 1f, 0));
		this.setPreferredSize(new Dimension(600, 400));
	}

	/**
	 * Answer my model as JunImageToAscii.
	 *
	 * @return jp.co.sra.jun.goodies.image.support.JunImageToAscii
	 * @category model accessing
	 */
	public JunImageToAscii getImageToAscii() {
		return (JunImageToAscii) this.model();
	}

	/**
	 * Answer the text area.
	 * 
	 * @return java.awt.TextArea
	 * @category user interface
	 */
	protected TextArea textArea() {
		if (textArea == null) {
			textArea = new TextArea("", 0, 0, TextArea.SCROLLBARS_VERTICAL_ONLY);
			textArea.setFont(this.getImageToAscii().font());

			this.getImageToAscii().textModel().compute_(new StBlockClosure1<String, String>() {
				public String value(String anObject) {
					textArea().setText(anObject);
					return null;
				}
			});
		}

		return textArea;
	}

}
