package jp.co.sra.jun.goodies.itemlist;

import jp.co.sra.smalltalk.StView;

/**
 * JunChoiceListDialogViewSwing class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/12/15 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun465 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunChoiceListDialogViewSwing.java,v 9.9 2010/03/09 09:17:13 nisinaka Exp $
 */
public class JunChoiceListDialogViewSwing extends JunItemListDialogViewSwing implements JunChoiceListDialogView {
	/**
	 * Create a new instance of JunChoiceListDialogViewSwing and initialize it.
	 *
	 * @param aChoiceListDialog jp.co.sra.jun.goodies.itemlist.JunChoiceListDialog
	 * @category Instance creation
	 */
	public JunChoiceListDialogViewSwing(JunChoiceListDialog aChoiceListDialog) {
		super(aChoiceListDialog);
	}

	/**
	 * Answer my order list view.
	 *
	 * @return jp.co.sra.smalltalk.StView
	 * @see jp.co.sra.jun.goodies.itemlist.JunItemListDialogViewSwing#orderListView()
	 * @category interface opening
	 */
	protected StView orderListView() {
		if (orderListView == null) {
			orderListView = JunChoiceListViewSwing.OnScrollPaneWithButtons((JunChoiceListModel) this.getOrderListDialog().itemListModel());
		}
		return orderListView;
	}
}
