package jp.co.sra.jun.goodies.itemlist;

import jp.co.sra.smalltalk.StBlockClosure;
import jp.co.sra.smalltalk.StBlockClosure1;

/**
 * JunItemListDialogTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/12/13 (by Mitsuhiro Asada)
 *  @updated   2008/04/24 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun465 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunItemListDialogTestExamples.java,v 9.9 2010/03/09 09:17:13 nisinaka Exp $
 */
public class JunItemListDialogTestExamples extends JunOrderListDialogTestExamples {
	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunItemListDialogTestExamples();
	}

	/**
	 * Example1 : test for a JunItemListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		Object[] answer = JunItemListDialog.Request_labels_checks_($String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray);
		_PrintObjects_(answer);
		return true;
	}

	/**
	 * Example2 : test for a JunItemListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example2() {
		Object[] answer = JunItemListDialog.Request_labels_checks_onAccept_onCancel_($String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray, new StBlockClosure() {
			public Object value_(Object object) {
				JunItemListModel model = (JunItemListModel) object;
				System.out.print($String("Accept button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		}, new StBlockClosure() {
			public Object value_(Object object) {
				JunItemListModel model = (JunItemListModel) object;
				System.out.print($String("Cancel button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		});
		_PrintObjects_(answer);
		return true;
	}

	/**
	 * Example2 : test for a JunItemListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2_g() {
		Object[] answer = JunItemListDialog.Request_labels_checks_onAccept_onCancel_($String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray, new StBlockClosure1<Boolean, JunOrderListModel>() {
			public Boolean value(JunOrderListModel model) {
				System.out.print($String("Accept button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		}, new StBlockClosure1<Boolean, JunOrderListModel>() {
			public Boolean value(JunOrderListModel model) {
				System.out.print($String("Cancel button was pressed."));
				System.out.print(" \t");
				_PrintObjects_(model.value());
				return Boolean.TRUE;
			}
		});
		_PrintObjects_(answer);
		return true;
	}

	/**
	 * Example3 : test for a JunItemListDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		Object[] answer = JunItemListDialog.Request_labels_checks_locks_($String("Choose items."), _StringArray, JunItemListTestExamples._CheckArray, JunItemListTestExamples._LockArray);
		_PrintObjects_(answer);
		return true;
	}
}
