package jp.co.sra.jun.goodies.itemlist;

import jp.co.sra.smalltalk.StView;

/**
 * JunItemListDialogViewAwt class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2003/12/13 (by Mitsuhiro Asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun465 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunItemListDialogViewAwt.java,v 9.9 2010/03/09 09:17:14 nisinaka Exp $
 */
public class JunItemListDialogViewAwt extends JunOrderListDialogViewAwt implements JunItemListDialogView {
	/**
	 * Create a new instance of JunItemListDialogViewAwt and initialize it.
	 *
	 * @param aItemListDialog jp.co.sra.jun.goodies.itemlist.JunItemListDialog
	 * @category Instance creation
	 */
	public JunItemListDialogViewAwt(JunItemListDialog aItemListDialog) {
		super(aItemListDialog);
	}

	/**
	 * Answer my order list view.
	 *
	 * @return jp.co.sra.smalltalk.StView
	 * @see jp.co.sra.jun.goodies.itemlist.JunOrderListDialogViewAwt#orderListView()
	 * @category interface opening
	 */
	protected StView orderListView() {
		if (orderListView == null) {
			orderListView = JunItemListViewAwt.OnScrollPaneWithButtons((JunItemListModel) this.getOrderListDialog().itemListModel());
		}
		return orderListView;
	}
}
