package jp.co.sra.jun.goodies.lisp;

import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunLispConverterTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2009/05/12 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLispConverterTestExamples.java,v 9.4 2010/03/09 09:17:14 nisinaka Exp $
 */
public class JunLispConverterTestExamples extends JunTestExamples {

	/**
	 * Test1_Register_Fail:
	 * 
	 * @return boolean
	 * @category Tests
	 */
	public static boolean Test1_Register_Fail() {
		try {
			JunLispConverter.Register("JunLispList", JunLispList.class);
			return false;
		} catch (RuntimeException e) {
			System.err.println(e.getMessage());
		}

		return true;
	}

	/**
	 * Test2_Register_Convert:
	 * 
	 * @return boolean
	 * @category Tests
	 */
	public static boolean Test2_Register_Convert() {
		JunLispConverter.Register("JunLispConverterTestExamples$Test", JunLispConverterTestExamples$Test.class);
		Object anObject = JunLispConverter.Convert(JunLispCons.Head_(StSymbol.Intern_("JunLispConverterTestExamples$Test")));
		System.out.println(anObject);

		return anObject instanceof JunLispConverterTestExamples$Test;
	}

	/**
	 * Execute the examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunLispConverterTestExamples();
	}

	//////////
	public static class JunLispConverterTestExamples$Test {
		public JunLispConverterTestExamples$Test(JunLispList aList) {
		}
	}

}
