package jp.co.sra.jun.goodies.lisp;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunLispInterpreterView interface
 * 
 *  @author    nisinaka
 *  @created   2003/05/07 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun490 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLispInterpreterView.java,v 9.9 2010/03/09 09:17:14 nisinaka Exp $
 */
public interface JunLispInterpreterView extends JunAbstractView {

	/**
	 * Answer my model as JunLispInterpreter.
	 *
	 * @return jp.co.sra.jun.goodies.lisp.JunLispInterpreter
	 * @category model accessing
	 */
	public JunLispInterpreter getLispInterpreter();

	/**
	 * Answer the selected text to 'do it'.
	 *
	 * @return java.lang.String
	 * @category accessing
	 */
	public String getSelectedText();

}
