package jp.co.sra.jun.goodies.meter;

import java.awt.Component;
import java.awt.Container;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.goodies.gauge.JunLevelGaugeModel;
import jp.co.sra.jun.goodies.gauge.JunLevelGaugeViewAwt;
import jp.co.sra.jun.system.framework.JunAbstractViewPanel;

/**
 * JunAbstractGaugeMeterViewAwt class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/04/04 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun652 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunAbstractGaugeMeterViewAwt.java,v 9.8 2010/03/09 09:17:15 nisinaka Exp $
 */
public abstract class JunAbstractGaugeMeterViewAwt extends JunAbstractViewPanel implements JunAbstractGaugeMeterView {
	/**
	 * Create a new instance of <code>JunAbstractGaugeMeterViewAwt</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunAbstractGaugeMeterViewAwt() {
		super();
	}

	/**
	 * Create a new instance of <code>JunAbstractGaugeMeterViewAwt</code> and initialize it.
	 * 
	 * @param aMeter jp.co.sra.jun.goodies.meter.JunAbstractGaugeMeter
	 * @category Instance creation
	 */
	public JunAbstractGaugeMeterViewAwt(JunAbstractGaugeMeter aMeter) {
		super(aMeter);
	}

	/**
	 * Answer the meter view with the specified gauges.
	 * 
	 * @param gauges jp.co.sra.jun.goodies.gauge.JunLevelGaugeModel[]
	 * @return java.awt.Component
	 * @category interface opening
	 */
	protected Component meterView_(JunLevelGaugeModel[] gauges) {
		Container meterView = new Container();
		meterView.setLayout(new WindowSpecLayout());

		boolean verticalGauge = gauges[0].verticalGauge();
		float deltaPosition = 1.0f / gauges.length;
		for (int i = 0; i < gauges.length; i++) {
			JunLevelGaugeViewAwt gaugeView = new JunLevelGaugeViewAwt(gauges[i]);
			if (verticalGauge) {
				meterView.add(gaugeView, WindowSpecLayout.Position(deltaPosition * i, 0, 0f, 0, deltaPosition * (i + 1), 0, 1f, 0));
			} else {
				meterView.add(gaugeView, WindowSpecLayout.Position(0f, 0, deltaPosition * i, 0, 1f, 0, deltaPosition * (i + 1), 0));
			}
		}
		return meterView;
	}

	/**
	 * Answer the receiver's model as JunAbstractGaugeMeter
	 * 
	 * @return jp.co.sra.jun.goodies.meter.JunAbstractGaugeMeter
	 * @see jp.co.sra.jun.goodies.meter.JunAbstractGaugeMeterView#getModel()
	 * @category model accessing
	 */
	public JunAbstractGaugeMeter getModel() {
		return (JunAbstractGaugeMeter) this.model();
	}
}
