package jp.co.sra.jun.goodies.milliseconds;

import java.awt.Dimension;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewSwing;

/**
 * JunMillisecondDialogViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2003/05/28 (by nisinaka)
 *  @updated   2008/05/23 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun433 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMillisecondDialogViewSwing.java,v 9.9 2010/03/09 09:17:16 nisinaka Exp $
 */
public class JunMillisecondDialogViewSwing extends JunAbstractDialogViewSwing implements JunMillisecondDialogView {
	protected JunMillisecondViewSwing millisecondView;

	/**
	 * Create a new instance of <code>JunMillisecondDialogViewSwing</code> and initialize it.
	 * 
	 * @param aMillisecondDialog jp.co.sra.jun.goodies.milliseconds.JunMillisecondDialog
	 * @category Instance creation
	 */
	public JunMillisecondDialogViewSwing(JunMillisecondDialog aMillisecondDialog) {
		super(aMillisecondDialog);
	}

	/**
	 * Answer my model as a JunMillisecondDialog.
	 *
	 * @return jp.co.sra.jun.goodies.milliseconds.JunMillisecondDialog
	 * @see jp.co.sra.jun.goodies.milliseconds.JunMillisecondDialogView#getMillisecondDialog()
	 * @category model accessing
	 */
	public JunMillisecondDialog getMillisecondDialog() {
		return (JunMillisecondDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewJPanel#buildComponent()
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.millisecondView()._onBorderedPanel(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -102, 1f, -1));
		this.add(this.acceptButton(), WindowSpecLayout.Position(1f, -96, 0f, 16, 1f, -8, 0f, 48));
		this.add(this.cancelButton(), WindowSpecLayout.Position(1f, -96, 0f, 56, 1f, -8, 0f, 88));
		this.setPreferredSize(new Dimension(250, 100));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my millisecond view.
	 *
	 * @return jp.co.sra.jun.goodies.milliseconds.JunMillisecondViewSwing
	 * @category user interface
	 */
	protected JunMillisecondViewSwing millisecondView() {
		if (millisecondView == null) {
			millisecondView = new JunMillisecondViewSwing(this.getMillisecondDialog().millisecondModel());
		}
		return millisecondView;
	}
}
