package jp.co.sra.jun.goodies.misc;

import java.awt.Dimension;
import java.awt.Frame;

import jp.co.sra.smalltalk.StApplicationModel;
import jp.co.sra.smalltalk.StBlockClosure0;
import jp.co.sra.smalltalk.StBlockClosure1;
import jp.co.sra.smalltalk.StImage;
import jp.co.sra.smalltalk.StView;

import jp.co.sra.jun.goodies.animation.JunCartoonMovie;
import jp.co.sra.jun.goodies.calendar.JunCalendarModel;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunFeelTheMoonTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2010/03/09 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun758 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFeelTheMoonTestExamples.java,v 9.1 2010/03/09 09:17:16 nisinaka Exp $
 */
public class JunFeelTheMoonTestExamples extends JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		feelTheMoon.open();

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		feelTheMoon.open();
		feelTheMoon.ageOfTheMoon_(5);

		return true;
	}

	/**
	 * Example3:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		feelTheMoon.open();
		feelTheMoon.dateString_("1976/07/24");

		return true;
	}

	/**
	 * Example4:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example4() {
		final JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		feelTheMoon.open();

		JunFeelTheMoon.RangeOfAgeOfTheMoon.do_(new StBlockClosure1<Void, Double>() {
			public Void value(final Double ageOfTheMoon) {
				feelTheMoon.do_forMilliseconds_(new StBlockClosure0<Void>() {
					public Void value() {
						feelTheMoon.ageOfTheMoon_(ageOfTheMoon);
						return null;
					}
				}, 100);
				return null;
			}
		});

		return true;
	}

	/**
	 * Example5:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example5() {
		JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		Frame frame = feelTheMoon.open();
		StApplicationModel._ShowAtCenterPoint(frame);

		feelTheMoon.openCalendar();

		return true;
	}

	/**
	 * Example6:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example6() {
		final JunFeelTheMoon feelTheMoon = new JunFeelTheMoon();
		StView view = feelTheMoon.defaultView();
		view.toComponent().setPreferredSize(new Dimension(200, 200));
		feelTheMoon.openView_(view);

		final JunCartoonMovie cartoonMovie = new JunCartoonMovie();
		final double tickTime = 100;

		JunFeelTheMoon.RangeOfAgeOfTheMoon.do_(new StBlockClosure1<Void, Double>() {
			public Void value(final Double ageOfTheMoon) {
				feelTheMoon.ageOfTheMoon_(ageOfTheMoon);
				StImage image = feelTheMoon.asImage();
				cartoonMovie.addImage_keepTime_(image, tickTime);
				return null;
			}
		});

		cartoonMovie.loop();
		cartoonMovie.openLightWeightWindowSpec();
		cartoonMovie.start();

		return true;
	}

	/**
	 * Test_AgeOfTheMoonFromDate:
	 * 
	 * @return boolean
	 * @category Testing
	 */
	public static boolean Test_AgeOfTheMoonFromDate() {
		double age = JunFeelTheMoon.AgeOfTheMoonFromDate_(JunCalendarModel.DateFromString_("2007/12/09"));
		return age == 0;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunFeelTheMoonTestExamples();
	}

}
