package jp.co.sra.jun.goodies.misc;

import java.awt.Dimension;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.opengl.display.JunOpenGL3dViewAwt;

/**
 * JunFeelTheMoonViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2010/03/09 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun758 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFeelTheMoonViewAwt.java,v 9.1 2010/03/09 09:17:16 nisinaka Exp $
 */
public class JunFeelTheMoonViewAwt extends JunOpenGL3dViewAwt implements JunFeelTheMoonView {

	/**
	 * Create a new instance of JunFeelTheMoonViewAwt and initialize it.
	 *
	 * @param aFeelTheMoon jp.co.sra.jun.goodies.misc.JunFeelTheMoon
	 * @category Instance creation
	 */
	public JunFeelTheMoonViewAwt(JunFeelTheMoon aFeelTheMoon) {
		super(aFeelTheMoon);
	}

	/**
	 * Build the component.
	 * 
	 * @see jp.co.sra.jun.opengl.display.JunOpenGL3dViewSwing#buildComponent()
	 * @category initialize-release
	 */
	@Override
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.getOpenGLDrawable().toComponent(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -1));
		this.setPreferredSize(new Dimension(300, 300));
	}

	/**
	 * Answer my model as JunFeelTheMoon.
	 * 
	 * @return jp.co.sra.jun.goodies.misc.JunFeelTheMoon
	 * @see jp.co.sra.jun.goodies.misc.JunFeelTheMoonView#getFeelTheMoon()
	 * @category model accessing
	 */
	public JunFeelTheMoon getFeelTheMoon() {
		return (JunFeelTheMoon) this.model();
	}

}
