package jp.co.sra.jun.goodies.morph;

import java.awt.image.BufferedImage;

import jp.co.sra.jun.geometry.curves.Jun2dLine;
import jp.co.sra.jun.goodies.utilities.JunImageUtilityTestExamples;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunMorphModelTestExamples class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2008/11/11 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun714 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMorphModelTestExamples.java,v 9.8 2010/03/09 09:17:17 nisinaka Exp $
 */
public class JunMorphModelTestExamples extends JunTestExamples {
	/**
	 * Example: Create a new instance of <code>JunMorphModel</code> and just open it.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunMorphModel morphModel = new JunMorphModel();
		morphModel.open();

		return true;
	}

	/**
	 * Example: Create a new instance of <code>JunMorphModel</code> and just open it.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunMorphModel morphModel = new JunMorphModel(JunImageUtilityTestExamples.MorphSampleFirstImage(), JunImageUtilityTestExamples.MorphSampleSecondImage());
		morphModel.open();

		return true;
	}

	/**
	 * Example: Create a new instance of <code>JunMorphModel</code> and just open it.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		BufferedImage firstImage = JunImageUtilityTestExamples.MorphSampleFirstImage();
		BufferedImage secondImage = JunImageUtilityTestExamples.MorphSampleSecondImage();
		Jun2dLine[] fromLines = JunImageUtilityTestExamples.MorphSampleFirstLines();
		Jun2dLine[] toLines = JunImageUtilityTestExamples.MorphSampleSecondLines();
		JunMorphModel morphModel = new JunMorphModel(firstImage, secondImage, fromLines, toLines);
		morphModel.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunMorphModelTestExamples();
	}
}
