package jp.co.sra.jun.goodies.multimedia;

import java.io.File;

import jp.co.sra.jun.goodies.files.JunFileModel;
import jp.co.sra.jun.graphics.navigator.JunFileRequesterDialog;
import jp.co.sra.jun.system.support.JunSystem;

/**
 * JunMultiMediaImageModelTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2003/03/19 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun637 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMultiMediaImageModelTestExamples.java,v 9.8 2010/03/09 09:17:18 nisinaka Exp $
 */
public class JunMultiMediaImageModelTestExamples extends jp.co.sra.jun.system.support.JunTestExamples {

	/**
	 * Example1: Open a JunMultiMediaViewer.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunFileModel.FileType[] fileTypes = new JunFileModel.FileType[] { new JunFileModel.FileType(JunSystem.$String("<1p> files", null, JunSystem.$String("Image")), JunSystem.DefaultImageExtensionPatterns()), JunFileModel.FileType.All(JunSystem.$String("All files"))};
		File aFile = JunFileRequesterDialog.Request(JunSystem.$String("Select an <1p> file.", null, JunSystem.$String("Image")), fileTypes, fileTypes[0]);
		if (aFile == null) {
			return false;
		}

		JunMultiMediaImageModel imageModel = new JunMultiMediaImageModel(aFile);
		imageModel.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(java.lang.String[] args) {
		new JunMultiMediaImageModelTestExamples();
	}
}
