package jp.co.sra.jun.goodies.nib;

import java.awt.Color;
import java.io.StringWriter;

import jp.co.sra.smalltalk.StBlockClosure;
import jp.co.sra.smalltalk.StBlockClosure1;
import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunNibChoiceTestExamples class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/03/19 (By Nobuto Matsubara)
 *  @updated   2008/05/16 (by m-asada)
 *  @version   758 (with StPL9.7) based on Jun538 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNibChoiceTestExamples.java,v 9.10 2010/03/09 09:17:19 nisinaka Exp $
 */
public class JunNibChoiceTestExamples extends JunTestExamples {
	/**
	 * Example1: open nib choice window
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example1() {
		JunNibChoice nibChoice = new JunNibChoice();
		nibChoice.compute_(new StBlockClosure() {
			public Object value_(Object anObject) {
				Object[] anArray = (Object[]) anObject;
				double[] nibCollection = (double[]) anArray[0];
				Double nibWidth = (Double) anArray[1];
				Color nibColor = (Color) anArray[2];
				StSymbol nibShape = (StSymbol) anArray[3];
				StringWriter writer = new StringWriter();
				for (int i = 0; i < nibCollection.length; i++) {
					if (i == 0) {
						writer.write("(");
					} else {
						writer.write(" ");
					}
					writer.write(String.valueOf(nibCollection[i]));
				}
				writer.write(") ");
				writer.write(nibWidth.toString());
				writer.write(" ");
				writer.write("(r=");
				writer.write(String.valueOf(nibColor.getRed()));
				writer.write(",g=");
				writer.write(String.valueOf(nibColor.getGreen()));
				writer.write(",b=");
				writer.write(String.valueOf(nibColor.getBlue()));
				writer.write(",a=");
				writer.write(String.valueOf(nibColor.getAlpha()));
				writer.write(") ");
				writer.write(nibShape.toString());
				System.out.println(writer.toString());

				return null;
			}
		});
		nibChoice.open();
		return true;
	}

	/**
	 * Example1: open nib choice window
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1_g() {
		JunNibChoice nibChoice = new JunNibChoice();
		nibChoice.compute_(new StBlockClosure1<Void, Object[]>() {
			public Void value(Object[] anArray) {
				double[] nibCollection = (double[]) anArray[0];
				Double nibWidth = (Double) anArray[1];
				Color nibColor = (Color) anArray[2];
				StSymbol nibShape = (StSymbol) anArray[3];
				StringWriter writer = new StringWriter();
				for (int i = 0; i < nibCollection.length; i++) {
					if (i == 0) {
						writer.write("(");
					} else {
						writer.write(" ");
					}
					writer.write(String.valueOf(nibCollection[i]));
				}
				writer.write(") ");
				writer.write(nibWidth.toString());
				writer.write(" ");
				writer.write("(r=");
				writer.write(String.valueOf(nibColor.getRed()));
				writer.write(",g=");
				writer.write(String.valueOf(nibColor.getGreen()));
				writer.write(",b=");
				writer.write(String.valueOf(nibColor.getBlue()));
				writer.write(",a=");
				writer.write(String.valueOf(nibColor.getAlpha()));
				writer.write(") ");
				writer.write(nibShape.toString());
				System.out.println(writer.toString());

				return null;
			}
		});
		nibChoice.open();
		return true;
	}

	/**
	 * Example2: open nib choice window
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunNibChoice nibChoice = new JunNibChoice(new double[] { 1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23, 25 });
		nibChoice.open();
		return true;
	}

	/**
	 * Example3: open nib choice window
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		JunNibChoice nibChoice = new JunNibChoice(new double[] { 1, 3, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23, 25 }, 13.0f, Color.red, $("circle"));
		nibChoice.open();
		return true;
	}

	/**
	 * Execute all examples.
	 *
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunNibChoiceTestExamples();
	}
}
