package jp.co.sra.jun.goodies.nib;

import jp.co.sra.smalltalk.StRectangle;
import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunNibChoiceView interface
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/03/19 (By Nobuto Matsubara)
 *  @updated   2004/09/22 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun519 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNibChoiceView.java,v 9.8 2010/03/09 09:17:19 nisinaka Exp $
 */
public interface JunNibChoiceView extends JunAbstractView {

	/**
	 * Answer my model as JunNibChoice.
	 * 
	 * @return jp.co.sra.jun.goodies.nib.JunNibChoice
	 * @category model accessing
	 */
	public JunNibChoice getNibChoice();

	/**
	 * Answer the area of nib shape.
	 * 
	 * @return jp.co.sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public StRectangle nibShapeArea();

	/**
	 * Answer the area of nib width.
	 * 
	 * @return jp.co.sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public StRectangle nibWidthArea();

	/**
	 * Answer the string of nib width.
	 * 
	 * @return jp.co.sra.smalltalk.StRectangle
	 * @category accessing
	 */
	public String nibWidthString();

}
