package jp.co.sra.jun.goodies.nib;

import java.awt.Dimension;
import java.awt.Window;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.dialog.JunAbstractDialogViewAwt;

/**
 * JunNibChoiceWithColorDialogViewAwt class
 * 
 *  @author    Nobuto Matsubara
 *  @created   2004/03/26 (By Nobuto Matsubara)
 *  @updated   2008/05/16 (By m-asada)
 *  @version   758 (with StPL9.7) based on Jun490 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunNibChoiceWithColorDialogViewAwt.java,v 9.10 2010/03/09 09:17:19 nisinaka Exp $
 */
public class JunNibChoiceWithColorDialogViewAwt extends JunAbstractDialogViewAwt implements JunNibChoiceWithColorDialogView {
	protected JunNibChoiceWithColorViewAwt nibChoiceView;

	/**
	 * Create a new instance of <code>JunNibChoiceWithColorDialogViewAwt</code> and initialize it.
	 * 
	 * @param aModel jp.co.sra.jun.goodies.nib.JunNibChoiceWithColorDialog
	 * @category Instance creation
	 */
	public JunNibChoiceWithColorDialogViewAwt(JunNibChoiceWithColorDialog aModel) {
		super(aModel);
	}

	/**
	 * Answer my model as a JunNibChoiceWithColorDialog.
	 * 
	 * @return jp.co.sra.jun.goodies.colors.JunNibChoiceWithColorDialog
	 * @see jp.co.sra.jun.goodies.nib.JunNibChoiceWithColorDialogView#getNibChoiceDialog()
	 * @category model accessing
	 */
	public JunNibChoiceWithColorDialog getNibChoiceDialog() {
		return (JunNibChoiceWithColorDialog) this.model();
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewPanel#buildComponent()
	 * @category interface opening
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.nibChoiceView(), WindowSpecLayout.Position(0f, 0, 0f, 0, 1f, 0, 1f, -50));
		this.add(this.acceptButton(), WindowSpecLayout.Position(0.25f, -44, 1f, -40, 0.25f, 44, 1f, -8));
		this.add(this.cancelButton(), WindowSpecLayout.Position(0.75f, -44, 1f, -40, 0.75f, 44, 1f, -8));
		this.setPreferredSize(new Dimension(238, 227));

		defaultButton = this.acceptButton();
	}

	/**
	 * Answer my nib choice view.
	 *
	 * @return jp.co.sra.smalltalk.StViewPanel
	 * @category interface opening
	 */
	protected JunNibChoiceWithColorViewAwt nibChoiceView() {
		if (nibChoiceView == null) {
			nibChoiceView = new JunNibChoiceWithColorViewAwt(this.getNibChoiceDialog().nibChoiceWithColorModel());
		}
		return nibChoiceView;
	}

	/**
	 * Set up the keyboard for the view on the window.
	 * 
	 * @param aWindow java.awt.Window
	 * @see jp.co.sra.smalltalk.StView#_setupKeyboard(java.awt.Window)
	 * @category keyboard
	 */
	public void _setupKeyboard(Window aWindow) {
		this.nibChoiceView()._setupKeyboard(aWindow);
	}
}
