package jp.co.sra.jun.goodies.print;

import java.awt.Graphics;

import jp.co.sra.smalltalk.StImage;

import jp.co.sra.jun.opengl.texture.JunOpenGLTextureTestExamples;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunPrintPreviewDialogTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2007/07/26 (by nisinaka)
 *  @updated   2008/08/14 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPrintPreviewDialogTestExamples.java,v 9.7 2010/03/09 09:17:20 nisinaka Exp $
 */
public class JunPrintPreviewDialogTestExamples extends JunTestExamples {

	/**
	 * Example:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example() {
		final StImage image = new StImage(JunOpenGLTextureTestExamples.ImageSmalltalkBalloon());
		JunPrintableObject printableObject = new JunPrintableObject() {
			protected double getWidth() {
				return image.width();
			}

			protected double getHeight() {
				return image.height();
			}

			protected void print(Graphics aGraphics) {
				image.displayOn_(aGraphics);
			}
		};
		printableObject.setScale(10);

		return JunPrintPreviewDialog.Request(printableObject);
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunPrintPreviewDialogTestExamples();
	}

}
