package jp.co.sra.jun.goodies.prolog;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunPrologInterpreterView interface
 * 
 *  @author    nisinaka
 *  @created   2003/05/06 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2008/05/23 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun490 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPrologInterpreterView.java,v 9.9 2010/03/09 09:17:22 nisinaka Exp $
 */
public interface JunPrologInterpreterView extends JunAbstractView {

	/**
	 * Answer my model as JunPrologInterpreter.
	 *
	 * @return jp.co.sra.jun.goodies.prolog.JunPrologInterpreter
	 * @category model accessing
	 */
	public JunPrologInterpreter getPrologInterpreter();

	/**
	 * Answer the selected text to 'do it'.
	 *
	 * @return java.lang.String
	 * @category accessing
	 */
	public String getSelectedText();

}
