package jp.co.sra.jun.goodies.revision;

import jp.co.sra.smalltalk.StObject;
import jp.co.sra.smalltalk.StValued;

/**
 * JunHistoryNode class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/08/14 (by Mitsuhiro Asada)
 *  @updated   2008/06/02 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun500 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunHistoryNode.java,v 9.9 2010/03/09 09:17:22 nisinaka Exp $
 */
public class JunHistoryNode<V> extends StObject {
	protected JunHistoryNode<V> parent;
	protected StValued<V> operation;
	protected String comment;

	/**
	 * Create a new instance of <code>JunHistoryNode</code> and initialize it.
	 * 
	 * @param evaluatableObject jp.co.sra.smalltalk.StValued
	 * @category Instance creation
	 */
	public JunHistoryNode(StValued<V> evaluatableObject) {
		super();
		this.operation_(evaluatableObject);
	}

	/**
	 * Answer the receiver's comment.
	 * 
	 * @return comment
	 * @category accessing
	 */
	public String comment() {
		return comment;
	}

	/**
	 * Set the receiver's comment.
	 * 
	 * @param aString java.lang.String
	 * @category accessing
	 */
	public void comment_(String aString) {
		comment = aString;
	}

	/**
	 * Answer the receiver's operation.
	 * 
	 * @return jp.co.sra.smalltalk.StValued
	 * @category accessing
	 */
	public StValued<V> operation() {
		return operation;
	}

	/**
	 * Set the receiver's operation.
	 * 
	 * @param evaluatableObject jp.co.sra.smalltalk.StValued
	 * @category accessing
	 */
	public void operation_(StValued<V> evaluatableObject) {
		operation = evaluatableObject;
	}

	/**
	 * Answer the receiver's parent.
	 * 
	 * @return jp.co.sra.jun.goodies.revision.JunHistoryNode
	 * @category accessing
	 */
	public JunHistoryNode<V> parent() {
		return parent;
	}

	/**
	 * Set the receiver's parent.
	 * 
	 * @param parentNode jp.co.sra.jun.goodies.revision.JunHistoryNode
	 * @category accessing
	 */
	public void parent_(JunHistoryNode<V> parentNode) {
		parent = parentNode;
	}
}
