package jp.co.sra.jun.goodies.sound;

import java.awt.Graphics;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunSoundWaveMeterView interface
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/29 (by Hoshi Takanori)
 *  @updated   2004/09/21 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun473 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSoundWaveMeterView.java,v 9.8 2010/03/09 09:17:23 nisinaka Exp $
 */
public interface JunSoundWaveMeterView extends JunAbstractView {
	/**
	 * Display on the graphics.
	 * 
	 * @param graphicsContext java.awt.Graphics
	 * @category displaying
	 */
	public void displayOn_(Graphics graphicsContext);

	/**
	 * Display the current position on the graphics context.
	 *
	 * @param graphicsContext java.awt.Graphics
	 * @param key java.lang.Double
	 * @category displaying
	 */
	public void displayOn_currentPosition_(Graphics graphicsContext, Double key);

	/**
	 * Display from startX to endX on the graphics context.
	 *
	 * @param graphicsContext java.awt.Graphics
	 * @param startX int
	 * @param endX int
	 * @category displaying
	 */
	public void displayOn_from_to_(Graphics graphicsContext, int startX, int endX);
}
