package jp.co.sra.jun.goodies.texteditor;

import jp.co.sra.smalltalk.StBlockClosure;
import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.system.support.JunSystem;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunTextEditorDialogTestExamples class
 * 
 *  @author    m-asada
 *  @created   2005/05/11 (by Mitsuhiro Asada)
 *  @updated   2008/05/15 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTextEditorDialogTestExamples.java,v 9.10 2010/03/09 09:17:25 nisinaka Exp $
 */
public class JunTextEditorDialogTestExamples extends JunTestExamples {
	/**
	 * Example1: Request a value with JunTextEditorDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		String value = JunTextEditorDialog.Request();
		System.out.println(value);

		return true;
	}

	/**
	 * Example2: Request a value with JunTextEditorDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		String value = JunTextEditorDialog.Request($String("Input a new <1p>.", null, $String("Text")));
		System.out.println(value);

		return true;
	}

	/**
	 * Example3: Request a value with JunTextEditorDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example3() {
		String value = JunTextEditorDialog.Request($String("Input a new <1p>.", null, $String("Text")), new JunTextEditor(JunSystem.FullName()), new StBlockClosure() {
			public Object value_(Object model) {
				System.out.println($String("Accept button was pressed."));
				System.out.println("\t" + ((JunTextEditor) model).text());
				return Boolean.TRUE;
			}
		}, new StBlockClosure() {
			public Object value_(Object model) {
				System.out.println($String("Cancel button was pressed."));
				System.out.println("\t" + ((JunTextEditor) model).text());
				return Boolean.TRUE;
			}
		});
		System.out.println(value);

		return true;
	}

	/**
	 * Example3: Request a value with JunTextEditorDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3_g() {
		String value = JunTextEditorDialog.Request($String("Input a new <1p>.", null, $String("Text")), new JunTextEditor(JunSystem.FullName()), new StBlockClosure1<Boolean, JunTextEditor>() {
			public Boolean value(JunTextEditor model) {
				System.out.println($String("Accept button was pressed."));
				System.out.println("\t" + model.text());
				return Boolean.TRUE;
			}
		}, new StBlockClosure1<Boolean, JunTextEditor>() {
			public Boolean value(JunTextEditor model) {
				System.out.println($String("Cancel button was pressed."));
				System.out.println("\t" + model.text());
				return Boolean.TRUE;
			}
		});
		System.out.println(value);

		return true;
	}

	/**
	 * Example4: Request a value with JunTextEditorDialog.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example4() {
		String value = JunTextEditorDialog.Request($String("Input a new <1p>.", null, $String("Text")), JunSystem.Copyright());
		System.out.println(value);

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunTextEditorDialogTestExamples();
	}
}
