package jp.co.sra.jun.goodies.tools;

import java.io.IOException;
import java.io.Writer;

/**
 * JunDummyWriter class
 * 
 *  @author    nisinaka
 *  @created   2009/06/23 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun727 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDummyWriter.java,v 9.3 2010/03/09 09:17:25 nisinaka Exp $
 */
public class JunDummyWriter extends Writer {

	protected int position = 0;

	/**
	 * Answer my current position.
	 * 
	 * @return int
	 * @category accessing
	 */
	public int position() {
		return position;
	}

	/**
	 * Write a portion of an array of characters.
	 *
	 * @param  cbuf  Array of characters
	 * @param  off   Offset from which to start writing characters
	 * @param  len   Number of characters to write
	 * @see java.io.Writer#write(char[], int, int)
	 */
	@Override
	public void write(char[] cbuf, int off, int len) throws IOException {
		position += len;
	}

	/**
	 * Flush the stream.
	 * 
	 * @see java.io.Writer#flush()
	 */
	@Override
	public void flush() throws IOException {
		// nothing to do
	}

	/**
	 * Close the stream.
	 * 
	 * @see java.io.Writer#close()
	 */
	@Override
	public void close() throws IOException {
		// nothing to do
	}

}
