package jp.co.sra.jun.goodies.track;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunSimpleSliderModelTestExamples class
 * 
 *  @author    Hoshi Takanori
 *  @created   2003/08/27 (by Hoshi Takanori)
 *  @updated   2008/05/11 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun475 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunSimpleSliderModelTestExamples.java,v 9.10 2010/03/09 09:17:26 nisinaka Exp $
 */
public class JunSimpleSliderModelTestExamples extends JunTestExamples {

	/**
	 * Example1.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunSimpleSliderModel slider = new JunSimpleSliderModel();
		slider.compute_(new StBlockClosure1<Void, Double>() {
			public Void value(Double value) {
				System.out.println(value);
				return null;
			}
		});
		for (int i = 0; i <= 100; i++) {
			slider.value_(i / 100.0);
		}

		return true;
	}

	/**
	 * Example2: Open JunSimpleSlider.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunSimpleSliderModel slider = new JunSimpleSliderModel();
		slider.compute_(new StBlockClosure1<Void, Double>() {
			public Void value(Double value) {
				System.out.println(value);
				return null;
			}
		});
		slider.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunSimpleSliderModelTestExamples();
	}
}
