package jp.co.sra.jun.goodies.track;

import jp.co.sra.smalltalk.StBlockClosure;
import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunTrackerModelTestExamples class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1998/11/24 (by MATSUDA Ryouichi)
 *  @updated   2002/10/27 (by nisinaka)
 *  @updated   2003/03/24 (by nisinaka)
 *  @updated   2006/02/23 (by nisinaka)
 *  @updated   2008/05/16 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on Jun651 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTrackerModelTestExamples.java,v 9.10 2010/03/09 09:17:26 nisinaka Exp $
 */
public class JunTrackerModelTestExamples extends JunTestExamples {
	/**
	 * Example1.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example1() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.open();

		return true;
	}

	/**
	 * Example1.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1_g() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure1<Void, Double>() {
			public Void value(Double value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.open();

		return true;
	}

	/**
	 * Example2.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example2() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.loop();
		tracker.open();

		return true;
	}

	/**
	 * Example2.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2_g() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure1<Void, Double>() {
			public Void value(Double value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.loop();
		tracker.open();

		return true;
	}

	/**
	 * Example3.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	@SuppressWarnings( { "unchecked", "deprecation" })
	public static boolean Example3() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure() {
			public Object value_(Object value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.backAndForth();
		tracker.open();

		return true;
	}

	/**
	 * Example3.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3_g() {
		JunTrackerModel tracker = new JunTrackerModel();
		tracker.compute_(new StBlockClosure1<Void, Double>() {
			public Void value(Double value) {
				System.out.println(value);
				return null;
			}
		});
		tracker.backAndForth();
		tracker.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunTrackerModelTestExamples();
	}
}
