package jp.co.sra.jun.goodies.utilities;

import java.io.File;

import jp.co.sra.jun.system.framework.JunAbstractObject;

/**
 * JunFileUtility class
 * 
 *  @author    Mitsuhiro Asada
 *  @created   2007/03/14 (by m-asada)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFileUtility.java,v 9.8 2010/03/09 09:17:27 nisinaka Exp $
 */
public class JunFileUtility extends JunAbstractObject  {
	/**
	 * Answer the extension string of the specified file.
	 * 
	 * @param aFile java.io.File
	 * @return java.lang.String
	 * @category Utilities
	 */
	public static String ExtensionStringOf_(File aFile) {
		String aString = aFile.getPath();
		int index = aString.lastIndexOf('.');
		if (index < 0) {
			return null;
		}
		return aString.substring(index + 1).toLowerCase();
	}

}
