package jp.co.sra.jun.graphics.navigator;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Rectangle;

import jp.co.sra.jun.graphics.list.JunFileList;
import jp.co.sra.jun.graphics.list.JunSequenceListViewSwing;

/**
 * JunEmbeddedFileListViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2004/02/05 (by nisinaka)
 *  @updated   2006/11/29 (by m-asada)
 *  @version   758 (with StPL9.7) based on Jun638 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunEmbeddedFileListViewSwing.java,v 9.8 2010/03/09 09:17:30 nisinaka Exp $
 */
public class JunEmbeddedFileListViewSwing extends JunSequenceListViewSwing {
	/**
	 * Create a new instance of <code>JunEmbeddedFileListViewSwing</code> and initialize it.
	 * 
	 * @param aModel jp.co.sra.jun.graphics.navigator.JunEmbeddedFileList
	 * @category Instance creation
	 */
	public JunEmbeddedFileListViewSwing(JunEmbeddedFileList aModel) {
		super(aModel);
	}

	/**
	 * Display the canvas part of the receiver on the graphics.
	 * 
	 * @param aGraphics java.awt.Graphics
	 * @see jp.co.sra.jun.graphics.framework.JunGraphicViewSwing#displayCanvasOn_(java.awt.Graphics)
	 * @category displaying
	 */
	protected void displayCanvasOn_(Graphics aGraphics) {
		super.displayCanvasOn_(aGraphics);

		if (((JunFileList) this.model()).isNull()) {
			Color originalColor = aGraphics.getColor();
			try {
				Rectangle bounds = this.canvas().getBounds();
				aGraphics.setColor(Color.black);
				aGraphics.drawLine(bounds.x + bounds.width, bounds.y, bounds.x, bounds.y + bounds.height);
			} finally {
				aGraphics.setColor(originalColor);
			}
		}
	}
}
