package jp.co.sra.jun.graphics.navigator;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunFileRequesterTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2004/04/09 (by nisinaka)
 *  @updated   2006/11/29 (by m-asada)
 *  @updated   2008/10/16 (by m-asada)
 *  @version   758 (with StPL9.7) based on Jun706 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunFileRequesterTestExamples.java,v 9.9 2010/03/09 09:17:30 nisinaka Exp $
 */
public class JunFileRequesterTestExamples extends JunTestExamples {
	/**
	 * Example: Open a new file requester.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example() {
		JunFileRequester fileRequester = new JunFileRequester();
		fileRequester.open();
		return true;
	}

	/**
	 * Example: Open a old file requester.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunFileRequester fileRequester = JunFileRequester.OldFile();
		fileRequester.open();
		return true;
	}

	/**
	 * Example: Open a old directory requester.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunFileRequester fileRequester = JunFileRequester.OldDirectory();
		fileRequester.open();
		return true;
	}

	/**
	 * Example: Open a new file requester.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		JunFileRequester fileRequester = JunFileRequester.NewFile();
		fileRequester.open();
		return true;
	}

	/**
	 * Example: Open a new directory requester.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example4() {
		JunFileRequester fileRequester = JunFileRequester.NewDirectory();
		fileRequester.open();
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunFileRequesterTestExamples();
	}
}
