package jp.co.sra.jun.metaball.atoms;

import jp.co.sra.smalltalk.StBlockClosure;
import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.metaball.abstracts.JunMetaball;

/**
 * JunBlockMetaball class
 * 
 *  @author    nishihara
 *  @created   1999/11/05 (by nishihara)
 *  @updated   2008/05/26 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunBlockMetaball.java,v 9.9 2010/03/09 09:17:31 nisinaka Exp $
 */
public class JunBlockMetaball extends JunMetaball {

	protected StBlockClosure1<Double, Jun3dPoint> block = null;

	/**
	 * Answer the block.
	 * 
	 * @return jp.co.sra.smalltalk.StBlockClosure
	 * @category accessing
	 */
	protected StBlockClosure1<Double, Jun3dPoint> block() {
		return block;
	}

	/**
	 * Set the block.
	 * 
	 * @param valueBlock jp.co.sra.smalltalk.StBlockClosure1
	 * @category accessing
	 */
	protected void block_(StBlockClosure1<Double, Jun3dPoint> valueBlock) {
		block = valueBlock;
	}

	/**
	 * Set the block.
	 * 
	 * @param valueBlock jp.co.sra.smalltalk.StBlockClosure
	 * @category accessing
	 * @deprecated since Jun701, use Generics.
	 */
	protected void block_(final StBlockClosure<?, ?, ?, ?> valueBlock) {
		this.block_(new StBlockClosure1<Double, Jun3dPoint>() {
			public Double value(Jun3dPoint aPoint) {
				return (Double) valueBlock.value_(aPoint);
			}
		});
	}

	/**
	 * Answer a value at the specified point.
	 * 
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @return double
	 */
	public double valueAt_(Jun3dPoint aJun3dPoint) {
		return this.block().value(aJun3dPoint);
	}

}
