package jp.co.sra.jun.obj;

import java.io.PrintWriter;
import java.io.StringWriter;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunMTLParserTestExamples class
 * 
 *  @author    Albert Kerssies
 *  @created   2009/03/26 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun721 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMTLParserTestExamples.java,v 9.6 2010/03/09 09:17:32 nisinaka Exp $
 */
public class JunMTLParserTestExamples extends JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunMTLParser.Parse_(ColoredBoxMaterial());

		return true;
	}

	/**
	 * Create a sample string of OBJ format.
	 * 
	 * @return java.lang.String
	 * @category Examples
	 */
	protected static String ColoredBoxMaterial() {
		StringWriter sw = new StringWriter();
		PrintWriter pw = new PrintWriter(sw);
		pw.println("# Wavefront Material file");
		pw.println("# coloredBox.mtl");
		pw.println("#");
		pw.println();
		pw.println("newmtl Red");
		pw.println("Ka 0.000000 0.000000 0.000000");
		pw.println("Kd 1.000000 0.000000 0.000000");
		pw.println("Ks 0.330000 0.330000 0.330000");
		pw.println();
		pw.println("newmtl DarkTurquoise");
		pw.println("Ka 0.000000 0.000000 0.000000");
		pw.println("Kd 0.000000 0.807843 0.819608");
		pw.println("Ks 0.330000 0.330000 0.330000");
		pw.println();
		pw.println("newmtl DarkSlateGray");
		pw.println("Ka 0.000000 0.000000 0.000000");
		pw.println("Kd 0.184314 0.309804 0.309804");
		pw.println("Ks 0.330000 0.330000 0.330000");

		return sw.toString();
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunMTLParserTestExamples();
	}

}
