package jp.co.sra.jun.obj;

import jp.co.sra.smalltalk.StObject;

/**
 * JunOBJAbstractGroup class
 * 
 *  @author    Albert Kerssies
 *  @created   2009/03/26 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun732 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOBJAbstractGroup.java,v 9.6 2010/03/09 09:17:32 nisinaka Exp $
 */
public abstract class JunOBJAbstractGroup extends StObject {

	protected String name;

	/**
	 * Create a new instance of JunOBJAbstractGroup and initialize it.
	 *
	 * @param aString
	 * @category Instance creation
	 */
	public JunOBJAbstractGroup(String aString) {
		this.initialize();
		this.name_(aString);
	}

	/**
	 * Initialize the receiver.
	 * 
	 * @category initialize-release
	 */
	protected void initialize() {
		name = null;
	}

	/**
	 * Answer my current name.
	 * 
	 * @return java.lang.String
	 * @category accessing
	 */
	public String name() {
		return name;
	}

	/**
	 * Set my new name.
	 * 
	 * @param aString java.lang.String
	 * @category accessing
	 */
	public void name_(String aString) {
		name = aString;
	}

}
