package jp.co.sra.jun.obj;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * JunOBJFaceGroup class
 * 
 *  @author    Albert Kerssies
 *  @created   2009/08/18 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun732 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOBJFaceGroup.java,v 9.3 2010/03/09 09:17:32 nisinaka Exp $
 */
public class JunOBJFaceGroup extends JunOBJAbstractGroup {

	protected Map<String, List<List<int[]>>> faces;

	/**
	 * Create a new instance of JunOBJFaceGroup and initialize it.
	 *
	 * @param aString
	 * @category Instance creation
	 */
	public JunOBJFaceGroup(String aString) {
		super(aString);
	}

	/**
	 * Initialize the receiver.
	 * 
	 * @see jp.co.sra.jun.obj.JunOBJAbstractGroup#initialize()
	 */
	@Override
	protected void initialize() {
		super.initialize();
		faces = new HashMap<String, List<List<int[]>>>();
	}

	/**
	 * Answer my current faces.
	 * 
	 * @return java.util.Map<String, List<int[]>>
	 * @category accessing
	 */
	public Map<String, List<List<int[]>>> faces() {
		return faces;
	}

	/**
	 * Add the face elements with the name.
	 * 
	 * @param faceElements java.util.List<int[]>
	 * @param name java.lang.String
	 * @category adding
	 */
	public void add_for_(List<int[]> faceElements, String name) {
		if (faces.containsKey(name) == false) {
			faces.put(name, new ArrayList<List<int[]>>());
		}
		faces.get(name).add(faceElements);
	}

}
