package jp.co.sra.jun.octree.basic;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.geometry.boundaries.Jun3dBoundingBox;

/**
 * JunOctreeTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1999/12/21 (by nisinaka)
 *  @updated   2008/05/27 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOctreeTestExamples.java,v 9.9 2010/03/09 09:17:32 nisinaka Exp $
 */
public class JunOctreeTestExamples extends jp.co.sra.jun.system.support.JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		final Jun3dPoint center = new Jun3dPoint(0, 0, 0);
		final double radius = 1.0;
		Jun3dBoundingBox bounds = Jun3dBoundingBox.Origin_corner_(new Jun3dPoint(-2, -2, -2), new Jun3dPoint(2, 2, 2));
		JunOctree octree = JunOctree.FromBlock_depth_bounds_(new StBlockClosure1<Double, Jun3dPoint>() {
			public Double value(Jun3dPoint point) {
				return radius - point.distance_(center);
			}
		}, 6, bounds);
		octree.show();

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunOctree octree = JunOctree.Bounds_(Jun3dBoundingBox.Origin_corner_(new Jun3dPoint(-2, -2, -2), new Jun3dPoint(2, 2, 2)));
		octree.edit();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 */
	public static void main(java.lang.String[] args) {
		new JunOctreeTestExamples();
	}
}
