package jp.co.sra.jun.opengl.catalog;

import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunOpenGLCatalogElementTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2009/06/16 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun771 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLCatalogElementTestExamples.java,v 9.3 2010/03/09 09:17:34 nisinaka Exp $
 */
public class JunOpenGLCatalogElementTestExamples extends JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunOpenGL3dObject displayObject = JunOpenGL3dObject.SmalltalkCube();
		JunOpenGLCatalogElement catalogElement = new JunOpenGLCatalogElement(displayObject);
		System.out.println(catalogElement.toLispList().saveString());

		JunOpenGLCatalogViewer catalogViewer = new JunOpenGLCatalogViewer();
		catalogElement.applyPreferencesTo_(catalogViewer);
		catalogViewer.open();

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunOpenGL3dObject displayObject = JunOpenGL3dObject.Benzene();
		JunOpenGLCatalogElement catalogElement = new JunOpenGLCatalogElement(displayObject);
		catalogElement = new JunOpenGLCatalogElement(catalogElement.toLispList());
		System.out.println(catalogElement.toLispList().saveString());

		JunOpenGLCatalogViewer catalogViewer = new JunOpenGLCatalogViewer();
		catalogElement.applyPreferencesTo_(catalogViewer);
		catalogViewer.open();

		return true;
	}

	/**
	 * Execute the examples
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunOpenGLCatalogElementTestExamples();
	}

}
