package jp.co.sra.jun.opengl.catalog;

import java.util.ArrayList;

import jp.co.sra.smalltalk.StBlockClosure1;

import jp.co.sra.jun.goodies.progress.JunProgress;
import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunOpenGLCatalogModelTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2009/06/18 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun771 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLCatalogModelTestExamples.java,v 9.3 2010/03/09 09:17:34 nisinaka Exp $
 */
public class JunOpenGLCatalogModelTestExamples extends JunTestExamples {

	/**
	 * Example:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example() {
		JunOpenGLCatalogModel aCatalog = new JunOpenGLCatalogModel();
		aCatalog.open();

		return true;
	}

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		final JunOpenGL3dObject[] objects = new JunOpenGL3dObject[] {
				JunOpenGL3dObject.ColorCube(),
				JunOpenGL3dObject.ColorCone(),
				JunOpenGL3dObject.ColorBall_(3),
				JunOpenGL3dObject.Torus(),
				JunOpenGL3dObject.Mobius(),
				JunOpenGL3dObject.MobiusStrip(),
				JunOpenGL3dObject.SoccerBall(),
				JunOpenGL3dObject.SmalltalkCube(),
				JunOpenGL3dObject.Benzene(),
				JunOpenGL3dObject.Alanine(),
				JunOpenGL3dObject.Cystine(),
				JunOpenGL3dObject.Earth() };

		final ArrayList<JunOpenGLCatalogElement> catalogElements = new ArrayList<JunOpenGLCatalogElement>(objects.length);
		new JunProgress().do_(new StBlockClosure1<Void, JunProgress>() {
			public Void value(JunProgress progress) {
				for (int i = 0; i < objects.length; i++) {
					progress.message_($String("makgin <1p>...", null, objects[i].name()));

					objects[i].boundingBox(); // ?
					JunOpenGLCatalogElement catalogElement = new JunOpenGLCatalogElement(objects[i]);
					catalogElements.add(catalogElement);

					progress.value_(((float) i) / objects.length);
				}
				return null;
			}
		});

		JunOpenGLCatalogModel aCatalog = new JunOpenGLCatalogModel(catalogElements);
		aCatalog.open();

		JunOpenGLCatalogViewer[] viewers = aCatalog.viewers().toArray(new JunOpenGLCatalogViewer[aCatalog.numberOfViewers()]);
		for (int i = 0; i <= 2; i++) {
			viewers[i].displayLightsAllOff();
			viewers[i].applyPreferencesToElement();
		}

		return true;
	}

	/**
	 * Execute the examples
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunOpenGLCatalogModelTestExamples();
	}

}
