package jp.co.sra.jun.opengl.catalog;

import java.awt.Component;

import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunOpenGLCatalogView interface
 * 
 *  @author    nisinaka
 *  @created   2009/06/17 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun771 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLCatalogView.java,v 9.3 2010/03/09 09:17:34 nisinaka Exp $
 */
public interface JunOpenGLCatalogView extends JunAbstractView {

	/**
	 * Answer my model as JunOpenGLCatalogModel.
	 * 
	 * @return jp.co.sra.jun.opengl.catalog.JunOpenGLCatalogModel
	 * @category model accessing
	 */
	public JunOpenGLCatalogModel getOpenGLCatalogModel();

	/**
	 * Answer my catalog composite as a component.
	 * 
	 * @return java.awt.Component
	 * @category accessing
	 */
	public Component getCatalogCompositeComponent();

	/**
	 * Answer my catalog viewer views.
	 * 
	 * @return jp.co.sra.jun.opengl.catalog.JunOpenGLCatalogViewerView[]
	 * @category accessing
	 */
	public JunOpenGLCatalogViewerView[] getCatalogViewerViews();

}
