package jp.co.sra.jun.opengl.catalog;

import java.awt.Dimension;

import jp.co.sra.smalltalk.StController;
import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.opengl.display.JunOpenGLDisplayViewSwing;

/**
 * JunOpenGLCatalogViewerViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2009/06/17 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun727 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLCatalogViewerViewSwing.java,v 9.3 2010/03/09 09:17:34 nisinaka Exp $
 */
public class JunOpenGLCatalogViewerViewSwing extends JunOpenGLDisplayViewSwing implements JunOpenGLCatalogViewerView {

	/**
	 * Create a new instance of JunOpenGLCatalogViewerViewSwing and initialize it.
	 *
	 * @param anOpenGLCatalogViewer jp.co.sra.jun.opengl.catalog.JunOpenGLCatalogViewer
	 * @category Instance creation
	 */
	public JunOpenGLCatalogViewerViewSwing(JunOpenGLCatalogViewer anOpenGLCatalogViewer) {
		super(anOpenGLCatalogViewer);
	}

	/**
	 * Build the component.
	 * 
	 * @see jp.co.sra.jun.opengl.display.JunOpenGLDisplayViewSwing#buildComponent()
	 * @category initialize-release
	 */
	@Override
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.getOpenGLDrawable().toComponent(), WindowSpecLayout.Position(0f, 1, 0f, 1, 1f, -1, 1f, -1));
		this.setPreferredSize(new Dimension(300, 300));
		this.setLightWeightPopupEnabled(false);
	}

	/**
	 * Answer my model as JunOpenGLCatalogViewer.
	 * 
	 * @return jp.co.sra.jun.opengl.catalog.JunOpenGLCatalogViewer
	 * @see jp.co.sra.jun.opengl.catalog.JunOpenGLCatalogViewerView#getOpenGLCatalogViewer()
	 * @category model accessing
	 */
	public JunOpenGLCatalogViewer getOpenGLCatalogViewer() {
		return (JunOpenGLCatalogViewer) this.model();
	}

	/**
	 * Answer my default controller.
	 * 
	 * @return jp.co.sra.smalltalk.StController
	 * @see jp.co.sra.jun.opengl.display.JunOpenGLDisplayViewSwing#defaultController()
	 * @category controller accessing
	 */
	@Override
	protected StController defaultController() {
		return new JunOpenGLCatalogViewerController();
	}

}
