package jp.co.sra.jun.opengl.chart;

import java.util.Vector;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunChartDataTestExamples class
 * 
 *  @author    nisinaka
 *  @created   1998/11/19 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunChartDataTestExamples.java,v 9.9 2010/03/09 09:17:34 nisinaka Exp $
 */
public class JunChartDataTestExamples extends JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 */
	public static boolean Example1() {
		JunChartData newChartData = new JunChartData(SampleSamples());
		System.out.println(newChartData.printString());

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 */
	public static boolean Example2() {
		JunChartData newChartData = new JunChartData(SampleSamples2());
		System.out.println(newChartData.printString());

		return true;
	}

	/**
	 * Example3:
	 * 
	 * @return boolean
	 */
	public static boolean Example3() {
		JunChartData newChartData = new JunChartData(SampleSamples3(), 1);
		System.out.println(newChartData.printString());

		return true;
	}

	/**
	 * Sample data.
	 * 
	 * @return java.util.Vector
	 */
	protected static Vector<Vector<Object[]>> SampleSamples() {
		Vector<Vector<Object[]>> samples = new Vector<Vector<Object[]>>();

		Object[] anArray1 = { new Integer(1), new Integer(10), new Integer(10) };
		Object[] anArray2 = { new Integer(2), new Integer(20), new Integer(40) };
		Object[] anArray3 = { new Integer(3), new Integer(40), new Integer(120) };
		Object[] anArray4 = { new Integer(4), new Integer(80), new Integer(320) };
		Vector<Object[]> sample = new Vector<Object[]>(4);
		sample.addElement(anArray1);
		sample.addElement(anArray2);
		sample.addElement(anArray3);
		sample.addElement(anArray4);

		samples.addElement(sample);
		return samples;
	}

	/**
	 * Sample data 2.
	 * 
	 * @return java.util.Vector
	 */
	protected static Vector<Vector<Object[]>> SampleSamples2() {
		Vector<Vector<Object[]>> samples = SampleSamples();

		Object[] anArray1 = { new Integer(1), new Integer(80), new Integer(320) };
		Object[] anArray2 = { new Integer(2), new Integer(40), new Integer(120) };
		Object[] anArray3 = { new Integer(3), new Integer(20), new Integer(40) };
		Object[] anArray4 = { new Integer(4), new Integer(10), new Integer(10) };
		Vector<Object[]> sample = new Vector<Object[]>(4);
		sample.addElement(anArray1);
		sample.addElement(anArray2);
		sample.addElement(anArray3);
		sample.addElement(anArray4);

		samples.addElement(sample);
		return samples;
	}

	/**
	 * Sample data.
	 * 
	 * @return java.util.Vector
	 */
	protected static Vector<Vector<Object[]>> SampleSamples3() {
		Vector<Vector<Object[]>> samples = new Vector<Vector<Object[]>>();

		Object[] anArray1 = { "April", new Integer(10), new Integer(10) };
		Object[] anArray2 = { "May", new Integer(20), new Integer(40) };
		Object[] anArray3 = { "June", new Integer(40), new Integer(120) };
		Object[] anArray4 = { "July", new Integer(80), new Integer(320) };
		Vector<Object[]> sample = new Vector<Object[]>(4);
		sample.addElement(anArray1);
		sample.addElement(anArray2);
		sample.addElement(anArray3);
		sample.addElement(anArray4);

		samples.addElement(sample);
		return samples;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunChartDataTestExamples();
	}

}
