package jp.co.sra.jun.opengl.cosmos;

import java.awt.Dimension;

import jp.co.sra.smalltalk.StController;
import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.goodies.button.JunButtonViewAwt;
import jp.co.sra.jun.goodies.wheels.JunThumbWheelViewAwt;
import jp.co.sra.jun.opengl.display.JunOpenGLDisplayViewAwt;

/**
 * JunOpenGLMicrocosmViewAwt class
 * 
 *  @author    nisinaka
 *  @created   1999/08/17 (by nisinaka)
 *  @updated   2002/11/14 (by nisinaka)
 *  @updated   2003/05/15 (by nisinaka)
 *  @updated   2004/09/22 (by nisinaka)
 *  @updated   2007/08/27 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun465 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLMicrocosmViewAwt.java,v 9.9 2010/03/09 09:17:35 nisinaka Exp $
 */
public class JunOpenGLMicrocosmViewAwt extends JunOpenGLDisplayViewAwt implements JunOpenGLMicrocosmView {

	/**
	 * Create a new instance of <code>JunOpenGLMicrocosmViewAwt</code> and initialize it.
	 * 
	 * @param anOpenGLMicrocosmModel jp.co.sra.jun.opengl.cosmos.JunOpenGLMicrocosmModel
	 * @category Instance creation
	 */
	public JunOpenGLMicrocosmViewAwt(JunOpenGLMicrocosmModel anOpenGLMicrocosmModel) {
		super(anOpenGLMicrocosmModel);
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewPanel#buildComponent()
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.createOpenGLDrawableOnBorderedPanel(), WindowSpecLayout.Position(0f, 20, 0f, 1, 1f, -20, 1f, -20));
		this.add(new JunButtonViewAwt(this.getOpenGLDisplayModel().pickButton()), WindowSpecLayout.Position(0f, 1, 0f, 1, 0f, 19, 0f, 19));
		this.add(new JunButtonViewAwt(this.getOpenGLDisplayModel().grabButton()), WindowSpecLayout.Position(0f, 1, 0f, 20, 0f, 19, 0f, 38));
		this.add(new JunButtonViewAwt(this.getOpenGLDisplayModel().dragButton()), WindowSpecLayout.Position(0f, 1, 0f, 39, 0f, 19, 0f, 57));
		this.add(new JunThumbWheelViewAwt(this.getOpenGLDisplayModel().xThumbWheel()), WindowSpecLayout.Position(0f, 1, 0.5f, -61, 0f, 19, 0.5f, 61));
		this.add(new JunThumbWheelViewAwt(this.getOpenGLDisplayModel().yThumbWheel()), WindowSpecLayout.Position(0.5f, -61, 1f, -19, 0.5f, 61, 1f, -1));
		this.add(new JunThumbWheelViewAwt(this.getOpenGLDisplayModel().zThumbWheel()), WindowSpecLayout.Position(1f, -19, 0.5f, -61, 1f, -1, 0.5f, 61));
		this.add(new JunButtonViewAwt(this.getOpenGLDisplayModel().dollyButton()), WindowSpecLayout.Position(1f, -19, 0.5f, 62, 1f, -1, 0.5f, 80));
		this.setPreferredSize(new Dimension(300, 300));
	}

	/**
	 * Answer my model as JunOpenGLMicrocosmModel.
	 * 
	 * @return jp.co.sra.jun.opengl.cosmos.JunOpenGLMicrocosmModel
	 * @see jp.co.sra.jun.opengl.cosmos.JunOpenGLMicrocosmView#getOpenGLMicrocosmModel()
	 * @category model accessing
	 */
	public JunOpenGLMicrocosmModel getOpenGLMicrocosmModel() {
		return (JunOpenGLMicrocosmModel) this.model();
	}

	/**
	 * Answer a default controller.
	 * 
	 * @return jp.co.sra.smalltalk.StController
	 * @see jp.co.sra.smalltalk.StViewPanel#defaultController()
	 * @category controller accessing
	 */
	protected StController defaultController() {
		return new JunOpenGLMicrocosmController();
	}

}
