package jp.co.sra.jun.opengl.display;

import java.util.List;
import java.util.Map;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.opengl.support.JunOpenGLDrawable;
import jp.co.sra.jun.system.framework.JunAbstractView;

/**
 * JunOpenGL3dView interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   2000/01/10 (by MATSUDA Ryouichi)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2004/12/02 (by Mitsuhiro Asada)
 *  @updated   2006/10/04 (by nisinaka)
 *  @updated   2006/10/16 (by m-asada)
 *  @updated   2007/08/23 (by nisinaka)
 *  @updated   2008/05/21 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun623 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGL3dView.java,v 9.9 2010/03/09 09:17:36 nisinaka Exp $
 */
public interface JunOpenGL3dView extends JunAbstractView {

	/**
	 * Answer my model as JunOpenGL3dModel.
	 * 
	 * @return jp.kidresearch.art.opengl.JunOpenGL3dModel
	 * @category model accessing
	 */
	public JunOpenGL3dModel getOpenGL3dModel();

	/**
	 * Answer my OpenGL drawable.
	 * 
	 * @return jp.co.sra.jun.opengl.support.JunOpenGLDrawable
	 * @category accessing
	 */
	public JunOpenGLDrawable getOpenGLDrawable();

	/**
	 * Convert the model points to the view 3D points sorted by Z.
	 * 
	 * @param modelPoints jp.co.sra.jun.geometry.basic.Jun3dPoint[]
	 * @return java.util.List
	 * @category converting
	 */
	public List<Map.Entry<Double, Jun3dPoint[]>> convertModelPointsToView3dPointsSortedByZ_(Jun3dPoint[] modelPoints);

}
