package jp.co.sra.jun.opengl.display;

import java.awt.Dimension;

import jp.co.sra.smalltalk.WindowSpecLayout;

import jp.co.sra.jun.system.framework.JunAbstractViewPanel;

/**
 * JunOpenGLDisplayObjectsViewAwt class
 * 
 *  @author    nisinaka
 *  @created   2006/07/25 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun682 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLDisplayObjectsViewAwt.java,v 9.10 2010/03/09 09:17:36 nisinaka Exp $
 */
public class JunOpenGLDisplayObjectsViewAwt extends JunAbstractViewPanel implements JunOpenGLDisplayObjectsView {

	protected JunOpenGLDisplayViewAwt viewfinder;
	protected JunOpenGLTypicalObjectsViewAwt methodList;

	/**
	 * Create a new instance of JunOpenGLDisplayObjectsViewAwt and initialize it.
	 *
	 * @param anOpenGLDisplayObjects jp.co.sra.jun.opengl.display.JunOpenGLDisplayObjects
	 * @category Instance creation
	 */
	public JunOpenGLDisplayObjectsViewAwt(JunOpenGLDisplayObjects anOpenGLDisplayObjects) {
		super(anOpenGLDisplayObjects);
	}

	/**
	 * Build this component.
	 * 
	 * @see jp.co.sra.smalltalk.StViewJPanel#buildComponent()
	 * @category initialize-release
	 */
	protected void buildComponent() {
		this.setLayout(new WindowSpecLayout());
		this.add(this.viewfinder(), WindowSpecLayout.Position(0f, 0, 0f, 0, 1f, -200, 1f, 0));
		this.add(this.methodList(), WindowSpecLayout.Position(1f, -200, 0f, 0, 1f, 0, 1f, 0));
		this.setPreferredSize(new Dimension(500, 300));
	}

	/**
	 * Answer my model as JunOpenGLDisplayObjects.
	 * 
	 * @return jp.co.sra.jun.opengl.display.JunOpenGLDisplayObjects
	 * @see jp.co.sra.jun.opengl.display.JunOpenGLDisplayObjectsView#getOpenGLDisplayObjects()
	 * @category model accessing
	 */
	public JunOpenGLDisplayObjects getOpenGLDisplayObjects() {
		return (JunOpenGLDisplayObjects) this.model();
	}

	/**
	 * Answer the viewfinder.
	 * 
	 * @return jp.co.sra.jun.opengl.display.JunOpenGLDisplayViewAwt
	 * @category user interface
	 */
	protected JunOpenGLDisplayViewAwt viewfinder() {
		if (viewfinder == null) {
			viewfinder = new JunOpenGLDisplayViewAwt(this.getOpenGLDisplayObjects());
		}
		return viewfinder;
	}

	/**
	 * Answer the method list.
	 * 
	 * @return jp.co.sra.jun.opengl.display.JunOpenGLTypicalObjectsViewAwt
	 * @category user interface
	 */
	protected JunOpenGLTypicalObjectsViewAwt methodList() {
		if (methodList == null) {
			methodList = new JunOpenGLTypicalObjectsViewAwt(this.getOpenGLDisplayObjects().typicalObjects());
		}
		return methodList;
	}

}
