package jp.co.sra.jun.opengl.parameterizedbody;

import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.topology.elements.JunBody;

/**
 * JunParameterizedOrPaintedBody interface
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/01/07 (MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunParameterizedOrPaintedBody.java,v 9.9 2010/03/09 09:17:42 nisinaka Exp $
 */
public interface JunParameterizedOrPaintedBody {
	/**
	 * Convert the receiver to a JunOpenGL3dObject.
	 * 
	 * @return jp.co.sra.jun.opengl.objects.JunOpenGL3dObject
	 * @category converting
	 */
	public JunOpenGL3dObject asJunOpenGL3dObject();

	/**
	 * Answer a body.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunBody
	 * @category accessing
	 */
	public JunBody body();
}
