package jp.co.sra.jun.opengl.projection;

import java.awt.Color;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.opengl.display.JunOpenGLDisplayModel;
import jp.co.sra.jun.opengl.lights.JunOpenGLParallelLight;
import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.opengl.support.JunOpenGLRenderingContext;

/**
 * JunOpenGLProjectorTestExamples class
 * 
 *  @author    MATSUDA Ryouichi
 *  @created   1999/04/08 (MATSUDA Ryouichi)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun725 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLProjectorTestExamples.java,v 9.10 2010/03/09 09:17:43 nisinaka Exp $
 */
public class JunOpenGLProjectorTestExamples extends jp.co.sra.jun.system.support.JunTestExamples {

	/**
	 * ManualExample1a:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean ManualExample1a() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aProjector.wireframePresentation();
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aRenderingContext.flush();
			}
		}.open();

		return true;
	}

	/**
	 * ManualExample1b:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean ManualExample1b() {
		new JunOpenGLDisplayModel() {
			public void renderOn_(JunOpenGLRenderingContext aRenderingContext) {
				JunOpenGLProjector aProjector;
				JunOpenGL3dObject aGlobe;
				JunOpenGLParallelLight aParallelLight;

				aRenderingContext.clear();
				aProjector = new JunOpenGLProjector();
				aProjector.eyePoint_(new Jun3dPoint(5, 5, 5));
				aProjector.sightPoint_(new Jun3dPoint(0, 0, 0));
				aProjector.upVector_(new Jun3dPoint(0, 0, 1));
				aGlobe = JunOpenGL3dObject.Globe();
				aGlobe.paint_(Color.magenta);
				aParallelLight = JunOpenGLParallelLight.At3dPoint_color_(new Jun3dPoint(1.0, 1.0, 1.0), Color.lightGray);
				aProjector.addLight_(aParallelLight);
				aProjector.project_on_(aGlobe, aRenderingContext);
				aRenderingContext.flush();
			}
		}.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunOpenGLProjectorTestExamples();
	}

}
