package jp.co.sra.jun.opengl.support;

import java.awt.Graphics;

/**
 * JunOpenGLRenderer interface
 * 
 *  @author    nisinaka
 *  @created   2007/08/23 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunOpenGLRenderer.java,v 9.9 2010/03/09 09:17:45 nisinaka Exp $
 */
public interface JunOpenGLRenderer {

	/**
	 * Render the receiver on the drawable.
	 * 
	 * @param aDrawable jp.co.sra.jun.opengl.support.JunOpenGLDrawable
	 * @category rendering
	 */
	public void renderOn_(JunOpenGLDrawable aDrawable);

	/**
	 * Superimpose on the graphics.
	 * 
	 * @param aGraphics java.awt.Graphics
	 * @param aDrawable jp.co.sra.jun.opengl.support.JunOpenGLDrawable
	 * @category superimpose
	 */
	public void superimposeOn_(Graphics aGraphics, JunOpenGLDrawable aDrawable);

}
