package jp.co.sra.jun.system.framework;

import jp.co.sra.smalltalk.StBlockClosure0;
import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunDialogTestExamples class
 * 
 *  @author    
 *  @created   UNKNOWN
 *  @updated   2006/04/19 (by nisinaka)
 *  @updated   2008/05/15 (by Mitsuhiro Asada)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunDialogTestExamples.java,v 9.10 2010/03/09 09:17:48 nisinaka Exp $
 */
public class JunDialogTestExamples extends JunTestExamples {

	/**
	 * Example to choose.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example_choose() {
		System.out.println(JunDialog.Choose_($String("Are you tired yet?"), new String[] { "absolutely", "sort of", "not really" }, new Object[] { $("yes"), $("maybe"), $("no") }, $("maybe")));
		return true;
	}

	/**
	 * Example to choose from list.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example_chooseFromList() {
		System.out.println(JunDialog.Choose_($String("Which one do you want?"), new String[] { "first", "second", "third", "fourth" }, new Object[] { new Integer(1), new Integer(2), new Integer(3), new Integer(4) }, new String[] { "Frobits" },
				new Object[] { null }, 8, new StBlockClosure0<StSymbol>() {
					public StSymbol value() {
						return $("noChoice");
					}
				}));
		return true;
	}

	/**
	 * Example to confirm.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example_confirm() {
		System.out.println(JunDialog.Confirm_($String("Are you happy?")));
		return true;
	}

	/**
	 * Example to request.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example_request() {
		System.out.println(JunDialog.Request_($String("What is your name?"), $String("Yoshiyuki NISHINAKA")));
		return true;
	}

	/**
	 * Example to warn.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example_warn() {
		System.out.println(JunDialog.Warn_($String("This is a fatal error.")));
		return true;
	}

	/**
	 * Execute the test examples.
	 *
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunDialogTestExamples();
	}
}
