package jp.co.sra.jun.system.generics;

import jp.co.sra.jun.system.framework.JunAbstractObject;

/**
 * JunPairObject class
 * 
 *  @author    nisinaka
 *  @created   2008/05/21 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun??? for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunPairObject.java,v 1.10 2010/03/09 09:17:48 nisinaka Exp $
 */
public class JunPairObject<F, S> extends JunAbstractObject {

	protected F first;
	protected S second;

	/**
	 * Create a new instance of JunPairObject and initialize it.
	 *
	 * @param first java.lang.Object
	 * @param second java.lang.Object
	 * @category Instance creation
	 */
	public JunPairObject(F first, S second) {
		this.first = first;
		this.second = second;
	}

	/**
	 * Initialize the receiver.
	 * 
	 * @see jp.co.sra.jun.system.framework.JunAbstractObject#initialize()
	 * @category initialize-release
	 */
	@Override
	protected void initialize() {
		super.initialize();
		first = null;
		second = null;
	}

	/**
	 * Answer my first object.
	 * 
	 * @return java.lang.Object
	 * @category accessing
	 */
	public F first() {
		return first;
	}

	/**
	 * Answer my second object.
	 * 
	 * @return java.lang.Object
	 * @category accessing
	 */
	public S second() {
		return second;
	}

}
