package jp.co.sra.jun.system.generics;

/**
 * JunTrioObject class
 * 
 *  @author    nisinaka
 *  @created   2008/05/21 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun??? for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTrioObject.java,v 1.10 2010/03/09 09:17:48 nisinaka Exp $
 */
public class JunTrioObject<F, S, T> extends JunPairObject<F, S> {

	protected T third;

	/**
	 * Create a new instance of JunTrioObject and initialize it.
	 *
	 * @param first java.lang.Object
	 * @param second java.lang.Object
	 * @param third java.lang.Object
	 * @category Instance creation
	 */
	public JunTrioObject(F first, S second, T third) {
		super(first, second);
		this.third = third;
	}

	/**
	 * Initialize the receiver.
	 * 
	 * @see jp.co.sra.jun.system.generics.JunPairObject#initialize()
	 * @category initialize-release
	 */
	@Override
	protected void initialize() {
		super.initialize();
		third = null;
	}

	/**
	 * Answer my third object.
	 * 
	 * @return java.lang.Object
	 * @category accessing
	 */
	public T third() {
		return third;
	}

}
