package jp.co.sra.jun.terrain.editor;

import java.awt.Rectangle;

import jp.co.sra.jun.opengl.display.JunOpenGLDisplayView;

/**
 * JunTerrainEditView interface
 * 
 *  @author    nisinaka
 *  @created   2001/11/19 (by nisinaka)
 *  @updated   2004/09/21 (by nisinaka)
 *  @updated   2007/08/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun519 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTerrainEditView.java,v 9.8 2010/03/09 09:17:50 nisinaka Exp $
 */
public interface JunTerrainEditView extends JunOpenGLDisplayView {

	/**
	 * Answer my model as JunTerrainEditModel.
	 * 
	 * @return jp.co.sra.jun.terrain.editor.JunTerrainEditModel
	 * @category model accessing
	 */
	public JunTerrainEditModel getTerrainEditModel();

	/**
	 * Answer the bounds of the canvas area.
	 * 
	 * @return java.awt.Rectangle
	 * @category bounds accessing
	 */
	public Rectangle boundsOfCanvas();

}
