package jp.co.sra.jun.topology.abstracts;

/**
 * JunGeometricOperator class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunGeometricOperator.java,v 9.8 2010/03/09 09:17:52 nisinaka Exp $
 */
public abstract class JunGeometricOperator extends JunAbstractOperator {
	/**
	 * Answer <code>true</code> if the receiver is a kind of Geometric Operator, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#isGeometricOperator()
	 * @category testing
	 */
	public boolean isGeometricOperator() {
		return true;
	}

	/**
	 * Answer <code>true</code> if the receiver can be inverted, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#isInversable()
	 * @category testing
	 */
	public boolean isInversable() {
		return true;
	}
}
