package jp.co.sra.jun.topology.abstracts;

import jp.co.sra.jun.topology.elements.JunBody;

/**
 * JunGlobalOperator class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunGlobalOperator.java,v 9.8 2010/03/09 09:17:52 nisinaka Exp $
 */
public abstract class JunGlobalOperator extends JunAbstractOperator {
	/**
	 * Create a new instance of <code>JunGlobalOperator</code> and initialize it.
	 * 
	 * @category Instance creation
	 */
	public JunGlobalOperator() {
		super();
	}

	/**
	 * Create a new instance of <code>JunGlobalOperator</code> and initialize it with a body.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @category Instance creation
	 */
	public JunGlobalOperator(JunBody aBody) {
		super(aBody);
	}

	/**
	 * Answer <code>true</code> if the receiver is a kind of Global Operator, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#isGlobalOperator()
	 * @category testing
	 */
	public boolean isGlobalOperator() {
		return true;
	}

	/**
	 * Answer <code>true</code> if the receiver can be inverted, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#isInversable()
	 * @category testing
	 */
	public boolean isInversable() {
		return true;
	}
}
