package jp.co.sra.jun.topology.abstracts;

import jp.co.sra.jun.system.framework.JunAbstractObject;

/**
 * JunTopology class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun697 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunTopology.java,v 9.8 2010/03/09 09:17:53 nisinaka Exp $
 */
public abstract class JunTopology extends JunAbstractObject {
	/**
	 * Answer <code>true</code> if the receiver is a kind of topological proxy, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isGeometry() {
		return false;
	}

	/**
	 * Answer <code>true</code> if the receiver is a kind of geometry, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isTopologicalProxy() {
		return false;
	}

	/**
	 * Answer <code>true</code> if the receiver is a kind of topology, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @category testing
	 */
	public boolean isTopology() {
		return true;
	}
}
