package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.smalltalk.StBlockClosure2;

import jp.co.sra.jun.topology.abstracts.JunAbstractOperator;
import jp.co.sra.jun.topology.abstracts.JunEulerOperator;
import jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunEdgeProxy;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunVertex;
import jp.co.sra.jun.topology.elements.JunVertexProxy;

/**
 * JunKDEV class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   2008/05/23 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKDEV.java,v 9.9 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunKDEV extends JunEulerOperator {

	protected JunVertexProxy vertexProxy1;
	protected JunVertexProxy vertexProxy2;
	protected JunEdgeProxy edgeProxy1;
	protected JunEdgeProxy edgeProxy2;
	protected JunEdgeProxy edgeProxy3;

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKDEV
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKDEV Body_edge_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		return new JunKDEV(aJunBody, aJunEdgeOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKDEV
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKDEV Body_edge_adviseVertex_vertex_edge_edge_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunVertexOrProxy1, JunTopologicalElementOrProxy aJunVertexOrProxy2,
			JunTopologicalElementOrProxy aJunEdgeOrProxy1, JunTopologicalElementOrProxy aJunEdgeOrProxy2) {
		return new JunKDEV(aJunBody, aJunEdgeOrProxy, aJunVertexOrProxy1, aJunVertexOrProxy2, aJunEdgeOrProxy1, aJunEdgeOrProxy2);
	}

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKDEV
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKDEV Body_edge_killVertex_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunVertexOrProxy) {
		return new JunKDEV(aJunBody, aJunEdgeOrProxy, aJunVertexOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKDEV(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		super();
		this.body_(aJunBody);
		this.edge1_(aJunEdgeOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKDEV(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunVertexOrProxy) {
		super();
		this.body_(aJunBody);
		this.edge1_(aJunEdgeOrProxy);
		this.vertex1_(aJunVertexOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKDEV</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKDEV(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunVertexOrProxy1, JunTopologicalElementOrProxy aJunVertexOrProxy2, JunTopologicalElementOrProxy aJunEdgeOrProxy1,
			JunTopologicalElementOrProxy aJunEdgeOrProxy2) {
		super();
		this.body_(aJunBody);
		this.edge1_(aJunEdgeOrProxy);
		this.edge2_(aJunEdgeOrProxy1);
		this.edge3_(aJunEdgeOrProxy2);
		this.vertex1_(aJunVertexOrProxy1);
		this.vertex2_(aJunVertexOrProxy2);
	}

	/**
	 * Initialize the receiver when created.
	 * 
	 * @see jp.co.sra.jun.system.framework.JunAbstractObject#initialize()
	 * @category initialize-release
	 */
	protected void initialize() {
		super.initialize();

		vertexProxy1 = null;
		vertexProxy2 = null;
		edgeProxy1 = null;
		edgeProxy2 = null;
		edgeProxy3 = null;
	}

	/**
	 * Answer the receiver's edge1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge1() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy1);
	}

	/**
	 * Set the receiver's edge1.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge1_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy1 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy1);
	}

	/**
	 * Answer the receiver's edge2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge2() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy2);
	}

	/**
	 * Set the receiver's edge2.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge2_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy2 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy2);
	}

	/**
	 * Answer the receiver's edge3.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge3() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy3);
	}

	/**
	 * Set the receiver's edge3.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge3_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy3 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy3);
	}

	/**
	 * Execute the operation.
	 * 
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#execute()
	 * @category executing
	 */
	public void execute() {
		this.vertex1_(this.edge1().startVertex());
		this.vertex2_(this.edge1().endVertex());

		JunEdge[] edges = this.vertex1().edges();
		JunEdge fromEdge1 = this.edge1().prevEdgeWithVertex_(this.vertex1());
		JunEdge toEdge1 = this.edge1().nextEdgeWithVertex_(this.vertex1());
		JunEdge fromEdge2 = this.edge1().prevEdgeWithVertex_(this.vertex2());
		JunEdge toEdge2 = this.edge1().nextEdgeWithVertex_(this.vertex2());
		fromEdge1.setNextEdge_withVertex_(toEdge2, this.vertex1());
		fromEdge2.setNextEdge_withVertex_(toEdge1, this.vertex2());

		StBlockClosure2<Void, JunLoop, JunEdge> correctLoopBlock = new StBlockClosure2<Void, JunLoop, JunEdge>() {
			public Void value(JunLoop loop, JunEdge edge) {
				if (loop.edge() == JunKDEV.this.edge1()) {
					loop.edge_(edge);
				}
				return null;
			}
		};

		correctLoopBlock.value(this.edge1().loopToVertex_(this.vertex1()), toEdge1);
		correctLoopBlock.value(this.edge1().loopToVertex_(this.vertex2()), toEdge2);

		for (int i = 0; i < edges.length; i++) {
			JunEdge edge = edges[i];
			edge.setVertex_insteadOf_(this.vertex2(), this.vertex1());
		}

		this.edge2_(toEdge1);
		this.edge3_(toEdge2);

		if (this.vertex2().edge() == this.edge1()) {
			this.vertex2().edge_(fromEdge1);
		}

		this.edge1().forget();
		this.vertex1().forget();
		this.body().removeEdge_(this.edge1());
		this.body().removeVertex_(this.vertex1());
	}

	/**
	 * Answer the inverse operation of the receiver.
	 * 
	 * @return jp.co.sra.jun.topology.abstracts.JunAbstractOperator
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#inverse()
	 * @category inverting
	 */
	public JunAbstractOperator inverse() {
		return JunMDEV.Body_vertex_edge_edge_adviseEdge_vertex_(this.body(), vertexProxy2, edgeProxy2, edgeProxy3, edgeProxy1, vertexProxy1);
	}

	/**
	 * Answer the receiver's killed edge.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge killedEdge() {
		return this.edge1();
	}

	/**
	 * Answer the receiver's killed vertex.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex killedVertex() {
		return this.vertex1();
	}

	/**
	 * Answer <code>true</code> if the post-condition is valid, otherwise <code>false</code>
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#postcondition()
	 * @category executing
	 */
	public boolean postcondition() {
		return super.postcondition() && this.body().isConsistentWithElements();
	}

	/**
	 * Answer <code>true</code> if the pre-condition is valid, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#precondition()
	 * @category executing
	 */
	public boolean precondition() {
		return super.precondition() && (this.edge1() != null);
	}

	/**
	 * Answer the receiver's vertex1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex1() {
		return (JunVertex) this.getTopologicalElement_(vertexProxy1);
	}

	/**
	 * Set the receiver's vertex1.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex1_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy1 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy1);
	}

	/**
	 * Answer the receiver's vertex2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex2() {
		return (JunVertex) this.getTopologicalElement_(vertexProxy2);
	}

	/**
	 * Set the receiver's vertex2.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex2_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy2 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy2);
	}

}
