package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.smalltalk.SmalltalkException;

import jp.co.sra.jun.topology.abstracts.JunAbstractOperator;
import jp.co.sra.jun.topology.abstracts.JunEulerOperator;
import jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunEdgeProxy;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunLoopProxy;
import jp.co.sra.jun.topology.elements.JunVertex;
import jp.co.sra.jun.topology.elements.JunVertexProxy;

/**
 * JunKEL class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   1999/08/04 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKEL.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunKEL extends JunEulerOperator {
	protected JunEdgeProxy edgeProxy;
	protected JunLoopProxy loopProxy1;
	protected JunLoopProxy loopProxy2;
	protected JunVertexProxy vertexProxy1;
	protected JunVertexProxy vertexProxy2;
	protected JunEdgeProxy edgeProxy2;
	protected JunEdgeProxy edgeProxy3;

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKEL
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKEL Body_edge_(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		return new JunKEL(aBody, aJunEdgeOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKEL
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKEL Body_edge_adviseLoop_loop_vertex_vertex_(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunLoopOrProxy1, JunTopologicalElementOrProxy aJunLoopOrProxy2,
			JunTopologicalElementOrProxy aJunVertexOrProxy1, JunTopologicalElementOrProxy aJunVertexOrProxy2) {
		return new JunKEL(aBody, aJunEdgeOrProxy, aJunLoopOrProxy1, aJunLoopOrProxy2, aJunVertexOrProxy1, aJunVertexOrProxy2);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdge jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoop jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKEL
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKEL Body_edge_aliveLoop_(JunBody aJunBody, JunEdge aJunEdge, JunLoop aJunLoop) {
		return new JunKEL(aJunBody, aJunEdge, aJunLoop);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKEL
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunKEL Body_edge_killLoop_(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunLoopOrProxy) {
		return new JunKEL(aBody, aJunEdgeOrProxy, aJunLoopOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKEL(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		super();
		this.body_(aBody);
		this.edge_(aJunEdgeOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdge jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoop jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKEL(JunBody aJunBody, JunEdge aJunEdge, JunLoop aJunLoop) {
		super();
		this.body_(aJunBody);
		this.edge_(aJunEdge);
		this.loop2_(aJunLoop);
		this.loop1_((aJunEdge.oppositeLoopOfLoop_(aJunLoop)));
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunKEL(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunLoopOrProxy) {
		super();
		this.body_(aBody);
		this.edge_(aJunEdgeOrProxy);
		this.loop1_(aJunLoopOrProxy);
	}

	/**
	 * Create a new instance of <code>JunKEL</code> and initialize it.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunLoopOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunKEL
	 * @category Instance creation
	 */
	public JunKEL(JunBody aBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunLoopOrProxy1, JunTopologicalElementOrProxy aJunLoopOrProxy2, JunTopologicalElementOrProxy aJunVertexOrProxy1,
			JunTopologicalElementOrProxy aJunVertexOrProxy2) {
		super();
		this.body_(aBody);
		this.edge_(aJunEdgeOrProxy);
		this.loop1_(aJunLoopOrProxy1);
		this.loop2_(aJunLoopOrProxy2);
		this.vertex1_(aJunVertexOrProxy1);
		this.vertex2_(aJunVertexOrProxy2);
	}

	/**
	 * Initialize the receiver when created.
	 * 
	 * @see jp.co.sra.jun.system.framework.JunAbstractObject#initialize()
	 * @category initialize-release
	 */
	protected void initialize() {
		super.initialize();

		edgeProxy = null;
		loopProxy1 = null;
		loopProxy2 = null;
		vertexProxy1 = null;
		vertexProxy2 = null;
		edgeProxy2 = null;
		edgeProxy3 = null;
	}

	/**
	 * Answer the receiver's alive loop.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunLoop
	 * @category accessing
	 */
	public JunLoop aliveLoop() {
		return this.loop2();
	}

	/**
	 * Answer the receiver's edge.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy);
	}

	/**
	 * Set the receiver's edge.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy);
	}

	/**
	 * Answer the receiver's edge2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge2() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy2);
	}

	/**
	 * Set the receiver's edge2.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge2_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy2 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy2);
	}

	/**
	 * Answer the receiver's edge3.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge3() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy3);
	}

	/**
	 * Set the receiver's edge3.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge3_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy3 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy3);
	}

	/**
	 * Execute the operation.
	 * 
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#execute()
	 * @throws jp.co.sra.smalltalk.SmalltalkException
	 * @category executing
	 */
	public void execute() {
		if (this.loop1() == null) {
			this.loop1_(this.edge().leftLoop());
		}

		if (this.loop2() == null) {
			if (this.loop1() == this.edge().leftLoop()) {
				this.loop2_(this.edge().rightLoop());
			} else {
				this.loop2_(this.edge().leftLoop());
			}
		}

		if (this.vertex1() == null) {
			this.vertex1_(this.edge().directionVertexOnLoop_(this.loop2()));
		}

		if (this.vertex2() == null) {
			this.vertex2_(this.edge().oppositeVertexOfVertex_(this.vertex1()));
		}

		JunEdge[] edges = this.loop1().edges();
		JunEdge fromEdge1 = this.edge().prevEdgeWithVertex_(this.vertex1());
		JunEdge toEdge1 = this.edge().nextEdgeWithVertex_(this.vertex1());
		JunEdge fromEdge2 = this.edge().prevEdgeWithVertex_(this.vertex2());
		JunEdge toEdge2 = this.edge().nextEdgeWithVertex_(this.vertex2());
		this.edge2_(fromEdge1);
		this.edge3_(fromEdge2);
		fromEdge1.setNextEdge_withVertex_(toEdge1, this.vertex1());
		fromEdge2.setNextEdge_withVertex_(toEdge2, this.vertex2());

		for (int i = 0; i < edges.length; i++) {
			edges[i].setLoop_insteadOf_(this.loop2(), this.loop1());
		}

		if (this.loop2().edge().equals(this.edge())) {
			this.loop2().edge_(fromEdge1);
		}

		if (this.vertex1().edge().equals(this.edge())) {
			this.vertex1().edge_(fromEdge1);
		}

		if (this.vertex2().edge().equals(this.edge())) {
			this.vertex2().edge_(fromEdge2);
		}

		this.loop1().forget();
		this.edge().forget();
		this.body().removeLoop_(this.loop1());
		this.body().removeEdge_(this.edge());

		if ((fromEdge1.loopToVertex_(this.vertex1())).equals(this.loop2()) == false) {
			throw SmalltalkException.Error("internal error");
		}

		if ((fromEdge2.loopToVertex_(this.vertex2()).equals(this.loop2())) == false) {
			throw SmalltalkException.Error("internal error");
		}

		if ((fromEdge1.nextEdgeWithVertex_(this.vertex1())).equals(toEdge1) == false) {
			throw SmalltalkException.Error("internal error");
		}

		if (fromEdge2.nextEdgeWithVertex_(this.vertex2()).equals(toEdge2) == false) {
			throw SmalltalkException.Error("internal error");
		}
	}

	/**
	 * Answer the inverse operation of the receiver.
	 * 
	 * @return jp.co.sra.jun.topology.abstracts.JunAbstractOperator
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#inverse()
	 * @category inverting
	 */
	public JunAbstractOperator inverse() {
		return new JunMEL(this.body(), loopProxy2, vertexProxy1, vertexProxy2, edgeProxy, loopProxy1, edgeProxy2, edgeProxy3);
	}

	/**
	 * Answer the receiver's killed loop.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunLoop
	 * @category accessing
	 */
	public JunLoop killedLoop() {
		return this.loop1();
	}

	/**
	 * Answer the receiver's loop1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunLoop
	 * @category accessing
	 */
	public JunLoop loop1() {
		return (JunLoop) this.getTopologicalElement_(loopProxy1);
	}

	/**
	 * Set the receiver's loop1.
	 * 
	 * @param aJunLoopOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void loop1_(JunTopologicalElementOrProxy aJunLoopOrProxy) {
		loopProxy1 = (JunLoopProxy) this.getTopologicalElementProxy_advise_(aJunLoopOrProxy, loopProxy1);
	}

	/**
	 * Answer the receiver's loop2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunLoop
	 * @category accessing
	 */
	public JunLoop loop2() {
		return (JunLoop) this.getTopologicalElement_(loopProxy2);
	}

	/**
	 * Set the receiver's loop1.
	 * 
	 * @param aJunLoopOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void loop2_(JunTopologicalElementOrProxy aJunLoopOrProxy) {
		loopProxy2 = (JunLoopProxy) this.getTopologicalElementProxy_advise_(aJunLoopOrProxy, loopProxy2);
	}

	/**
	 * Answer <code>true</code> if the pre-condition is valid, otherwise <code>false</code>.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#precondition()
	 * @category executing
	 */
	public boolean precondition() {
		if (super.precondition() == false) {
			return false;
		}

		if (this.edge() == null) {
			return false;
		}

		if (this.edge().leftLoop().equals(this.edge().rightLoop())) {
			return false;
		}

		return true;
	}

	/**
	 * Answer the receiver's vertex1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex1() {
		return (JunVertex) getTopologicalElement_(this.vertexProxy1);
	}

	/**
	 * Set the receiver's vertex1.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex1_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy1 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy1);
	}

	/**
	 * Answer the receiver's vertex2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex2() {
		return (JunVertex) getTopologicalElement_(this.vertexProxy2);
	}

	/**
	 * Set the receiver's vertex2.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex2_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy2 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy2);
	}
}
