package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunVertex;

/**
 * JunKELTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   1999/07/29 (by BNR)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKELTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunKELTestExamples extends JunTestExamples {
	/**
	 * Examples.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunBody body = new JunBody();
		JunMEVVL mevvl = new JunMEVVL(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		System.out.println("-------- mevvl.doOperation();");
		mevvl.doOperation();
		JunLoop loop = mevvl.newLoop();
		JunVertex vertex100 = mevvl.vertex1();
		JunVertex vertex010 = mevvl.vertex2();
		System.out.println("-------- JunMEV");
		JunMEV mev = new JunMEV(body, vertex100, loop, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		JunVertex vertex000 = mev.newVertex();
		System.out.println("-------- JunMEL");
		JunMEL mel =new  JunMEL(body, mevvl.loop(), vertex010, vertex000);
		mel.doOperation();
		System.out.println("-------- JunKEL");
		JunKEL kel = new JunKEL(body, mel.newEdge());
		kel.doOperation();

		//not in Java: (#killedEdge )
		//in Java: (#killedLoop #aliveLoop 
		//    #vertex1 #vertex2 #edge2 #edge3)
		System.out.println("-------- #killedLoop");
		System.out.println(kel.killedLoop());
		System.out.println("\n-------- #aliveLoop");
		System.out.println(kel.aliveLoop());
		System.out.println("-------- #vertex1");
		System.out.println(kel.vertex1());
		System.out.println("\n-------- #vertex2");
		System.out.println(kel.vertex2());
		System.out.println("-------- #edge2");
		System.out.println(kel.edge2());
		System.out.println("\n-------- #edge3");
		System.out.println(kel.edge3());

		//System.out.println("\n-------- body.show()");
		//body.show().wireframePresentation();
		//return mel;
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunKELTestExamples();
	}
}
