package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunVertex;

/**
 * JunKEMLTestExamples class
 * 
 *  @author    bnr
 *  @created   1999/07/29 (by BNR)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKEMLTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunKEMLTestExamples extends JunTestExamples {
	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		System.out.println("JunKEMLTestExamples example1");

		JunBody body = new JunBody();
		JunMEVVL mevvl = new JunMEVVL(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();
		JunVertex vertex100 = mevvl.newVertex1();
		JunVertex vertex010 = mevvl.newVertex2();
		JunLoop loop1 = mevvl.loop();
		JunMEV mev = new JunMEV(body, vertex100, loop1, new Jun3dPoint(0, 0, 0));
		mev.doOperation();
		JunVertex vertex000 = mev.newVertex();
		JunMEL mel = new JunMEL(body, mev.loop(), vertex010, vertex000);
		mel.doOperation();
		JunMEVVL mevvl2 = new JunMEVVL(new JunBody(), new Jun3dPoint(1, 0, 1), new Jun3dPoint(0, 1, 1));
		mevvl2.doOperation();
		JunLoop loop2 = mevvl2.loop();
		JunVertex vertex101 = mevvl2.newVertex1();
		JunVertex vertex011 = mevvl2.newVertex2();
		mev = new JunMEV(body, vertex101, loop2, new Jun3dPoint(0, 0, 1));
		mev.doOperation();
		JunVertex vertex001 = mev.newVertex();
		mel = new JunMEL(body, mev.loop(), vertex011, vertex001);
		mel.doOperation();
		JunMEKL mekl = JunMEKL.Body_killLoop_aliveLoop_vertex_vertex_(body, loop1, loop2, vertex000, vertex001);
		mekl.doOperation();
		JunEdge edge = mekl.newEdge();
		JunKEML keml = new JunKEML(body, edge);
		keml.doOperation();

		// #(#killedEdge #originalLoop #newLoop #vertex1 
		// #vertex2 #edge2 #edge3)
		System.out.println("\n-------- #killedEdge");
		System.out.println(keml.killedEdge());
		System.out.println("-------- #originalLoop");
		System.out.println(keml.originalLoop());
		System.out.println("\n-------- #newLoop");
		System.out.println(keml.newLoop());
		System.out.println("-------- #vertex1");
		System.out.println(keml.vertex1());
		System.out.println("\n-------- #vertex2");
		System.out.println(keml.vertex2());
		System.out.println("-------- #edge2");
		System.out.println(keml.edge2());
		System.out.println("\n-------- #edge3");
		System.out.println(keml.edge3());

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunKEMLTestExamples();
	}
}
