package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunVertex;

/**
 * JunKVETestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunKVETestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunKVETestExamples extends JunTestExamples {
	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunBody body = new JunBody();
		JunMEVVL mevvl = new JunMEVVL(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(0, 0, 1));
		mevvl.doOperation();
		JunVertex v000 = mevvl.vertex1();
		JunVertex v001 = mevvl.vertex2();
		// JunEdge edge000001 = mevvl.edge();
		mevvl.edge();
		JunLoop loop1 = mevvl.loop();

		JunMEV mev1 = new JunMEV(body, v001, loop1, new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		JunVertex v010 = mev1.vertex1();
		JunEdge edge001010 = mev1.edge();

		JunMEV mev2 = new JunMEV(body, v010, loop1, new Jun3dPoint(1, 0, 0));
		mev2.doOperation();
		JunVertex v100 = mev2.vertex1();
		// JunEdge edge010100 = mev2.edge();
		mev2.edge();

		JunMEL mel = new JunMEL(body, loop1, v100, v000);
		mel.doOperation();
		// JunEdge edge100000 = mel.edge();
		mel.edge();
		// JunLoop loop2 = mel.loop1();
		mel.loop1();

		JunMVE mve = new JunMVE(body, edge001010, new Jun3dPoint(1, 1, 1));
		mve.doOperation();

		/*
		 for (int i = 0; i < 100; i++) {
		 JunKVE kve = (JunKVE) (mve.inverse());
		 kve.doOperation();
		 mve = (JunMVE) (kve.inverse());
		 mve.doOperation();
		 }
		 */

		for (int i = 0; i < 1; i++) {
			mve.undoOperation();
			mve.doOperation();
		}
		mve.body().show();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunKVETestExamples();
	}
}
