package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunLoop;
import jp.co.sra.jun.topology.elements.JunVertex;

/**
 * JunMCLKPLTestExamples class
 * 
 *  @author    bnr
 *  @created   1999/08/19 (by bnr)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMCLKPLTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMCLKPLTestExamples extends JunTestExamples {
	/**
	 * The example on JunMCLKPL.htm
	 * 
	 * @return boolean.
	 * @category Examples
	 */
	public static boolean Example1() {
		JunBody body = new JunBody();
		JunMEVVL mevvl = new JunMEVVL(body, new Jun3dPoint(1, 0, 0), new Jun3dPoint(0, 1, 0));
		mevvl.doOperation();

		JunLoop loop1 = mevvl.loop();
		JunVertex vertex100 = mevvl.newVertex1();
		JunVertex vertex010 = mevvl.newVertex2();

		JunMEV mev = new JunMEV(body, vertex100, loop1, new Jun3dPoint(0, 0, 0));
		mev.doOperation();

		JunVertex vertex000 = mev.newVertex();

		JunMEL mel = new JunMEL(body, loop1, vertex010, vertex000);
		mel.doOperation();

		mevvl = new JunMEVVL(body, new Jun3dPoint(1, 0, 1), new Jun3dPoint(0, 1, 1));
		mevvl.doOperation();

		JunLoop loop2 = mevvl.loop();
		JunVertex vertex101 = mevvl.newVertex1();
		JunVertex vertex011 = mevvl.newVertex2();

		mev = new JunMEV(body, vertex101, loop2, new Jun3dPoint(0, 0, 1));
		mev.doOperation();

		JunVertex vertex001 = mev.newVertex();

		mel = new JunMEL(body, loop2, vertex011, vertex001);
		mel.doOperation();

		JunMCLKPL mclkpl = new JunMCLKPL(body, loop1, loop2);
		mclkpl.doOperation();

		body.show();

		// JunMCLKPL MCLKPL = JunMCLKPL.Body_loop_(body, loop2);
		// MCLKPL.doOperation();
		// body.show();
		System.out.println("-------- #loop1");
		System.out.println(mclkpl.loop1());
		System.out.println("-------- #loop2");
		System.out.println(mclkpl.loop2());

		//
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunMCLKPLTestExamples();
	}
}
