package jp.co.sra.jun.topology.euleroperators;

import java.util.ArrayList;

import jp.co.sra.jun.topology.abstracts.JunAbstractOperator;
import jp.co.sra.jun.topology.abstracts.JunEulerOperator;
import jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunEdgeProxy;
import jp.co.sra.jun.topology.elements.JunVertex;
import jp.co.sra.jun.topology.elements.JunVertexProxy;

/**
 * JunMDEV class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   2008/05/23 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMDEV.java,v 9.9 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMDEV extends JunEulerOperator {

	protected JunEdgeProxy edgeProxy1;
	protected JunVertexProxy vertexProxy1;
	protected JunVertexProxy vertexProxy2;
	protected JunEdgeProxy edgeProxy2;
	protected JunEdgeProxy edgeProxy3;

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy3 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunMDEV
	 */
	public static final JunMDEV Body_vertex_edge_edge_(JunBody aBody, JunTopologicalElementOrProxy aJunVertexOrProxy, JunTopologicalElementOrProxy aJunEdgeOrProxy2, JunTopologicalElementOrProxy aJunEdgeOrProxy3) {
		JunMDEV anOperator;
		anOperator = new JunMDEV();
		anOperator.body_(aBody);
		anOperator.vertex2_(aJunVertexOrProxy);
		anOperator.edge2_(aJunEdgeOrProxy2);
		anOperator.edge3_(aJunEdgeOrProxy3);
		return anOperator;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy3 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunMDEV
	 */
	public static final JunMDEV Body_vertex_edge_edge_adviseEdge_vertex_(JunBody aJunBody, JunTopologicalElementOrProxy aJunVertexOrProxy, JunTopologicalElementOrProxy aJunEdgeOrProxy2, JunTopologicalElementOrProxy aJunEdgeOrProxy3,
			JunTopologicalElementOrProxy aJunEdgeOrProxy, JunTopologicalElementOrProxy aJunVertexOrProxy2) {
		JunMDEV anOperator;
		anOperator = new JunMDEV();
		anOperator.body_(aJunBody);
		anOperator.vertex2_(aJunVertexOrProxy);
		anOperator.edge2_(aJunEdgeOrProxy2);
		anOperator.edge3_(aJunEdgeOrProxy3);
		anOperator.vertex1_(aJunVertexOrProxy2);
		anOperator.edge1_(aJunEdgeOrProxy);
		return anOperator;
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 */
	public JunEdge edge1() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy1);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunEdgeOrProxy
	 *        jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void edge1_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy1 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy1);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 */
	public JunEdge edge2() {
		return (JunEdge) this.getTopologicalElement_(this.edgeProxy2);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void edge2_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy2 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy2);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 */
	public JunEdge edge3() {
		return (JunEdge) this.getTopologicalElement_(edgeProxy3);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void edge3_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy3 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy3);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 */
	public void execute() {
		ArrayList<JunEdge> v1Edges = new ArrayList<JunEdge>();
		ArrayList<JunEdge> v2Edges = new ArrayList<JunEdge>();
		this.vertex1_(JunVertex.Point_(this.vertex2().point()));
		this.edge1_(JunEdge.StartVertex_endVertex_(this.vertex1(), this.vertex2()));
		this.vertex1().edge_(this.edge1());
		v1Edges.add(this.edge2());
		JunEdge currentEdge = this.edge2();
		JunEdge targetEdge = this.edge3();
		JunEdge nextEdge = currentEdge.nextEdgeWithVertex_(this.vertex2());

		while (nextEdge != targetEdge) {
			currentEdge = nextEdge;
			v1Edges.add(currentEdge);
			nextEdge = currentEdge.nextEdgeWithVertex_(this.vertex2());
		}

		v2Edges.add(this.edge3());
		currentEdge = this.edge3();
		targetEdge = this.edge2();
		nextEdge = currentEdge.nextEdgeWithVertex_(this.vertex2());

		while (nextEdge != targetEdge) {
			currentEdge = nextEdge;
			v2Edges.add(currentEdge);
			nextEdge = currentEdge.nextEdgeWithVertex_(this.vertex2());
		}

		if ((v1Edges.size() + v2Edges.size()) != this.vertex2().numberOfEdges()) {
			this.error_("MDEV internal error.");
		}

		this.edge1().setLoop_fromVertex_(this.edge2().loopFromVertex_(this.vertex2()), this.vertex1());
		this.edge1().setLoop_fromVertex_(this.edge3().loopFromVertex_(this.vertex2()), this.vertex2());
		v1Edges.get(v1Edges.size() - 1).setNextEdge_withVertex_(this.edge1(), this.vertex2());
		this.edge1().setNextEdge_withVertex_(v2Edges.get(0), this.vertex2());
		v2Edges.get(v2Edges.size() - 1).setNextEdge_withVertex_(this.edge1(), this.vertex2());
		this.edge1().setNextEdge_withVertex_(v1Edges.get(0), this.vertex1());

		for (int i = 0; i < v1Edges.size(); i++) {
			JunEdge edge = v1Edges.get(i);
			edge.setVertex_insteadOf_(this.vertex1(), this.vertex2());
		}

		if (this.vertex2().edge().includesVertex_(this.vertex2()) == false) {
			this.vertex2().edge_(v2Edges.get(0));
		}

		this.body().addVertex_(this.vertex1());
		this.body().addEdge_(this.edge1());
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.abstracts.JunAbstractOperator
	 */
	public JunAbstractOperator inverse() {
		return new JunKDEV(this.body(), edgeProxy1, vertexProxy1, vertexProxy2, edgeProxy2, edgeProxy3);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 */
	public JunEdge newEdge() {
		return this.edge1();
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 */
	public JunVertex newVertex() {
		return this.vertex1();
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return boolean
	 */
	public boolean precondition() {
		if (this.vertex1() != null) {
			return false;
		}
		if (this.edge1() != null) {
			return false;
		}

		JunVertex vertex2 = this.vertex2();
		if (vertex2 == null) {
			return false;
		}

		JunEdge edge2 = this.edge2();
		if (edge2 == null) {
			return false;
		}

		JunEdge edge3 = this.edge3();
		if (edge3 == null) {
			return false;
		}

		return super.precondition() && edge2.includesVertex_(vertex2) && edge3.includesVertex_(vertex2);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 */
	public JunVertex vertex1() {
		return (JunVertex) this.getTopologicalElement_(vertexProxy1);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void vertex1_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy1 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy1);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 */
	public JunVertex vertex2() {
		return (JunVertex) this.getTopologicalElement_(vertexProxy2);
	}

	/**
	 * Please refer to the corresponding method in Smalltalk.
	 * 
	 * @param aJunVertexOrProxy
	 *        jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 */
	public void vertex2_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy2 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy2);
	}

}
