package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.*;

/**
 * JunMEKLTestExamples class
 * 
 *  @author    BNR, ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMEKLTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMEKLTestExamples extends JunTestExamples {
	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunBody body = new JunBody();
		JunMEVVL mevvl1 = new JunMEVVL(body, new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl1.doOperation();
		JunVertex v000 = mevvl1.vertex1();
		JunVertex v100 = mevvl1.vertex2();
		JunLoop loop0_0 = mevvl1.loop();
		JunMEV mev1 = new JunMEV(body, v100, loop0_0, new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		JunVertex v010 = mev1.newVertex();
		JunMEL mel1 = new JunMEL(body, loop0_0, v010, v000);
		mel1.doOperation();
		JunLoop loop0_1 = mel1.newLoop();
		JunMEVVL mevvl2 = new JunMEVVL(body, new Jun3dPoint(0, 0, 1), new Jun3dPoint(1, 0, 1));
		mevvl2.doOperation();
		JunVertex v001 = mevvl2.vertex1();
		JunVertex v101 = mevvl2.vertex2();
		JunLoop loop1_0 = mevvl2.loop();
		JunMEV mev2 = new JunMEV(body, v101, loop1_0, new Jun3dPoint(0, 1, 1));
		mev2.doOperation();
		JunVertex v011 = mev2.newVertex();
		JunMEL mel2 = new JunMEL(body, loop1_0, v011, v001);
		mel2.doOperation();
		JunMEKL mekl = new JunMEKL(body, loop0_1, loop1_0, v000, v001);
		mekl.doOperation();
		JunMEL mel3 = new JunMEL(body, mekl.aliveLoop(), v100, v101);
		mel3.doOperation();

		JunVertex[] tempVertex = mel3.loop2().vertexes();
		int i;
		for (i = 0; i < tempVertex.length; i++) {
			if (tempVertex[i] == v010) {
				new JunMEL(body, mel3.loop2(), v010, v011).doOperation();
				break;
			}
		}

		if (i == tempVertex.length) {
			new JunMEL(body, mel3.loop1(), v010, v011).doOperation();
		}

		body.show();

		//#?# mekl
		System.out.println("-------- #edge3");
		System.out.println(mekl.edge3());
		System.out.println("-------- #edge2");
		System.out.println(mekl.edge2());
		System.out.println("-------- #vertex2");
		System.out.println(mekl.vertex2());
		System.out.println("-------- #vertex1");
		System.out.println(mekl.vertex1());
		System.out.println("-------- #killedLoop");
		System.out.println(mekl.killedLoop());
		System.out.println("-------- #aliveLoop");
		System.out.println(mekl.aliveLoop());
		System.out.println("-------- #newEdge");
		System.out.println(mekl.newEdge());

		/*
		if (mel3.loop2().vertexes().includes_(v010)) {
			new JunMEL(body, mel3.loop2(), v010, v011).doOperation();
		} else {
			new JunMEL(body, mel3.loop1(), v010, v011).doOperation();
		}
		*/

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunMEKLTestExamples();
	}
}
