package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;

/**
 * JunMELTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMELTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMELTestExamples extends JunTestExamples {
	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunMEVVL mevvl = new JunMEVVL(new JunBody(), new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		JunMEL mel = new JunMEL(mevvl.body(), mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();

		//return mel;
		//#newEdge #newLoop #originalLoop #vertex1 #vertex2 #edge2 #edge3
		System.out.println("-------- #newEdge");
		System.out.println(mel.newEdge());
		System.out.println("\n-------- #newLoop");
		System.out.println(mel.newLoop());
		System.out.println("-------- #originalLoop");
		System.out.println(mel.originalLoop());
		System.out.println("-------- #vertex1");
		System.out.println(mel.vertex1());
		System.out.println("-------- #vertex2");
		System.out.println(mel.vertex2());
		System.out.println("-------- #edge2");
		System.out.println(mel.edge2());
		System.out.println("-------- #edge3");
		System.out.println(mel.edge3());

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunMELTestExamples();
	}
}
