package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;

/**
 * JunMEVTestExamples class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMEVTestExamples.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMEVTestExamples extends JunTestExamples {
	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunMEVVL mevvl;
		JunMEV mev;
		mevvl = new JunMEVVL(new JunBody(), new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		mev = new JunMEV(mevvl.body(), mevvl.vertex2(), mevvl.loop(), new Jun3dPoint(0, 1, 0));
		mev.doOperation();
		mev.body().show();

		//#?# mev
		System.out.println("-------- #point");
		System.out.println(mev.point());
		System.out.println("-------- #loop");
		System.out.println(mev.loop());
		System.out.println("-------- #vertex2");
		System.out.println(mev.vertex2());
		System.out.println("-------- #edge2");
		System.out.println(mev.edge2());
		System.out.println("-------- #newVertex");
		System.out.println(mev.newVertex());
		System.out.println("-------- #newEdge");
		System.out.println(mev.newEdge());

		//return mev;
		return true;
	}

	/**
	 * Example.
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunMEVVL mevvl = new JunMEVVL(new JunBody(), new Jun3dPoint(0, 0, 0), new Jun3dPoint(1, 0, 0));
		mevvl.doOperation();
		JunMEL mel = new JunMEL(mevvl.body(), mevvl.loop(), mevvl.vertex1(), mevvl.vertex2());
		mel.doOperation();
		JunMEV mev1 = new JunMEV(mevvl.body(), mevvl.vertex1(), mel.loop1(), new Jun3dPoint(0, 1, 0));
		mev1.doOperation();
		JunMEV mev2 = new JunMEV(mevvl.body(), mevvl.vertex2(), mel.loop2(), new Jun3dPoint(0, 0, 1));
		mev2.doOperation();
		mev2.body().show();

		//return mev2;
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunMEVTestExamples();
	}
}
