package jp.co.sra.jun.topology.euleroperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.topology.abstracts.JunAbstractOperator;
import jp.co.sra.jun.topology.abstracts.JunEulerOperator;
import jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy;
import jp.co.sra.jun.topology.elements.JunBody;
import jp.co.sra.jun.topology.elements.JunEdge;
import jp.co.sra.jun.topology.elements.JunEdgeProxy;
import jp.co.sra.jun.topology.elements.JunVertex;
import jp.co.sra.jun.topology.elements.JunVertexProxy;

/**
 * JunMVE class
 * 
 *  @author    ASTI Shanghai
 *  @created   UNKNOWN
 *  @updated   1999/08/04 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunMVE.java,v 9.8 2010/03/09 09:17:54 nisinaka Exp $
 */
public class JunMVE extends JunEulerOperator {
	protected JunVertexProxy vertexProxy;
	protected JunEdgeProxy edgeProxy1;
	protected JunEdgeProxy edgeProxy2;
	protected Jun3dPoint point;
	protected JunVertexProxy vertexProxy1;

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @return jp.co.sra.jun.topology.euleroperators.JunMVE
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunMVE Body_edge_point_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint) {
		return new JunMVE(aJunBody, aJunEdgeOrProxy, aJun3dPoint);
	}

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunMVE
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunMVE Body_edge_point_adviseVertex_edge_newEdgeOnVertex_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint, JunTopologicalElementOrProxy aJunVertexOrProxy,
			JunTopologicalElementOrProxy aJunEdgeOrProxy2, JunTopologicalElementOrProxy aJunVertexOrProxy1) {
		return new JunMVE(aJunBody, aJunEdgeOrProxy, aJun3dPoint, aJunVertexOrProxy, aJunEdgeOrProxy2, aJunVertexOrProxy1);
	}

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @return jp.co.sra.jun.topology.euleroperators.JunMVE
	 * @deprecated since Jun700, using constructor
	 * @category Instance creation
	 */
	public static final JunMVE Body_edge_point_newEdgeOnVertex_(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint, JunTopologicalElementOrProxy aJunVertexOrProxy) {
		return new JunMVE(aJunBody, aJunEdgeOrProxy, aJun3dPoint, aJunVertexOrProxy);
	}

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @category Instance creation
	 */
	public JunMVE(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint) {
		this(aJunBody, aJunEdgeOrProxy, aJun3dPoint, null, null, null);
	}

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunEdgeOrProxy2 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJunVertexOrProxy1 jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunMVE(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint, JunTopologicalElementOrProxy aJunVertexOrProxy, JunTopologicalElementOrProxy aJunEdgeOrProxy2, JunTopologicalElementOrProxy aJunVertexOrProxy1) {
		super();
		this.body_(aJunBody);
		this.edge1_(aJunEdgeOrProxy2);
		this.edge2_(aJunEdgeOrProxy);
		this.point_(aJun3dPoint);
		this.vertex_(aJunVertexOrProxy);
		this.vertex1_(aJunVertexOrProxy1);
	}

	/**
	 * Create a new instance of <code>JunMVE</code> and initialize it.
	 * 
	 * @param aJunBody jp.co.sra.jun.topology.elements.JunBody
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @param aJun3dPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category Instance creation
	 */
	public JunMVE(JunBody aJunBody, JunTopologicalElementOrProxy aJunEdgeOrProxy, Jun3dPoint aJun3dPoint, JunTopologicalElementOrProxy aJunVertexOrProxy) {
		this(aJunBody, aJunEdgeOrProxy, aJun3dPoint, null, null, aJunVertexOrProxy);
	}

	/**
	 * Initialize the receiver when created.
	 * 
	 * @see jp.co.sra.jun.system.framework.JunAbstractObject#initialize()
	 * @category initialize-release
	 */
	protected void initialize() {
		super.initialize();

		vertexProxy = null;
		edgeProxy1 = null;
		edgeProxy2 = null;
		point = null;
		vertexProxy1 = null;
	}

	/**
	 * Answer the receiver's edge1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge1() {
		return (JunEdge) this.getTopologicalElement_(edgeProxy1);
	}

	/**
	 * Set the receiver's edge1.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge1_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		edgeProxy1 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, edgeProxy1);
	}

	/**
	 * Answer the receiver's edge2.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge edge2() {
		return (JunEdge) this.getTopologicalElement_(edgeProxy2);
	}

	/**
	 * Set the receiver's edge2.
	 * 
	 * @param aJunEdgeOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void edge2_(JunTopologicalElementOrProxy aJunEdgeOrProxy) {
		this.edgeProxy2 = (JunEdgeProxy) this.getTopologicalElementProxy_advise_(aJunEdgeOrProxy, this.edgeProxy2);
	}

	/**
	 * Execute the operation.
	 * 
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#execute()
	 * @category executing
	 */
	public void execute() {
		JunEdge fromEdge1;
		this.vertex_(JunVertex.Point_(this.point()));
		this.vertex().edge_(this.edge2());
		this.edge1_((JunEdge) (this.edge2().copy()));

		if (this.vertex1() != this.edge2().endVertex()) {
			fromEdge1 = this.edge2().prevEdgeWithVertex_(this.edge2().startVertex());
			fromEdge1.setNextEdge_withVertex_(this.edge1(), this.edge2().startVertex());

			if (this.edge2().startVertex().edge() == this.edge2()) {
				this.edge2().startVertex().edge_(this.edge1());
			}

			this.edge1().endVertex_(this.vertex());
			this.edge2().startVertex_(this.vertex());
			this.edge1().endLeftEdge_(this.edge2());
			this.edge2().startRightEdge_(this.edge1());

			if (this.edge1().startRightEdge() == this.edge2()) {
				this.edge1().startRightEdge_(this.edge1());
			}
		} else {
			fromEdge1 = this.edge2().prevEdgeWithVertex_(this.edge2().endVertex());
			fromEdge1.setNextEdge_withVertex_(this.edge1(), this.edge2().endVertex());

			if (this.edge2().endVertex().edge() == this.edge2()) {
				this.edge2().endVertex().edge_(this.edge1());
			}

			this.edge1().startVertex_(this.vertex());
			this.edge2().endVertex_(this.vertex());
			this.edge1().startRightEdge_(this.edge2());
			this.edge2().endLeftEdge_(this.edge1());

			if (this.edge1().endLeftEdge() == this.edge2()) {
				this.edge1().endLeftEdge_(this.edge1());
			}
		}

		this.body().addVertex_(this.vertex());
		this.body().addEdge_(this.edge1());
	}

	/**
	 * Answer the inverse operation of the receiver.
	 * 
	 * @return jp.co.sra.jun.topology.abstracts.JunAbstractOperator
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#inverse()
	 * @category inverting
	 */
	public JunAbstractOperator inverse() {
		return new JunKVE(this.body(), vertexProxy, edgeProxy1, edgeProxy2);
	}

	/**
	 * Answer my new edge.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge newEdge() {
		return this.edge1();
	}

	/**
	 * Answer my new vertex.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex newVertex() {
		return this.vertex();
	}

	/**
	 * Answer my original edge.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunEdge
	 * @category accessing
	 */
	public JunEdge originalEdge() {
		return this.edge2();
	}

	/**
	 * Answer the receiver's point.
	 * 
	 * @return jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @category accessing
	 */
	public Jun3dPoint point() {
		return point;
	}

	/**
	 * Set the receiver's point.
	 * 
	 * @param aPoint jp.co.sra.jun.geometry.basic.Jun3dPoint
	 * @category accessing
	 */
	public void point_(Jun3dPoint aPoint) {
		point = aPoint;
	}

	/**
	 * Precondition to check before executing the operation.
	 * 
	 * @return boolean
	 * @see jp.co.sra.jun.topology.abstracts.JunAbstractOperator#precondition()
	 * @category executing
	 */
	public boolean precondition() {
		if (this.edge2() == null) {
			return false;
		} else {
			return super.precondition();
		}
	}

	/**
	 * Answer the receiver's vertex.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex() {
		return (JunVertex) this.getTopologicalElement_(this.vertexProxy);
	}

	/**
	 * Set the receiver's vertex.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, vertexProxy);
	}

	/**
	 * Answer the receiver's vertex1.
	 * 
	 * @return jp.co.sra.jun.topology.elements.JunVertex
	 * @category accessing
	 */
	public JunVertex vertex1() {
		return (JunVertex) this.getTopologicalElement_(this.vertexProxy1);
	}

	/**
	 * Set the receiver's vertex1.
	 * 
	 * @param aJunVertexOrProxy jp.co.sra.jun.topology.abstracts.JunTopologicalElementOrProxy
	 * @category accessing
	 */
	public void vertex1_(JunTopologicalElementOrProxy aJunVertexOrProxy) {
		vertexProxy1 = (JunVertexProxy) this.getTopologicalElementProxy_advise_(aJunVertexOrProxy, this.vertexProxy1);
	}
}
