package jp.co.sra.jun.topology.globaloperators;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.system.support.JunTestExamples;
import jp.co.sra.jun.topology.elements.JunBody;

/**
 * JunLineSCALETestExamples class
 * 
 *  @author    UNKNOWN
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunLineSCALETestExamples.java,v 9.9 2010/03/09 09:17:55 nisinaka Exp $
 */
public class JunLineSCALETestExamples extends JunTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		Jun3dPoint point1 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint point2 = new Jun3dPoint(1, 0, 0);
		Jun3dPoint point3 = new Jun3dPoint(0, 1, 0);
		Jun3dPoint point4 = new Jun3dPoint(0, 0, 1);
		Jun3dPoint vector = new Jun3dPoint(1, 0, 0);
		Jun3dPoint[] a3dPoint = new Jun3dPoint[4];
		a3dPoint[0] = point1;
		a3dPoint[1] = point2;
		a3dPoint[2] = point3;
		a3dPoint[3] = point4;
		JunBody body = JunBody.Tetrahedron_(a3dPoint);
		body.show();
		JunLineSCALE scale = new JunLineSCALE(body, point1, vector, 0.5d);
		scale.doOperation();
		scale.body().show();

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		Jun3dPoint point1 = new Jun3dPoint(0, 0, 0);
		Jun3dPoint point2 = new Jun3dPoint(1, 0, 0);
		Jun3dPoint point3 = new Jun3dPoint(0, 1, 0);
		Jun3dPoint point4 = new Jun3dPoint(0, 0, 1);
		Jun3dPoint vector = new Jun3dPoint(1, 0, 0);
		Jun3dPoint[] a3dPoint = new Jun3dPoint[4];
		a3dPoint[0] = point1;
		a3dPoint[1] = point2;
		a3dPoint[2] = point3;
		a3dPoint[3] = point4;
		JunBody body = JunBody.Tetrahedron_(a3dPoint);
		JunLineSCALE scale = new JunLineSCALE(body, point1, vector, 2.0d);
		body.show();
		scale.doOperation();
		body.show();
		scale.inverse().doOperation();
		body.show();

		return true;
	}

	/**
	 * Example3:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		System.out.println("\nJunLineSCALETestExamples Example3");

		Jun3dPoint point1 = new Jun3dPoint(10, 10, 10);
		Jun3dPoint point2 = new Jun3dPoint(11, 10, 10);
		Jun3dPoint point3 = new Jun3dPoint(10, 11, 10);
		Jun3dPoint point4 = new Jun3dPoint(10, 10, 11);
		Jun3dPoint vector = new Jun3dPoint(1, 0, 0);
		Jun3dPoint[] a3dPoint = new Jun3dPoint[4];
		a3dPoint[0] = point1;
		a3dPoint[1] = point2;
		a3dPoint[2] = point3;
		a3dPoint[3] = point4;
		JunBody body = JunBody.Tetrahedron_(a3dPoint);
		JunLineSCALE scale = new JunLineSCALE(body, point1, vector, 2.0d);
		body.show();
		scale.doOperation();
		body.show();
		scale.inverse().doOperation();
		body.show();
		System.out.println("-------- #vertexes");
		System.out.println(body.vertexes());

		//   ?? body.vertexes() does not work, just shows class name
		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args an array of command-line arguments
	 * @category Main
	 */
	public static void main(java.lang.String[] args) {
		new JunLineSCALETestExamples();
	}

}
