package jp.co.sra.jun.topology.graph;

import java.awt.Color;
import java.util.Map;

import jp.co.sra.smalltalk.StBlockClosure2;
import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunElementalArcSettingsTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2006/04/20 (by nisinaka)
 *  @updated   2008/05/26 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun593 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalArcSettingsTestExamples.java,v 9.9 2010/03/09 09:17:55 nisinaka Exp $
 */
public class JunElementalArcSettingsTestExamples extends JunTestExamples {

	/**
	 * Example0: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example0() {
		JunElementalArcSettings settings = new JunElementalArcSettings();
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalArc>() {
			public Void value(Map<StSymbol, Object> table, JunElementalArc stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Example1: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunElementalArc arc = new JunElementalArc();
		arc.lineColor_(Color.red);
		arc.lineWidth_(3);
		arc.firstBoxColor_(Color.green);
		arc.lastBoxColor_(Color.blue);
		arc.firstPointAlignment_($("leftCenter"));
		arc.lastPointAlignment_($("rightCenter"));

		JunElementalArcSettings settings = new JunElementalArcSettings(arc);
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalArc>() {
			public Void value(Map<StSymbol, Object> table, JunElementalArc stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new JunElementalArcSettingsTestExamples();
	}

}
