package jp.co.sra.jun.topology.graph;

import java.awt.Color;
import java.util.Map;

import jp.co.sra.smalltalk.StBlockClosure2;
import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunElementalGraphSettingsTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2006/04/20 (by nisinaka)
 *  @updated   2008/05/26 (b y nisinaka)
 *  @version   758 (with StPL9.7) based on Jun593 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalGraphSettingsTestExamples.java,v 9.9 2010/03/09 09:17:55 nisinaka Exp $
 */
public class JunElementalGraphSettingsTestExamples extends JunTestExamples {

	/**
	 * Example0: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example0() {
		JunElementalGraphSettings settings = new JunElementalGraphSettings();
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalGraph>() {
			public Void value(Map<StSymbol, Object> table, JunElementalGraph stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Example1: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunElementalGraph graph = new JunElementalGraph();
		graph.labelString_($String("Untitled"));
		graph.selectionBorderColor_(Color.blue);
		graph.selectionBorderWidth_(3);
		graph.arrangeFormat_($("forest"));
		graph.arrangeForestInterval_(100);
		graph.arrangeForestMargin_(5);

		JunElementalGraphSettings settings = new JunElementalGraphSettings(graph);
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalGraph>() {
			public Void value(Map<StSymbol, Object> table, JunElementalGraph stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunElementalGraphSettingsTestExamples();
	}

}
