package jp.co.sra.jun.topology.graph;

import java.awt.Color;
import java.awt.Point;
import java.util.Map;

import jp.co.sra.smalltalk.StBlockClosure2;
import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunElementalNodeSettingsTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2006/04/17 (by nisinaka)
 *  @updated   2008/05/26 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun593 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalNodeSettingsTestExamples.java,v 9.9 2010/03/09 09:17:55 nisinaka Exp $
 */
public class JunElementalNodeSettingsTestExamples extends JunTestExamples {

	/**
	 * Example0: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example0() {
		JunElementalNodeSettings settings = new JunElementalNodeSettings();
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalNode>() {
			public Void value(Map<StSymbol, Object> table, JunElementalNode stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Example1: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunElementalNode node = new JunElementalNode();
		node.labelString_($String("Untitled"));
		node.locationPoint_(new Point(100, 200));
		node.foregroundColor_(Color.red);
		node.backgroundColor_(Color.green);
		node.borderColor_(Color.blue);
		node.borderWidth_(3);

		JunElementalNodeSettings settings = new JunElementalNodeSettings(node);
		settings.compute_(new StBlockClosure2<Void, Map<StSymbol, Object>, JunElementalNode>() {
			public Void value(Map<StSymbol, Object> table, JunElementalNode stuff) {
				System.out.println(table.toString() + " " + stuff);
				return null;
			}
		});
		settings.open();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunElementalNodeSettingsTestExamples();
	}

}
