package jp.co.sra.jun.topology.graph;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;

import jp.co.sra.smalltalk.StColorValue;
import jp.co.sra.smalltalk.StImage;

import jp.co.sra.jun.system.support.JunTestExamples;

/**
 * JunElementalNodeTestExamples class
 * 
 *  @author    nisinaka
 *  @created   2006/04/05 (by nisinaka)
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on Jun597 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalNodeTestExamples.java,v 9.8 2010/03/09 09:17:55 nisinaka Exp $
 */
public class JunElementalNodeTestExamples extends JunTestExamples {

	/**
	 * Example1: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		JunElementalNode aNode = new JunElementalNode();
		System.out.println(aNode.printString());

		return true;
	}

	/**
	 * Example2: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		JunElementalNode aNode = new JunElementalNode("NISHINAKA Yoshiyuki");
		System.out.println(aNode.toLispList());

		return true;
	}

	/**
	 * Example3: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		JunElementalNode aNode = new JunElementalNode("ASADA Mitsuhiro");
		aNode.labelEmphasis_(true);
		aNode.borderColor_(Color.red);
		aNode.borderWidth_(2);
		aNode.backgroundColor_(StColorValue.LightYellow);
		aNode.foregroundColor_(Color.blue);
		aNode.visualObject()._display();

		return true;
	}

	/**
	 * Example4: 
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example4() {
		JunElementalNode firstNode = new JunElementalNode("ASADA Mitsuhiro");
		JunElementalNode lastNode = new JunElementalNode("NISHINAKA Yoshiyuki");
		JunElementalArc arcEdge = new JunElementalArc(firstNode, lastNode);

		int width = 450;
		int height = 300;
		StImage anImage = new StImage(width, height);
		Graphics aGraphics = null;
		try {
			firstNode.center_(new Point(width / 2 + 100, height / 2 + 50));
			lastNode.center_(new Point(width / 2 - 100, height / 2 - 50));

			aGraphics = anImage.image().getGraphics();
			firstNode.displayOn_(aGraphics);
			lastNode.displayOn_(aGraphics);
			arcEdge.displayOn_(aGraphics);

		} finally {
			if (aGraphics != null) {
				aGraphics.dispose();
			}
		}
		anImage._display();

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 */
	public static void main(String[] args) {
		new JunElementalNodeTestExamples();
	}

}
