package jp.co.sra.jun.topology.graph;

import jp.co.sra.jun.system.framework.JunAbstractViewJPanel;

/**
 * JunElementalStuffSettingsViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2006/04/17 (by nisinaka)
 *  @updated   2008/05/26 (by nisinaka)
 *  @version   758 (with StPL9.7) based on Jun598 for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunElementalStuffSettingsViewSwing.java,v 9.9 2010/03/09 09:17:56 nisinaka Exp $
 */
public abstract class JunElementalStuffSettingsViewSwing<E extends JunElementalStuff> extends JunAbstractViewJPanel implements JunElementalStuffSettingsView<E> {

	/**
	 * Create a new instance of JunElementalStuffSettingsViewSwing and initialize it.
	 *
	 * @param anElementalStuffSettings
	 * @category Instance creation
	 */
	public JunElementalStuffSettingsViewSwing(JunElementalStuffSettings<E> anElementalStuffSettings) {
		super(anElementalStuffSettings);
	}

	/**
	 * Answer my model as JunElementalStuffSettings.
	 * 
	 * @return jp.co.sra.jun.topology.graph.JunElementalStuffSettings
	 * @see jp.co.sra.jun.topology.graph.JunElementalStuffSettingsView#getElementalStuffSettings()
	 * @category model accessing
	 */
	@SuppressWarnings("unchecked")
	public JunElementalStuffSettings<E> getElementalStuffSettings() {
		return (JunElementalStuffSettings<E>) this.model();
	}

}
