package jp.co.sra.jun.vrml.field.abstracts;

import java.util.Collection;

import jp.co.sra.jun.system.framework.JunAbstractObject;

/**
 * JunVrmlField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlField.java,v 9.9 2010/03/09 09:17:59 nisinaka Exp $
 */
public abstract class JunVrmlField extends JunAbstractObject {

	/**
	 * A utility method to convert a collection to an array of primitive numbers.
	 * 
	 * @param aCollection java.util.Collection
	 * @return float[]
	 * @category Utilities
	 */
	public static float[] _ConvertToFloatArray(Collection<Number> aCollection) {
		float[] numbers = null;
		if (aCollection != null) {
			Number[] array = aCollection.toArray(new Number[aCollection.size()]);
			numbers = new float[array.length];
			for (int i = 0; i < numbers.length; i++) {
				numbers[i] = array[i].floatValue();
			}
		}
		return numbers;
	}

	/**
	 * A utility method to convert a collection to an array of primitive numbers.
	 * 
	 * @param aCollection java.util.Collection
	 * @return int[]
	 * @category Utilities
	 */
	public static int[] _ConvertToIntegerArray(Collection<Number> aCollection) {
		int[] numbers = null;
		if (aCollection != null) {
			Number[] array = aCollection.toArray(new Number[aCollection.size()]);
			numbers = new int[array.length];
			for (int i = 0; i < numbers.length; i++) {
				numbers[i] = array[i].intValue();
			}
		}
		return numbers;
	}

	/**
	 * A utility method to convert a collection to an array of primitive numbers.
	 * 
	 * @param aCollection java.util.Collection
	 * @return long[]
	 * @category Utilities
	 */
	public static long[] _ConvertToLongArray(Collection<Number> aCollection) {
		long[] numbers = null;
		if (aCollection != null) {
			Number[] array = aCollection.toArray(new Number[aCollection.size()]);
			numbers = new long[array.length];
			for (int i = 0; i < numbers.length; i++) {
				numbers[i] = array[i].longValue();
			}
		}
		return numbers;
	}

}
