package jp.co.sra.jun.vrml.field.mf;

import java.util.Collection;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlMFField;

/**
 * JunVrmlMFFloatField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlMFFloatField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlMFFloatField extends JunVrmlMFField {

	protected float[] value;

	/**
	 * Create a new instance of JunVrmlMFFloatField and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlMFFloatField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlMFFloatField and initialize it.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public JunVrmlMFFloatField(Collection<Number> aCollection) {
		this.value_(_ConvertToFloatArray(aCollection));
	}

	/**
	 * Create a JunVrmlMFFloatField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlMFFloatField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

}
