package jp.co.sra.jun.vrml.field.mf;

import java.util.Collection;

import jp.co.sra.smalltalk.SmalltalkException;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlMFField;

/**
 * JunVrmlMFStringField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlMFStringField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlMFStringField extends JunVrmlMFField {

	protected String[] value;

	/**
	 * Create a new instance of JunVrmlMFStringField and initialize it.
	 * 
	 * @param strings java.lang.String[]
	 */
	public JunVrmlMFStringField(String[] strings) {
		this.value_(strings);
	}

	/**
	 * Create a new instance of JunVrmlMFStringField and initialize it.
	 *
	 * @param aCollection java.util.Collection
	 * @category Instance creation
	 */
	public JunVrmlMFStringField(Collection<String> aCollection) {
		this(aCollection.toArray(new String[aCollection.size()]));
	}

	/**
	 * Create a new instance of JunVrmlMFStringField and initialize it.
	 *
	 * @param anObject java.lang.Object
	 * @category Instance creation
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlMFStringField(Object anObject) {
		if (anObject instanceof String) {
			this.value_(new String[] { (String) anObject });
		} else if (anObject instanceof Collection) {
			Collection<String> aCollection = (Collection<String>) anObject;
			this.value_(aCollection.toArray(new String[aCollection.size()]));
		} else {
			throw SmalltalkException.Error("invalid parameter - " + anObject);
		}
	}

	/**
	 * Answer my value.
	 * 
	 * @return java.lang.String[]
	 */
	public String[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param strings java.lang.String[]
	 */
	public void value_(String[] strings) {
		value = strings;
	}

}
