package jp.co.sra.jun.vrml.field.mf;

import java.util.Collection;

import jp.co.sra.jun.geometry.basic.Jun2dPoint;
import jp.co.sra.jun.vrml.field.abstracts.JunVrmlMFField;

/**
 * JunVrmlMFVec2fField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlMFVec2fField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlMFVec2fField extends JunVrmlMFField {

	protected float[] value;

	/**
	 * Create a new instance of JunVrmlMFVec2Field and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlMFVec2fField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlMFVec2fField and initialize it.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public JunVrmlMFVec2fField(Collection<Number> aCollection) {
		this.value_(_ConvertToFloatArray(aCollection));
	}

	/**
	 * Create a JunVrmlMFVec2fField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlMFVec2fField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Convert to an array of Jun2dPoint
	 * 
	 * @return jp.co.sra.jun.geometry.basic.Jun2dPoint[]
	 */
	public Jun2dPoint[] as2dPoints() {
		Jun2dPoint[] points = new Jun2dPoint[value.length / 2];
		for (int i = 0; i < value.length; i += 2) {
			points[i / 2] = new Jun2dPoint(value[i], value[i + 1]);
		}
		return points;
	}

}
