package jp.co.sra.jun.vrml.field.mf;

import java.util.Collection;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.vrml.field.abstracts.JunVrmlMFField;

/**
 * JunVrmlMFVec3fField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlMFVec3fField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlMFVec3fField extends JunVrmlMFField {

	protected float[] value;

	/**
	 * Create a new instance of JunVrmlMFVec3field and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlMFVec3fField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlMFVec3fField and initialize it.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public JunVrmlMFVec3fField(Collection<Number> aCollection) {
		this.value_(_ConvertToFloatArray(aCollection));
	}

	/**
	 * Create a JunVrmlMFVec3fField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlMFVec3fField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set the numbers as a value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Convert to an array of Jun3dPoint
	 * 
	 * @return jp.co.sra.jun.geometry.basic.Jun3dPoint[]
	 */
	public Jun3dPoint[] as3dPoints() {
		Jun3dPoint[] points = new Jun3dPoint[value.length / 3];
		for (int i = 0; i < value.length; i += 3) {
			points[i / 3] = new Jun3dPoint(value[i], value[i + 1], value[i + 2]);
		}
		return points;
	}

}
