package jp.co.sra.jun.vrml.field.sf;

import jp.co.sra.smalltalk.StSymbol;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFBoolField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFBoolField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlSFBoolField extends JunVrmlSFField {

	protected boolean value;

	/**
	 * Create a new instance of JunVrmlSFBoolField and initialize it.
	 * 
	 * @param booleanValue boolean
	 */
	public JunVrmlSFBoolField(boolean booleanValue) {
		this.value_(booleanValue);
	}

	/**
	 * Create a new instance of JunVrmlSFBoolField and initialize it.
	 * 
	 * @param aSymbol jp.co.sra.smalltalk.StSymbol
	 */
	public JunVrmlSFBoolField(StSymbol aSymbol) {
		this(aSymbol == $("TRUE"));
	}

	/**
	 * Create a JunVrmlSFBoolField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFBoolField(Object anObject) {
		this((StSymbol) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return boolean
	 */
	public boolean value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param booleanValue boolean
	 */
	public void value_(boolean booleanValue) {
		value = booleanValue;
	}

}
