package jp.co.sra.jun.vrml.field.sf;

import java.awt.Color;
import java.util.Collection;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFColorField class
 * 
 *  @author    nisinaka
 *  @created   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 1999-2005 Information-technology Promotion Agency, Japan (IPA)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFColorField.java,v 9.9 2010/03/09 09:18:00 nisinaka Exp $
 */
public class JunVrmlSFColorField extends JunVrmlSFField {

	protected float[] value;

	/**
	 * Create a new instance of JunVrmlSFColorField and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlSFColorField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlSFColorField and initialize it.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public JunVrmlSFColorField(Collection<Number> aCollection) {
		this.value_(_ConvertToFloatArray(aCollection));
	}

	/**
	 * Create a JunVrmlSFColorField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlSFColorField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Convert to a Color.
	 * 
	 * @return java.awt.Color
	 */
	public Color asColor() {
		return new Color(value[0], value[1], value[2]);
	}

}
