package jp.co.sra.jun.vrml.field.sf;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFFloatField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFFloatField.java,v 9.9 2010/03/09 09:18:01 nisinaka Exp $
 */
public class JunVrmlSFFloatField extends JunVrmlSFField {

	protected float value;

	/**
	 * Create a new instance of JunVrmlSFFloatField and initialize it.
	 * 
	 * @param number float
	 */
	public JunVrmlSFFloatField(float number) {
		this.value_(number);
	}

	/**
	 * Create a JunVrmlSFBoolField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFFloatField(Object anObject) {
		this(((Number) anObject).floatValue());
	}

	/**
	 * Answer my value.
	 * 
	 * @return float
	 */
	public float value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param floatValue float
	 */
	public void value_(float floatValue) {
		value = floatValue;
	}

}
