package jp.co.sra.jun.vrml.field.sf;

import java.awt.Image;
import java.awt.image.BufferedImage;
import java.util.Collection;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFImageField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/04/14 (by nisinaka)
 *  @updated   2004/12/03 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFImageField.java,v 9.9 2010/03/09 09:18:01 nisinaka Exp $
 */
public class JunVrmlSFImageField extends JunVrmlSFField {

	protected int[] value;

	/**
	 * Create a new instance of JunVrmlSFImageField and initialize it.
	 * 
	 * @param numbers int[]
	 */
	public JunVrmlSFImageField(int[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlSFImageField and initialize it.
	 * 
	 * @param aVector java.utilVector
	 */
	public JunVrmlSFImageField(Collection<Number> aCollection) {
		this(_ConvertToIntegerArray(aCollection));
	}

	/**
	 * Create a JunVrmlSFImageField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlSFImageField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return int[]
	 */
	public int[] value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param numbers int[]
	 */
	public void value_(int[] numbers) {
		value = numbers;
	}

	/**
	 * Convert to an Image.
	 * 
	 * @return java.awt.Image
	 */
	public Image asImage() {
		int type = value[2];
		if (type == 0) {
			return null;
		}
		if (type != 3) {
			this.error_("The type of image is not supported");
			return null;
		}

		int width = value[0];
		int height = value[1];
		BufferedImage image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
		for (int y = 0; y < height; y++) {
			for (int x = 0; x < width; x++) {
				int i = (height - y - 1) * width + x + 3;
				image.setRGB(x, y, value[i]);
			}
		}
		return image;
	}

}
