package jp.co.sra.jun.vrml.field.sf;

import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFStringField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFStringField.java,v 9.9 2010/03/09 09:18:01 nisinaka Exp $
 */
public class JunVrmlSFStringField extends JunVrmlSFField {

	protected String value;

	/**
	 * Create a new instance of JunVrmlSFStringField and initialize it.
	 * 
	 * @param aString java.lang.String
	 */
	public JunVrmlSFStringField(String aString) {
		this.value_(aString);
	}

	/**
	 * Create a JunVrmlSFStringField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	public JunVrmlSFStringField(Object anObject) {
		this((String) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return java.lang.String
	 */
	public String value() {
		return value;
	}

	/**
	 * Set my value.
	 * 
	 * @param aString java.lang.String
	 */
	public void value_(String aString) {
		value = aString;
	}

}
