package jp.co.sra.jun.vrml.field.sf;

import java.util.Collection;

import jp.co.sra.jun.geometry.basic.Jun3dPoint;
import jp.co.sra.jun.vrml.field.abstracts.JunVrmlSFField;

/**
 * JunVrmlSFVec3fField class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/17 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSFVec3fField.java,v 9.9 2010/03/09 09:18:01 nisinaka Exp $
 */
public class JunVrmlSFVec3fField extends JunVrmlSFField {

	protected float[] value;

	/**
	 * Create a new instance of JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param numbers float[]
	 */
	public JunVrmlSFVec3fField(float[] numbers) {
		this.value_(numbers);
	}

	/**
	 * Create a JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public JunVrmlSFVec3fField(Collection<Number> aCollection) {
		this.value_(_ConvertToFloatArray(aCollection));
	}

	/**
	 * Create a JunVrmlSFVec3fField and initialize it.
	 * 
	 * @param anObject java.lang.Object
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlSFVec3fField(Object anObject) {
		this((Collection<Number>) anObject);
	}

	/**
	 * Answer my value.
	 * 
	 * @return float[]
	 */
	public float[] value() {
		return value;
	}

	/**
	 * Set the numbers as a value.
	 * 
	 * @param numbers float[]
	 */
	public void value_(float[] numbers) {
		value = numbers;
	}

	/**
	 * Convert the value to a Jun3dPoint.
	 * 
	 * @return jp.co.sra.jun.geometry.basic.Jun3dPoint
	 */
	public Jun3dPoint as3dPoint() {
		return new Jun3dPoint(value[0], value[1], value[2]);
	}

}
