package jp.co.sra.jun.vrml.node.abstracts;

import jp.co.sra.jun.opengl.objects.JunOpenGL3dObject;
import jp.co.sra.jun.vrml.support.JunVrmlNodeVisitor;

/**
 * JunVrmlAbstractPropertyNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlAbstractPropertyNode.java,v 9.9 2010/03/09 09:18:01 nisinaka Exp $
 */
public abstract class JunVrmlAbstractPropertyNode extends JunVrmlNode {

	/**
	 * Answer true if the receiver is a property node, otherwise false.
	 * 
	 * @return boolean
	 */
	public boolean isPropertyNode() {
		return true;
	}

	/**
	 * Process myself with the generator.
	 * 
	 * @param aVisitor jp.co.sra.jun.vrml.support.JunVrmlNodeVisitor
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		aVisitor.doGeneralProperty_(this);
	}

	/**
	 * Set my properties on the JunOpenGL3dObject.
	 * 
	 * @param a3dObject jp.co.sra.jun.opengl.objects.JunOpenGL3dObject
	 */
	public abstract void propertyOn_(JunOpenGL3dObject a3dObject);

}
