package jp.co.sra.jun.vrml.node.grouping10;

import java.util.Collection;
import java.util.Vector;

import jp.co.sra.jun.vrml.node.abstracts.JunVrmlAbstractGroupingNode;
import jp.co.sra.jun.vrml.node.abstracts.JunVrmlNode;
import jp.co.sra.jun.vrml.support.JunVrmlNodeVisitor;

/**
 * JunVrmlSeparatorNode class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   2000/03/27 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlSeparatorNode.java,v 9.9 2010/03/09 09:18:02 nisinaka Exp $
 */
public class JunVrmlSeparatorNode extends JunVrmlAbstractGroupingNode {

	protected JunVrmlNode[] nodes;

	/**
	 * Create a new instance of JunVrmlSeparatorNode and initialize it.
	 * 
	 * @param aCollectionOfNodes java.util.Collection
	 */
	public JunVrmlSeparatorNode(Collection<JunVrmlNode> aCollectionOfNodes) {
		this.nodes_(aCollectionOfNodes);
	}

	/**
	 * Create a new instance of JunVrmlSeparatorNode and initialize it.
	 * 
	 * @param aCollectionOfNodes java.util.Collection
	 */
	@SuppressWarnings("unchecked")
	public JunVrmlSeparatorNode(Vector<?> aCollectionOfNodes) {
		this((Collection<JunVrmlNode>) aCollectionOfNodes);
	}

	/**
	 * Process myself with the generator.
	 * 
	 * @param aVisitor jp.co.sra.jun.vrml.support.JunVrmlNodeVisitor
	 */
	public void nodeDo_(JunVrmlNodeVisitor aVisitor) {
		try {
			aVisitor.perform_with_("doSeparator_", this);
		} catch (Exception e) {
			super.nodeDo_(aVisitor);
		}
	}

	/**
	 * Answer the nodes.
	 * 
	 * @return jp.co.sra.jun.vrml.node.abstracts.JunVrmlNode[]
	 */
	public JunVrmlNode[] nodes() {
		return nodes;
	}

	/**
	 * Set the nodes.
	 * 
	 * @param aCollection java.util.Collection
	 */
	public void nodes_(Collection<JunVrmlNode> aCollection) {
		nodes = aCollection.toArray(new JunVrmlNode[aCollection.size()]);
	}

}
