package jp.co.sra.jun.vrml.support;

import jp.co.sra.smalltalk.StObject;
import jp.co.sra.smalltalk.StSymbol;

/**
 * JunVrmlKeywordTable class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   1999/06/22 (by nisinaka)
 *  @updated   2008/05/28 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlKeywordTable.java,v 9.9 2010/03/09 09:18:05 nisinaka Exp $
 */
public class JunVrmlKeywordTable extends StObject {

	/** The keyword table. */
	protected StSymbol[] table = null;

	/**
	 * Create a new JunVrmlKeywordTable.
	 */
	public JunVrmlKeywordTable() {
		this(0);
	}

	/**
	 * Create a new JunVrmlKeywordTable.
	 * 
	 * @param nSize int
	 */
	public JunVrmlKeywordTable(int nSize) {
		table = new StSymbol[nSize];
	}

	/**
	 * Answer the keyword table.
	 * 
	 * @return jp.co.sra.jun.vrml.support.JunVrmlKeywordTable
	 */
	public static JunVrmlKeywordTable KeywordTable() {
		return null;
	}

	/**
	 * Answer the object at the specified place.
	 * 
	 * @param index int
	 * @return java.lang.Object
	 */
	public Object at(int index) {
		return table[index];
	}

	/**
	 * Answer true if the table contains the symbol as a key.
	 * 
	 * @param aSymbol jp.co.sra.smalltalk.StSymbol
	 * @return boolean
	 */
	public boolean hasSymbol_(StSymbol aSymbol) {
		for (int i = 0; i < table.length; i++) {
			if (table[i] == aSymbol) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Put the object at the specified place.
	 * This is a replacement of the smalltalk method 'at:put:'.
	 * 
	 * @param index int
	 * @param aSymbol jp.co.sra.smalltalk.StSymbol
	 */
	public void put(int index, StSymbol aSymbol) {
		table[index] = aSymbol;
	}

	/**
	 * Answer the size of the table.
	 * 
	 * @return int
	 */
	public int size() {
		return table.length;
	}

}
