package jp.co.sra.jun.vrml.support;

import jp.co.sra.jun.system.framework.JunAbstractObject;
import jp.co.sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode;
import jp.co.sra.jun.vrml.node.abstracts.JunVrmlAbstractPropertyNode;
import jp.co.sra.jun.vrml.node.abstracts.JunVrmlNode;

/**
 * JunVrmlNodeVisitor class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   N/A
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlNodeVisitor.java,v 9.9 2010/03/09 09:18:05 nisinaka Exp $
 */
public abstract class JunVrmlNodeVisitor extends JunAbstractObject {

	/**
	 * Process the geometry node.
	 * 
	 * @param aNode jp.co.sra.jun.vrml.node.abstracts.JunVrmlAbstractGeometryNode
	 */
	public void doGeneralGeometry_(JunVrmlAbstractGeometryNode aNode) {
		// Do nothing as a default.
	}

	/**
	 * Process the property node.
	 * 
	 * @param aNode jp.co.sra.jun.vrml.node.abstracts.JunVrmlAbstractPropertyNode
	 */
	public void doGeneralProperty_(JunVrmlAbstractPropertyNode aNode) {
		// Do nothing as a default.
	}

	/**
	 * Process the geometry node.
	 * 
	 * @param aNode jp.co.sra.jun.vrml.node.abstracts.JunVrmlNode
	 */
	public void doWorldInfo_(JunVrmlNode aNode) {
		// Do nothing as a default.
	}

}
