package jp.co.sra.jun.vrml.support;

/**
 * JunVrmlScannerTable20 class
 * 
 *  @author    ASTI Beijing
 *  @created   UNKNOWN
 *  @updated   1999/06/22 (by nisinaka)
 *  @version   758 (with StPL9.7) based on JunXXX for Smalltalk
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: JunVrmlScannerTable20.java,v 9.9 2010/03/09 09:18:05 nisinaka Exp $
 */
public class JunVrmlScannerTable20 extends JunVrmlScannerTable {

	/** The scanner table for VRML2.0. */
	protected static JunVrmlScannerTable scanningTable = null;

	static {
		Initialize();
	}

	/**
	 * Create a new instance of JunVrmlScannerTable20.
	 * 
	 * @param nSize int
	 */
	public JunVrmlScannerTable20(int nSize) {
		super(nSize);
	}

	/**
	 * Initialize the scanner table.
	 */
	public static void Initialize() {
		JunVrmlScannerTable20 newTable = new JunVrmlScannerTable20(256);

		for (int i = 0; i < 256; i++) {
			newTable.put(i, $("xBinary"));
		}

		newTable.put(9, $("xDelimiter"));
		newTable.put(10, $("xDelimiter"));
		newTable.put(13, $("xDelimiter"));
		newTable.put(32, $("xDelimiter"));

		for (int i = '0'; i <= '9'; i++) {
			newTable.put(i, $("xDigit"));
		}

		for (int i = 'a'; i <= 'z'; i++) {
			newTable.put(i, $("xSymbol"));
		}

		for (int i = 'A'; i <= 'Z'; i++) {
			newTable.put(i, $("xSymbol"));
		}

		for (int i = 128; i < 256; i++) {
			newTable.put(i, $("xSymbol"));
		}

		newTable.put('\'', $("quote"));
		newTable.put('"', $("xDoubleQuote"));
		newTable.put('#', $("xComment"));
		newTable.put('[', $("leftBracket"));
		newTable.put(']', $("rightBracket"));
		newTable.put('{', $("leftBrace"));
		newTable.put('}', $("rightBrace"));
		newTable.put('+', $("xSign"));
		newTable.put('-', $("xSign"));
		newTable.put('<', $("xSymbol"));
		newTable.put('>', $("xSymbol"));
		newTable.put('=', $("xSymbol"));
		newTable.put('~', $("xSymbol"));
		newTable.put('*', $("xSymbol"));
		newTable.put('/', $("xSymbol"));
		newTable.put('_', $("xSymbol"));
		newTable.put(':', $("xSymbol"));
		newTable.put('%', $("xSymbol"));
		newTable.put('(', $("xSymbol"));
		newTable.put(')', $("xSymbol"));
		newTable.put('!', $("xSymbol"));
		newTable.put(',', $("xDelimiter"));
		newTable.put('.', $("period"));
		newTable.put('`', $("quote"));
		newTable.put(EndChar, $("eof"));
		scanningTable = newTable;
	}

	/**
	 * Answer the scanner table.
	 * 
	 * @return jp.co.sra.jun.vrml.support.JunVrmlScannerTable
	 */
	public static JunVrmlScannerTable ScannerTable() {
		return scanningTable;
	}

}
