package jp.co.sra.smalltalk;

/**
 * StBlockValued interface
 * 
 *  @author    nisinaka
 *  @created   2003/03/07 (by nisinaka)
 *  @updated   2008/04/22 (by nisinaka)
 *  @version   9.7
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StBlockValued.java,v 9.8 2010/03/09 09:18:06 nisinaka Exp $
 */
public interface StBlockValued<V> extends StValued<V> {

	/**
	 * Add the dependent listener as my dependent.
	 *
	 * @param aDependentListener jp.co.sra.smalltalk.DependentListener
	 * @category dependents access
	 */
	public void addDependent_(DependentListener aDependentListener);

	/**
	 * Add the dependent listener as my dependent.
	 * 
	 * @param aDependentListener jp.co.sra.smalltalk.DependentListener
	 * @category dependents access
	 */
	public void addDependentListener(DependentListener aDependentListener);

	/**
	 * Remove the dependent listener from the receiver's dependents.
	 * 
	 * @param aDependentListener jp.co.sra.smalltalk.DependentListener
	 * @category dependents access
	 */
	public void removeDependentListener(DependentListener aDependentListener);

}
