package jp.co.sra.smalltalk;

/**
 * StIntervalTestExamples class
 * 
 *  @author    NISHIHARA Satoshi
 *  @created   2000/01/13 (by NISHIHARA Satoshi)
 *  @updated   2008/04/23 (by nisinaka)
 *  @version   9.7
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StIntervalTestExamples.java,v 9.8 2010/03/09 09:18:07 nisinaka Exp $
 */
public class StIntervalTestExamples extends SmalltalkTestExamples {

	/**
	 * Example1:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example1() {
		StInterval interval = StInterval.From_to_by_(0, 10, 1);
		System.out.println("interval: " + interval);
		System.out.println("first: " + interval.first());
		System.out.println("last: " + interval.last());
		System.out.println("increment: " + interval.increment());
		System.out.println("size: " + interval.size());
		System.out.println("at_(4): " + interval.at_(4));

		StBlockClosure1<Object, Double> block = new StBlockClosure1<Object, Double>() {
			public Object value(Double value) {
				System.out.println(value);
				return null;
			}
		};
		StBlockClosure1<Double, Double> collectBlock = new StBlockClosure1<Double, Double>() {
			public Double value(Double value) {
				return value * 5;
			}
		};

		interval.do_(block);
		interval.reverseDo_(block);

		double[] collect = interval.collect_(collectBlock);
		for (int i = 0; i < collect.length; i++) {
			System.out.println(i + ": " + collect[i]);
		}

		return true;
	}

	/**
	 * Example2:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example2() {
		StInterval interval = new StInterval(0, 10);
		System.out.println("interval: " + interval);
		System.out.println("first: " + interval.first());
		System.out.println("last: " + interval.last());
		System.out.println("increment: " + interval.increment());
		System.out.println("size: " + interval.size());
		System.out.println("at_(4): " + interval.at_(4));

		StBlockClosure1<Object, Double> block = new StBlockClosure1<Object, Double>() {
			public Object value(Double value) {
				System.out.println(value);
				return null;
			}
		};
		StBlockClosure1<Double, Double> collectBlock = new StBlockClosure1<Double, Double>() {
			public Double value(Double value) {
				return value * 5;
			}
		};

		interval.do_(block);
		interval.reverseDo_(block);

		double[] collect = interval.collect_(collectBlock);
		for (int i = 0; i < collect.length; i++) {
			System.out.println(i + ": " + collect[i]);
		}

		return true;
	}

	/**
	 * Example3:
	 * 
	 * @return boolean
	 * @category Examples
	 */
	public static boolean Example3() {
		StInterval interval = new StInterval(20, 10, -0.5);
		System.out.println("interval: " + interval);
		System.out.println("first: " + interval.first());
		System.out.println("last: " + interval.last());
		System.out.println("increment: " + interval.increment());
		System.out.println("size: " + interval.size());
		System.out.println("at_(4): " + interval.at_(4));
		System.out.println("at_(interval.size() - 1): " + interval.at_(interval.size() - 1));

		StBlockClosure1<Object, Double> block = new StBlockClosure1<Object, Double>() {
			public Object value(Double value) {
				System.out.println(value);
				return null;
			}
		};
		StBlockClosure1<Double, Double> collectBlock = new StBlockClosure1<Double, Double>() {
			public Double value(Double value) {
				return value * 5;
			}
		};

		interval.do_(block);
		interval.reverseDo_(block);

		double[] collect = interval.collect_(collectBlock);
		for (int i = 0; i < collect.length; i++) {
			System.out.println(i + ": " + collect[i]);
		}

		return true;
	}

	/**
	 * Execute all examples.
	 * 
	 * @param args java.lang.String[]
	 * @category Main
	 */
	public static void main(String[] args) {
		new StIntervalTestExamples();
	}

}
