package jp.co.sra.smalltalk.menu;

import javax.swing.JComponent;
import javax.swing.JPopupMenu;

/**
 * StPopupMenuViewSwing class
 * 
 *  @author    nisinaka
 *  @created   2005/02/18 (by nisinaka)
 *  @updated   N/A
 *  @version   9.7
 *  @copyright 1999-2010 SRA (Software Research Associates, Inc.)
 *  @copyright 2001-2010 SRA/KTL (SRA Key Technology Laboratory, Inc.)
 * 
 * $Id: StPopupMenuViewSwing.java,v 9.7 2010/03/09 09:18:08 nisinaka Exp $
 */
public class StPopupMenuViewSwing extends StMenuViewSwing implements StPopupMenuView {

	/**
	 * Create a new instance of StPopupMenuViewSwing and initialize it.
	 *
	 * @param aPopupMenu jp.co.sra.smalltalk.menu.StPopupMenu
	 * @category Instance creation
	 */
	public StPopupMenuViewSwing(StPopupMenu aPopupMenu) {
		super(aPopupMenu);
	}

	/**
	 * Answer my popup menu.
	 * 
	 * @return jp.co.sra.smalltalk.menu.StPopupMenu
	 * @see jp.co.sra.smalltalk.menu.StPopupMenuView#getPopupMenu()
	 * @category model accessing
	 */
	public StPopupMenu getPopupMenu() {
		return (StPopupMenu) this.getMenuItem();
	}

	/**
	 * Answer the menu item view as JPopupMenu.
	 * 
	 * @return javax.swing.JPopupMenu
	 * @category converting
	 */
	public JPopupMenu toPopupMenu() {
		return (JPopupMenu) this.menuItemView();
	}

	/**
	 * Update the enabled of the menu item view.
	 * 
	 * @see jp.co.sra.smalltalk.menu.StMenuItemViewAwt#updateEnabled()
	 * @category updating
	 */
	protected void updateEnabled() {
		// nothing to do
	}

	/**
	 * Update the label of the menu item view.
	 * 
	 * @see jp.co.sra.smalltalk.menu.StMenuItemViewAwt#updateLabel()
	 * @category updating
	 */
	protected void updateLabel() {
		// nothing to do
	}

	/**
	 * Update the label image of the menu item view.
	 * 
	 * @see jp.co.sra.smalltalk.menu.StMenuItemViewSwing#updateLabelImage()
	 * @category updating
	 */
	protected void updateLabelImage() {
		// nothing to do
	}

	/**
	 * Create a menu item view.
	 * 
	 * @return java.awt.MenuComponent
	 * @see jp.co.sra.smalltalk.menu.StMenuItemViewAwt#createMenuItemView()
	 * @category private
	 */
	protected JComponent createMenuItemView() {
		JPopupMenu aPopupMenu = new JPopupMenu() {
			public void addNotify() {
				super.addNotify();
				initializeWithWindow();
			}
		};

		StMenuItem[] items = this.getMenu().menuItems();
		for (int i = 0; i < items.length; i++) {
			if (items[i] == StMenu.Separator) {
				aPopupMenu.addSeparator();
			} else {
				StMenuItemViewSwing aMenuItemView = _New(items[i]);
				menuItemViews.add(aMenuItemView);
				aPopupMenu.add(aMenuItemView.toMenuItem());
			}
		}

		return aPopupMenu;
	}

}